///****************************************************************************
//// Name:        DFTTSSampleJava with DFTTS Desktop SDK v 3.5.0
//// Purpose:
//// Author:      Digital Future
//// Modified by:
//// Created:     06/10/2008, updated 07/23/2008
//// RCS-ID:
//// Copyright:   (C) Digital Future 2008. All rights reserved.
//// License:     see license document
//***************************************************************************/


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class Frame1 extends JFrame {
	
 
    
    private JNILayer JNILayer;

    
	public Frame1() {
		
		JNILayer = new JNILayer();
		
		JNILayer.setFrame(this);
		
		//Initialize the SDK
		
		int[] iLoadedEngines;	
		
	    int[] iLoadedEnginesReturnValues;
		
		iLoadedEngines = new int[NUM_ENGINE_INITIALIZATIONS];
		
		iLoadedEnginesReturnValues = new int[NUM_ENGINE_INITIALIZATIONS];
		
		String[] sNeoSpeechDBFolderPaths;
		
		sNeoSpeechDBFolderPaths = new String[NEOSPEECH_NUM_VOICES];
		
		String[] szNeoSpeechLicFilePaths;
		
		szNeoSpeechLicFilePaths = new String[NEOSPEECH_NUM_VOICES];
		
		
		for( int i = 0; i<NUM_ENGINE_INITIALIZATIONS-1; i++ )
		{
			
			iLoadedEngines[i] = 0;
			iLoadedEnginesReturnValues[i] = 0;
			
			 if( i < NEOSPEECH_NUM_VOICES)
			 {
				 if( i == 1 ) //Paul (Windows only) - Change your paths accordingly!
				 {
					 sNeoSpeechDBFolderPaths[i]="C:\\Program Files\\VW\\VT\\Paul\\M16";
					 
					 szNeoSpeechLicFilePaths[i]="C:\\Program Files\\VW\\VT\\Paul\\M16\\data-common\\verify\\verification.txt";				 
					 
				 }
				 else
				 {
					 sNeoSpeechDBFolderPaths[i]="";
				 
					 szNeoSpeechLicFilePaths[i]="";
				 }
			 }
		}
		 
		JNILayer.InitDFTTSEngineEx3(0,
				sNeoSpeechDBFolderPaths[0], //Kate
				sNeoSpeechDBFolderPaths[1], //Paul 
				sNeoSpeechDBFolderPaths[2], //Miyu
				sNeoSpeechDBFolderPaths[3], //Show 
				sNeoSpeechDBFolderPaths[4], //Misaki
				sNeoSpeechDBFolderPaths[5], //Lily 
				sNeoSpeechDBFolderPaths[6], //Wang 
				sNeoSpeechDBFolderPaths[7],	//Junwoo
				sNeoSpeechDBFolderPaths[8], //Sujin 
				sNeoSpeechDBFolderPaths[9], //Yumi
				sNeoSpeechDBFolderPaths[10], //Gyuri
				sNeoSpeechDBFolderPaths[11], //Dayoung
				szNeoSpeechLicFilePaths[0], //Kate
				szNeoSpeechLicFilePaths[1], //Paul 
				szNeoSpeechLicFilePaths[2], //Miyu
				szNeoSpeechLicFilePaths[3], //Show 
				szNeoSpeechLicFilePaths[4], //Misaki
				szNeoSpeechLicFilePaths[5], //Lily 
				szNeoSpeechLicFilePaths[6], //Wang 
				szNeoSpeechLicFilePaths[7],	//Junwoo
				szNeoSpeechLicFilePaths[8], //Sujin 
				szNeoSpeechLicFilePaths[9], //Yumi
				szNeoSpeechLicFilePaths[10], //Gyuri
				szNeoSpeechLicFilePaths[11], //Dayoung
	            iLoadedEngines,
	            iLoadedEnginesReturnValues
	    );
		
		
        /*Catch load errors */

        String sEngineName = "";
        int result = 0;

        String[] sNeospVoiceNames = {
            NEOSPEECH_KATE_ENG_NAMESTR,
            NEOSPEECH_PAUL_ENG_NAMESTR,
            NEOSPEECH_MIYU_JPN_NAMESTR,
            NEOSPEECH_SHOW_JPN_NAMESTR,
            NEOSPEECH_MISAKI_JPN_NAMESTR,
            NEOSPEECH_LILY_CHI_NAMESTR,
            NEOSPEECH_WANG_CHI_NAMESTR,
            NEOSPEECH_JUNWOO_KOR_NAMESTR,
            NEOSPEECH_SUJIN_KOR_NAMESTR,
            NEOSPEECH_YUMI_KOR_NAMESTR,
            NEOSPEECH_GYURI_KOR_NAMESTR,
            NEOSPEECH_DAYOUNG_KOR_NAMESTR
        };

        for (int intI = 0; intI <= iLoadedEngines.length- 1; intI++)
        {

          

            if (iLoadedEngines[intI] == NEOSPEECHVOICETEXT)
            {

                sEngineName = "NEOPSEECHVOICETEXT Engine Load Result for voice " + 
                    sNeospVoiceNames[intI] + ": ";

            }
            else if (iLoadedEngines[intI] == CEPSTRAL)
            {

                sEngineName = "CEPSTRAL Engine Load Result: ";

            }
            else if (iLoadedEngines[intI] == ATTNV)
            {

                sEngineName = "ATTNV Engine (RESERVED INTERNAL USE) Load Result: ";

            }
            else if (iLoadedEngines[intI] == MACOSXSPMAN)
            {

                sEngineName = "MAC OS X SPMAN Load Result: ";

            } 
            else if (iLoadedEngines[intI] == MSSAPI)
            {

                sEngineName = "MS SAPI Load Result: ";

            }           

            result = iLoadedEnginesReturnValues[intI];
                        
            System.out.println(sEngineName + result + '\n');
            
        }
        
        //Initialize the controls, etc
        
        initComponents();
        
        //List installed voices
        
        int z=0;
                
        for( ;;z++ )
        {  
        	
            int[] pvetOut = new int[] { -1 };
           
            int[] piVoiceNameLenOut = new int[] { -1 };
            
            int[] piVoiceIDOut = new int[] { -1 };
            
            short[] plangOut = new short[] { -1 };        	
      
        	String szVoiceNameOut = JNILayer.GetDFTTSVoice( z, 
	    		    pvetOut, 
	    		    piVoiceNameLenOut, 
	    			piVoiceIDOut, 
	    			plangOut 
	    			);
	       
	       if( szVoiceNameOut.length() == 0 )
	    	   break;
	        
	        System.out.println("Voice Engine: " + pvetOut[0] + '\n');
	        
	        System.out.println("Voice Name: " + szVoiceNameOut + '\n');
	        
	        System.out.println("Voice Name Length: " + piVoiceNameLenOut[0] + '\n');
	        
	        System.out.println("Voice ID: " + piVoiceIDOut[0] + '\n');
	        
	        System.out.println("Language ID: " + plangOut[0] + '\n');
	        
	        //See class VoiceData
	        
	        comboBox1.addItem( new VoiceData(szVoiceNameOut,
	        		pvetOut[0],
	        		piVoiceIDOut[0],
	        		plangOut[0]) );
        
        }
        
        if (z == 0)
        {
        	JOptionPane.showMessageDialog(this, "No voices can be found on your system! Please download and install at least 1 voice!");
        }

        int dictreturn = 0;

        //User Dictionary Loading: 
        //(read dictionary documentation per engine located in folder DictionarySystems)

        //This is how to load a dictionary for the NeoSpeech provider (the dictionary is loaded _
        //by language from a file (the dict name, voice name, _
        //dict content do NOT matter), the dictionary number matters)

        //JNILayer.MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US) = 1033 - You can just use 1033
        
        // *** YOU MUST CHANGE THE DICTIONARY PATH TO MATCH YOURS! *** //

        /*dictreturn = JNILayer.LoadDFTTSUserDict(1, "", 
                "C:\\CPP\\Projects\\DFTTSSDK\\samples\\Java\\DFTTSSDKSampleJava\\neospeech_userdict_eng.csv", 
                NEOSPEECHVOICETEXT, JNILayer.MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US), 
                "", "");*/

        //This is how to load a dictionary for the Cepstral provider (the dictionary is loaded
        //by voice from a file.
        //The dictionary number, dict name, dict content do NOT matter.)

        /*dictreturn = JNILayer.LoadDFTTSUserDict(-1, "", 
                "C:\\CPP\\Projects\\DFTTSSDK\\samples\\Java\\DFTTSSDKSampleJava\\cepstral_dictionary.txt",
                CEPSTRAL, LANG_SUBLANG_NEUTRAL, "David", "");*/
        
        //MACOSXSPMAN: No dictionary support.

        if (dictreturn != 0 )
        {
        	JOptionPane.showMessageDialog( this, "SDK Load Dictionary failed with error: " + dictreturn );
        }

					
	
	}


	private void button1MouseClicked(MouseEvent e) {		
		
		
		//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		//NeoSpeech does return too soon and the speech is lost when using JNI 
		//(for the Java implementation of the SDK)!
		//THEREFORE: JNI currently DOES NOT support speaking by NeoSpeech voices (it supports audio file generation, though)!
		//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		
		Object obj = comboBox1.getItemAt( comboBox1.getSelectedIndex() );		
		
		VoiceData vo = (VoiceData)obj;
		
		int result = JNILayer.DFTTSSpeak(0,
    		   vo.m_vet,
    		   vo.m_sVoiceName,
               vo.m_VoiceID,
               vo.m_lang,
               textArea1.getText(), -1, -1, -1, -1,
               1, DFTTS_TEXT_TYPE_XML, SPSF_16kHz16BitStereo);
            
            		
      	if( result != 0 )
		{
			JOptionPane.showMessageDialog(this, "SDK Speak error: " + result);
				
		}
      	else
      		bIsSpeaking = true;
	       
	}

	private void button2MouseClicked(MouseEvent e) {
		
		//JNILayer.MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US) = 1033 - You can just use 1033
		
		Object obj = comboBox1.getItemAt( comboBox1.getSelectedIndex() );		
		
		VoiceData vo = (VoiceData)obj;
		
        if(bIsPaused==true)
        {

            bIsPaused = false;

            int result = JNILayer.DFTTSResume(vo.m_vet,(short)1033);

            if (result != 0)
            {

            	JOptionPane.showMessageDialog(this, "SDK Resume error: " + result);

            }

        }
        else if (bIsPaused == false)
        {

            bIsPaused = true;

            int result = JNILayer.DFTTSPause(vo.m_vet,(short)1033);

            if (result != 0)
            {

            	JOptionPane.showMessageDialog(this, "SDK Pause error: " + result);

            }

        }
	}

	private void button3MouseClicked(MouseEvent e) {
		
		//JNILayer.MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US) = 1033 - You can just use 1033
		
		Object obj = comboBox1.getItemAt( comboBox1.getSelectedIndex() );		
		
		VoiceData vo = (VoiceData)obj;
		
		int result = JNILayer.DFTTSStop(vo.m_vet,(short)1033);
        
        if (result != 0)
        {

        	JOptionPane.showMessageDialog(this, "SDK Stop error: " + result);

        }
        else
        {
        	bIsPaused = false;
        	
          	bIsSpeaking = false;
        	
  	    	if( button2.isEnabled())
  	    		button2.setEnabled(false);
  	    	
  	    	if( button3.isEnabled())
  	    		button3.setEnabled(false);
  	    	
        }
        	
	}

	private void button4MouseClicked(MouseEvent e) {
		
		// *** YOU MUST CHANGE THE WAV PATH TO MATCH YOURS! *** //
		
		/*MAC OS X note: MACOSXSPMAN only AIFF format supported. All format args will be ignored*/
		
		//JNILayer.MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US) = 1033 - You can just use 1033
				
		Object obj = comboBox1.getItemAt( comboBox1.getSelectedIndex() );		
		
		VoiceData vo = (VoiceData)obj;
		
		String filepath = "test.wav";
		
		if( vo.m_vet == MACOSXSPMAN )
			filepath = "test.aiff";
		
		short format = 0;
		
		if( vo.m_vet == NEOSPEECHVOICETEXT )
			format = VT_FILE_API_FMT_ALAW_WAVE;
		else if( vo.m_vet == MSSAPI )
			format = SPSF_16kHz16BitStereo;

        int result = JNILayer.DFTTSExportToFileEx(vo.m_vet,
        vo.m_sVoiceName, vo.m_VoiceID,
        (short)1033, textArea1.getText(), -1, 
        -1, -1, -1, 
        1, DFTTS_TEXT_TYPE_XML,
        filepath, 
        format, 
        "pcm16", 16000, 
        2);        
               
        if (result != 0)
        {

        	JOptionPane.showMessageDialog(this, "SDK Export error: " + result);

        }     
	}

	private void thisWindowClosing(WindowEvent e) {
	
		
		/*********************************
		 * IMPORTANT FOR MAC OS X USERS!
		 * 
		 * JNILayer.UninitDFTTSEngine();
		 * 
		 * MUST ALSO BE CALLED WHEN THE APP QUITS (WHEN THE USER PRESSES MAC BUTTON + Q)!
		 * 
		 * SEE THE SAMPLE PACKAGE FROM APPLE IN FOLDER OSXAdapter ON HOW TO CAPTURE THE QUIT EVENT FOR MAC OS X
		 * 
		 * THE SAMPLE IS MADE CROSS-PLATFORM AS IT CHECKS FOR THE OS NAME
		 * 
		 */
		
		//Stop the voice if it is speaking (so we do not cause exceptions with some voices)
		
		if( bIsSpeaking )
		{
			
			//JNILayer.MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US) = 1033 - You can just use 1033
			
			Object obj = comboBox1.getItemAt( comboBox1.getSelectedIndex() );		
			
			VoiceData vo = (VoiceData)obj;
			
			JNILayer.DFTTSStop(vo.m_vet,(short)1033);			
			
		}
		
		JNILayer.UninitDFTTSEngine();
		
		 System.out.println("Speech SDK Memory Released!");
		 
		 System.exit(0);
	}

	private void initComponents() {
		
		button1 = new JButton();
		button2 = new JButton();
		button2.setEnabled(false);
		button3 = new JButton();
		button3.setEnabled(false);
		button4 = new JButton();
		label1 = new JLabel();
		scrollPane1 = new JScrollPane();
		textArea1 = new JTextArea();
		label2 = new JLabel();
		comboBox1 = new JComboBox();

		//======== this ========
		setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		setResizable(false);
		setTitle("DF TTS SDK sample for Java");
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				thisWindowClosing(e);
			}
		});
		Container contentPane = getContentPane();
		contentPane.setLayout(null);
		
		label2.setText("Voice:");
		contentPane.add(label2);
		label2.setBounds(10, 25, 35, label2.getPreferredSize().height);
		contentPane.add(comboBox1);
		comboBox1.setBounds(59, 20, 315, comboBox1.getPreferredSize().height);		

		//---- button1 ----
		button1.setText("Speak");
		button1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				button1MouseClicked(e);
			}
		});
		contentPane.add(button1);
		button1.setBounds(10, 210, 75, 23);

		//---- button2 ----
		button2.setText("Pause / Resume");
		button2.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				button2MouseClicked(e);
			}
		});
		contentPane.add(button2);
		button2.setBounds(95, 210, 115, 23);

		//---- button3 ----
		button3.setText("Stop");
		button3.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				button3MouseClicked(e);
			}
		});
		contentPane.add(button3);
		button3.setBounds(220, 210, 75, 23);

		//---- button4 ----
		button4.setText("Export");
		button4.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				button4MouseClicked(e);
			}
		});
		contentPane.add(button4);
		button4.setBounds(300, 210, 75, 23);
		contentPane.add(label1);
		label1.setBounds(10, 240, 365, 25);

		//======== scrollPane1 ========
		{

			//---- textArea1 ----
			textArea1.setText("Enter text here.");
			textArea1.setFont(new Font("Courier New", Font.PLAIN, 12));
			scrollPane1.setViewportView(textArea1);
		}
		contentPane.add(scrollPane1);
		scrollPane1.setBounds(10, 50, 365, 150);

		{ // compute preferred size
			Dimension preferredSize = new Dimension();
			for(int i = 0; i < contentPane.getComponentCount(); i++) {
				Rectangle bounds = contentPane.getComponent(i).getBounds();
				preferredSize.width = Math.max(bounds.x + bounds.width, preferredSize.width+5);
				preferredSize.height = Math.max(bounds.y + bounds.height, preferredSize.height);
			}
			Insets insets = contentPane.getInsets();
			preferredSize.width += insets.right;
			preferredSize.height += insets.bottom;
			contentPane.setMinimumSize(preferredSize);
			contentPane.setPreferredSize(preferredSize);
		}
		setSize(400, 300);
		setLocationRelativeTo(null);
		
	}
	
	public boolean bIsPaused = false;
	
	public boolean bIsSpeaking = false;
	
	public static final long serialVersionUID = 6603384152749567654L;
	    
	private JButton button1;
	public JButton button2;
	public JButton button3;
	private JButton button4;
	public JLabel label1;
	private JScrollPane scrollPane1;
	private JTextArea textArea1;
	private JLabel label2;
	private JComboBox comboBox1;
	
	private class VoiceData extends Object
	{
		public VoiceData(final String sVoiceName,
				final int vet,
				final int iVoiceID,
				final short lang )  
		{
			
			m_sVoiceName = sVoiceName;
			m_vet = vet;
			m_VoiceID = iVoiceID;
			m_lang = lang;
		}
		
		public String m_sVoiceName;
		public int m_vet;
		public int m_VoiceID;
		public short m_lang;
		
		 public @Override String  toString() 
		 { return m_sVoiceName; }
		

	}
	
	
	//API Variables
	
    public final int NEOSPEECH_NUM_VOICES = 12;

    public final int NUM_ENGINE_INITIALIZATIONS = 16;
    
    
    public final int NEOSPEECH_KATE_ENG = 0;

    public final int NEOSPEECH_PAUL_ENG = 1;

    public final int NEOSPEECH_MIYU_JPN = 0;

    public final int NEOSPEECH_SHOW_JPN = 1;

    public final int NEOSPEECH_MISAKI_JPN = 2;

    public final int NEOSPEECH_LILY_CHI = 0;

    public final int NEOSPEECH_WANG_CHI = 1;

    public final int NEOSPEECH_JUNWOO_KOR = 3;

    public final int NEOSPEECH_SUJIN_KOR = 8;

    public final int NEOSPEECH_YUMI_KOR = 10;

    public final int NEOSPEECH_GYURI_KOR = 11;

    public final int NEOSPEECH_DAYOUNG_KOR = 12;


    public final String NEOSPEECH_KATE_ENG_NAMESTR = "Kate";

    public final String NEOSPEECH_PAUL_ENG_NAMESTR  = "Paul";


    public final String NEOSPEECH_MIYU_JPN_NAMESTR  = "Miyu";

    public final String NEOSPEECH_SHOW_JPN_NAMESTR  = "Show";

    public final String NEOSPEECH_MISAKI_JPN_NAMESTR  = "Misaki";


    public final String NEOSPEECH_LILY_CHI_NAMESTR  = "Lily";

    public final String NEOSPEECH_WANG_CHI_NAMESTR  = "Wang";


    public final String NEOSPEECH_JUNWOO_KOR_NAMESTR  = "Junwoo";

    public final String NEOSPEECH_SUJIN_KOR_NAMESTR  = "Sujin";

    public final String NEOSPEECH_YUMI_KOR_NAMESTR  = "Yumi";

    public final String NEOSPEECH_GYURI_KOR_NAMESTR  = "Gyuri";

    public final String NEOSPEECH_DAYOUNG_KOR_NAMESTR = "Dayoung";
    

	
    public final int NOENGINE = -4;
    
    public final int ALLENGINES = -3;
    
    public final int NEOSPEECHVOICETEXT = 0;
    
    public final int CEPSTRAL = 1;
    
    public final int ATTNV = 2;
    
    public final int MSSAPI = 3;
    
    public final int MACOSXSPMAN = 4;

       

	public final int DFTTS_TEXT_TYPE_PLAIN = 0;
	
	public final int DFTTS_TEXT_TYPE_XML = 1;

   

    //NeoSpeech VoiceText (TM) Audio Format
	public final short VT_FILE_API_FMT_S16PCM = 0;
	public final short VT_FILE_API_FMT_ALAW = 1;
	public final short VT_FILE_API_FMT_MULAW = 2;
	public final short VT_FILE_API_FMT_DADPCM = 3;
	public final short VT_FILE_API_FMT_S16PCM_WAVE = 4;
	public final short VT_FILE_API_FMT_U08PCM_WAVE = 5;
	public final short VT_FILE_API_FMT_IMA_WAVE = 6;
	public final short VT_FILE_API_FMT_ALAW_WAVE = 7;
	public final short VT_FILE_API_FMT_MULAW_WAVE = 8;
	public final short VT_FILE_API_FMT_MULAW_AU = 9;

    

    /*Export formats for Cepstral voices

        You need to set the following instead:

        szAudioEncoding [possible values: 
        	* "pcm16", "pcm8" PCM 16 bit/8 bit WAV
        	* "ulaw" - -Law (8-bit by definition), "alaw" - A-Law (8-bit by definition)
            * "riff": Microsoft RIFF (WAV) file 
            * "snd": Sun/NeXT .au (SND) format. 
            * "raw": unheadered audio data, native byte order 
            * "le": unheadered audio data, little-endian (LSB first) 
            * "be": unheadered audio data, big-endian (MSB first) 
            * NOTE: that not all encoding types may be supported by all formats. For instance, SND doesnt support A-Law. ], 
     
        int iAudioSamplingRate [possible values: 8000 (8 KHz), 16000 (16 KHz), 11025 (11.025 kHz), etc ], 
     
        int iAudioChannels [possible values: 1 (mono), 2 (stereo)]
        
    Export formats for AT&T NV (RESERVED INTERNAL USE) 
    Currently only PCM WAV supported  (all audio format arguments will be ignored)
    */
	
	//Format (Speak & Export) for MSSAPI
	
	public final short SPSF_Default	= -1;
	public final short SPSF_NoAssignedFormat	= 0;
	public final short SPSF_Text	= SPSF_NoAssignedFormat + 1;
	public final short SPSF_NonStandardFormat	= SPSF_Text + 1;
	public final short SPSF_ExtendedAudioFormat	= SPSF_NonStandardFormat + 1;
	public final short SPSF_8kHz8BitMono	= SPSF_ExtendedAudioFormat + 1;
	public final short SPSF_8kHz8BitStereo	= SPSF_8kHz8BitMono + 1;
	public final short SPSF_8kHz16BitMono	= SPSF_8kHz8BitStereo + 1;
	public final short SPSF_8kHz16BitStereo	= SPSF_8kHz16BitMono + 1;
	public final short SPSF_11kHz8BitMono	= SPSF_8kHz16BitStereo + 1;
	public final short SPSF_11kHz8BitStereo	= SPSF_11kHz8BitMono + 1;
	public final short SPSF_11kHz16BitMono	= SPSF_11kHz8BitStereo + 1;
	public final short SPSF_11kHz16BitStereo	= SPSF_11kHz16BitMono + 1;
	public final short SPSF_12kHz8BitMono	= SPSF_11kHz16BitStereo + 1;
	public final short SPSF_12kHz8BitStereo	= SPSF_12kHz8BitMono + 1;
	public final short SPSF_12kHz16BitMono	= SPSF_12kHz8BitStereo + 1;
	public final short SPSF_12kHz16BitStereo	= SPSF_12kHz16BitMono + 1;
	public final short SPSF_16kHz8BitMono	= SPSF_12kHz16BitStereo + 1;
	public final short SPSF_16kHz8BitStereo	= SPSF_16kHz8BitMono + 1;
	public final short SPSF_16kHz16BitMono	= SPSF_16kHz8BitStereo + 1;
	public final short SPSF_16kHz16BitStereo	= SPSF_16kHz16BitMono + 1;
	public final short SPSF_22kHz8BitMono	= SPSF_16kHz16BitStereo + 1;
	public final short SPSF_22kHz8BitStereo	= SPSF_22kHz8BitMono + 1;
	public final short SPSF_22kHz16BitMono	= SPSF_22kHz8BitStereo + 1;
	public final short SPSF_22kHz16BitStereo	= SPSF_22kHz16BitMono + 1;
	public final short SPSF_24kHz8BitMono	= SPSF_22kHz16BitStereo + 1;
	public final short SPSF_24kHz8BitStereo	= SPSF_24kHz8BitMono + 1;
	public final short SPSF_24kHz16BitMono	= SPSF_24kHz8BitStereo + 1;
	public final short SPSF_24kHz16BitStereo	= SPSF_24kHz16BitMono + 1;
	public final short SPSF_32kHz8BitMono	= SPSF_24kHz16BitStereo + 1;
	public final short SPSF_32kHz8BitStereo	= SPSF_32kHz8BitMono + 1;
	public final short SPSF_32kHz16BitMono	= SPSF_32kHz8BitStereo + 1;
	public final short SPSF_32kHz16BitStereo	= SPSF_32kHz16BitMono + 1;
	public final short SPSF_44kHz8BitMono	= SPSF_32kHz16BitStereo + 1;
	public final short SPSF_44kHz8BitStereo	= SPSF_44kHz8BitMono + 1;
	public final short SPSF_44kHz16BitMono	= SPSF_44kHz8BitStereo + 1;
	public final short SPSF_44kHz16BitStereo	= SPSF_44kHz16BitMono + 1;
	public final short SPSF_48kHz8BitMono	= SPSF_44kHz16BitStereo + 1;
	public final short SPSF_48kHz8BitStereo	= SPSF_48kHz8BitMono + 1;
	public final short SPSF_48kHz16BitMono	= SPSF_48kHz8BitStereo + 1;
	public final short SPSF_48kHz16BitStereo	= SPSF_48kHz16BitMono + 1;
	public final short SPSF_TrueSpeech_8kHz1BitMono	= SPSF_48kHz16BitStereo + 1;
	public final short SPSF_CCITT_ALaw_8kHzMono	= SPSF_TrueSpeech_8kHz1BitMono + 1;
	public final short SPSF_CCITT_ALaw_8kHzStereo	= SPSF_CCITT_ALaw_8kHzMono + 1;
	public final short SPSF_CCITT_ALaw_11kHzMono	= SPSF_CCITT_ALaw_8kHzStereo + 1;
	public final short SPSF_CCITT_ALaw_11kHzStereo	= SPSF_CCITT_ALaw_11kHzMono + 1;
	public final short SPSF_CCITT_ALaw_22kHzMono	= SPSF_CCITT_ALaw_11kHzStereo + 1;
	public final short SPSF_CCITT_ALaw_22kHzStereo	= SPSF_CCITT_ALaw_22kHzMono + 1;
	public final short SPSF_CCITT_ALaw_44kHzMono	= SPSF_CCITT_ALaw_22kHzStereo + 1;
	public final short SPSF_CCITT_ALaw_44kHzStereo	= SPSF_CCITT_ALaw_44kHzMono + 1;
	public final short SPSF_CCITT_uLaw_8kHzMono	= SPSF_CCITT_ALaw_44kHzStereo + 1;
	public final short SPSF_CCITT_uLaw_8kHzStereo	= SPSF_CCITT_uLaw_8kHzMono + 1;
	public final short SPSF_CCITT_uLaw_11kHzMono	= SPSF_CCITT_uLaw_8kHzStereo + 1;
	public final short SPSF_CCITT_uLaw_11kHzStereo	= SPSF_CCITT_uLaw_11kHzMono + 1;
	public final short SPSF_CCITT_uLaw_22kHzMono	= SPSF_CCITT_uLaw_11kHzStereo + 1;
	public final short SPSF_CCITT_uLaw_22kHzStereo	= SPSF_CCITT_uLaw_22kHzMono + 1;
	public final short SPSF_CCITT_uLaw_44kHzMono	= SPSF_CCITT_uLaw_22kHzStereo + 1;
	public final short SPSF_CCITT_uLaw_44kHzStereo	= SPSF_CCITT_uLaw_44kHzMono + 1;
	public final short SPSF_ADPCM_8kHzMono	= SPSF_CCITT_uLaw_44kHzStereo + 1;
	public final short SPSF_ADPCM_8kHzStereo	= SPSF_ADPCM_8kHzMono + 1;
	public final short SPSF_ADPCM_11kHzMono	= SPSF_ADPCM_8kHzStereo + 1;
	public final short SPSF_ADPCM_11kHzStereo	= SPSF_ADPCM_11kHzMono + 1;
	public final short SPSF_ADPCM_22kHzMono	= SPSF_ADPCM_11kHzStereo + 1;
	public final short SPSF_ADPCM_22kHzStereo	= SPSF_ADPCM_22kHzMono + 1;
	public final short SPSF_ADPCM_44kHzMono	= SPSF_ADPCM_22kHzStereo + 1;
	public final short SPSF_ADPCM_44kHzStereo	= SPSF_ADPCM_44kHzMono + 1;
	public final short SPSF_GSM610_8kHzMono	= SPSF_ADPCM_44kHzStereo + 1;
	public final short SPSF_GSM610_11kHzMono	= SPSF_GSM610_8kHzMono + 1;
	public final short SPSF_GSM610_22kHzMono	= SPSF_GSM610_11kHzMono + 1;
	public final short SPSF_GSM610_44kHzMono	= SPSF_GSM610_22kHzMono + 1;
	public final short SPSF_NUM_FORMATS	= SPSF_GSM610_44kHzMono + 1;
	
	
	public final int DF_TTS_DEFAULT_PITCH = 100; /*100%*/
	public final int DF_TTS_DEFAULT_SPEED = 100; /*100%*/
	public final int DF_TTS_DEFAULT_VOLUME = 100; /*100%*/
	public final int DF_TTS_DEFAULT_PAUSE = 670; /*670 msec*/
	public final int DF_TTS_NEOSPEECH_MIN_PITCH = 50;
	public final int DF_TTS_NEOSPEECH_MAX_PITCH = 200;
	public final int DF_TTS_NEOSPEECH_MIN_SPEED = 50;
	public final int DF_TTS_NEOSPEECH_MAX_SPEED = 400;
	public final int DF_TTS_NEOSPEECH_MIN_VOLUME = 0;
	public final int DF_TTS_NEOSPEECH_MAX_VOLUME = 500;
	public final int DF_TTS_NEOSPEECH_MIN_PAUSE = 0;
	public final int DF_TTS_NEOSPEECH_MAX_PAUSE = 20000;
	public final int DF_TTS_CEPSTRAL_MIN_PITCH = 100;
	public final int DF_TTS_CEPSTRAL_MAX_PITCH = 500;
	public final int DF_TTS_CEPSTRAL_MIN_SPEED = 0;
	public final int DF_TTS_CEPSTRAL_MAX_SPEED = 400;
	public final int DF_TTS_CEPSTRAL_MIN_VOLUME = 0;
	public final int DF_TTS_CEPSTRAL_MAX_VOLUME = 500;
	public final int DF_TTS_ATTNV_MIN_SPEED = 13;
	public final int DF_TTS_ATTNV_MAX_SPEED = 800;
	public final int DF_TTS_ATTNV_MIN_VOLUME = 0;
	public final int DF_TTS_ATTNV_MAX_VOLUME = 500;
	public final int DF_TTS_ATTNV_MIN_PITCH = 0; /*AT&T NV do not support this*/
	public final int DF_TTS_ATTNV_MAX_PITCH = 0; /*AT&T NV do not support this*/
	public final int DF_TTS_MACOSXSPMAN_MIN_PITCH = 1;
	public final int DF_TTS_MACOSXSPMAN_MAX_PITCH = 1000;
	public final int DF_TTS_MACOSXSPMAN_MIN_SPEED = 1;
	public final int DF_TTS_MACOSXSPMAN_MAX_SPEED = 1000;
	public final int DF_TTS_MACOSXSPMAN_MIN_VOLUME = 100;
	public final int DF_TTS_MACOSXSPMAN_MAX_VOLUME = 500;
	public final int DF_TTS_MSSAPI_MIN_PITCH = 30;
	public final int DF_TTS_MSSAPI_MAX_PITCH = 350;
	public final int DF_TTS_MSSAPI_MIN_SPEED = 30;
	public final int DF_TTS_MSSAPI_MAX_SPEED = 350;
	public final int DF_TTS_MSSAPI_MIN_VOLUME = 0;
	public final int DF_TTS_MSSAPI_MAX_VOLUME = 100;

	
    //
    //  Language IDs.
    //
    //  The following two combinations of primary language ID and
    //  sublanguage ID have special semantics:
    //
    //    Primary Language ID   Sublanguage ID      Result
    //    -------------------   ---------------     ------------------------
    //    LANG_NEUTRAL          SUBLANG_NEUTRAL     Language neutral
    //    LANG_NEUTRAL          SUBLANG_DEFAULT     User default language
    //    LANG_NEUTRAL          SUBLANG_SYS_DEFAULT System default language
    //    LANG_INVARIANT        SUBLANG_NEUTRAL     Invariant locale
    //

    //
    //  Primary language IDs.
    //

    public final short LANG_NEUTRAL = 0;
    public final short LANG_INVARIANT = 127;

    public final short LANG_AFRIKAANS = 54;
    public final short LANG_ALBANIAN = 28;
    public final short LANG_ALSATIAN = 132;
    public final short LANG_AMHARIC = 94;
    public final short LANG_ARABIC = 1;
    public final short LANG_ARMENIAN = 43;
    public final short LANG_ASSAMESE = 77;
    public final short LANG_AZERI = 44;
    public final short LANG_BASHKIR = 109;
    public final short LANG_BASQUE = 45;
    public final short LANG_BELARUSIAN = 35;
    public final short LANG_BENGALI = 69;
    public final short LANG_BRETON = 126;
    // Use with SUBLANG_BOSNIAN_* Sublanguage IDs
    public final short LANG_BOSNIAN = 26;
    // Use with the ConvertDefaultLocale function
    public final short LANG_BOSNIAN_NEUTRAL = 30746;
    public final short LANG_BULGARIAN = 2;
    public final short LANG_CATALAN = 3;
    // Use with SUBLANG_CHINESE_* Sublanguage IDs
    public final short LANG_CHINESE = 4;
    // Use with the ConvertDefaultLocale function
    public final short LANG_CHINESE_SIMPLIFIED = 4;
    // Use with the ConvertDefaultLocale function
    public final short LANG_CHINESE_TRADITIONAL = 31748;
    public final short LANG_CORSICAN = 131;
    public final short LANG_CROATIAN = 26;
    public final short LANG_CZECH = 5;
    public final short LANG_DANISH = 6;
    public final short LANG_DARI = 140;
    public final short LANG_DIVEHI = 101;
    public final short LANG_DUTCH = 19;
    public final short LANG_ENGLISH = 9;
    public final short LANG_ESTONIAN = 37;
    public final short LANG_FAEROESE = 56;
    // Deprecated: use LANG_PERSIAN instead
    public final short LANG_FARSI = 41;
    public final short LANG_FILIPINO = 100;
    public final short LANG_FINNISH = 11;
    public final short LANG_FRENCH = 12;
    public final short LANG_FRISIAN = 98;
    public final short LANG_GALICIAN = 86;
    public final short LANG_GEORGIAN = 55;
    public final short LANG_GERMAN = 7;
    public final short LANG_GREEK = 8;
    public final short LANG_GREENLANDIC = 111;
    public final short LANG_GUJARATI = 71;
    public final short LANG_HAUSA = 104;
    public final short LANG_HEBREW = 13;
    public final short LANG_HINDI = 57;
    public final short LANG_HUNGARIAN = 14;
    public final short LANG_ICELANDIC = 15;
    public final short LANG_IGBO = 112;
    public final short LANG_INDONESIAN = 33;
    public final short LANG_INUKTITUT = 93;
    // Use with the SUBLANG_IRISH_IRELAND Sublanguage ID
    public final short LANG_IRISH = 60;
    public final short LANG_ITALIAN = 16;
    public final short LANG_JAPANESE = 17;
    public final short LANG_KANNADA = 75;
    public final short LANG_KASHMIRI = 96;
    public final short LANG_KAZAK = 63;
    public final short LANG_KHMER = 83;
    public final short LANG_KICHE = 134;
    public final short LANG_KINYARWANDA = 135;
    public final short LANG_KONKANI = 87;
    public final short LANG_KOREAN = 18;
    public final short LANG_KYRGYZ = 64;
    public final short LANG_LAO = 84;
    public final short LANG_LATVIAN = 38;
    public final short LANG_LITHUANIAN = 39;
    public final short LANG_LOWER_SORBIAN = 46;
    public final short LANG_LUXEMBOURGISH = 110;
    // the Former Yugoslav Republic of Macedonia
    public final short LANG_MACEDONIAN = 47;
    public final short LANG_MALAY = 62;
    public final short LANG_MALAYALAM = 76;
    public final short LANG_MALTESE = 58;
    public final short LANG_MANIPURI = 88;
    public final short LANG_MAORI = 129;
    public final short LANG_MAPUDUNGUN = 122;
    public final short LANG_MARATHI = 78;
    public final short LANG_MOHAWK = 124;
    public final short LANG_MONGOLIAN = 80;
    public final short LANG_NEPALI = 97;
    public final short LANG_NORWEGIAN = 20;
    public final short LANG_OCCITAN = 130;
    public final short LANG_ORIYA = 72;
    public final short LANG_PASHTO = 99;
    public final short LANG_PERSIAN = 41;
    public final short LANG_POLISH = 21;
    public final short LANG_PORTUGUESE = 22;
    public final short LANG_PUNJABI = 70;
    public final short LANG_QUECHUA = 107;
    public final short LANG_ROMANIAN = 24;
    public final short LANG_ROMANSH = 23;
    public final short LANG_RUSSIAN = 25;
    public final short LANG_SAMI = 59;
    public final short LANG_SANSKRIT = 79;
    // Use with the SUBLANG_SERBIAN_* Sublanguage IDs
    public final short LANG_SERBIAN = 26;
    // Use with the ConvertDefaultLocale function
    public final short LANG_SERBIAN_NEUTRAL = 31770;
    public final short LANG_SINDHI = 89;
    public final short LANG_SINHALESE = 91;
    public final short LANG_SLOVAK = 27;
    public final short LANG_SLOVENIAN = 36;
    public final short LANG_SOTHO = 108;
    public final short LANG_SPANISH = 10;
    public final short LANG_SWAHILI = 65;
    public final short LANG_SWEDISH = 29;
    public final short LANG_SYRIAC = 90;
    public final short LANG_TAJIK = 40;
    public final short LANG_TAMAZIGHT = 95;
    public final short LANG_TAMIL = 73;
    public final short LANG_TATAR = 68;
    public final short LANG_TELUGU = 74;
    public final short LANG_THAI = 30;
    public final short LANG_TIBETAN = 81;
    public final short LANG_TIGRIGNA = 115;
    public final short LANG_TSWANA = 50;
    public final short LANG_TURKISH = 31;
    public final short LANG_TURKMEN = 66;
    public final short LANG_UIGHUR = 128;
    public final short LANG_UKRAINIAN = 34;
    public final short LANG_UPPER_SORBIAN = 46;
    public final short LANG_URDU = 32;
    public final short LANG_UZBEK = 67;
    public final short LANG_VIETNAMESE = 42;
    public final short LANG_WELSH = 82;
    public final short LANG_WOLOF = 136;
    public final short LANG_XHOSA = 52;
    public final short LANG_YAKUT = 133;
    public final short LANG_YI = 120;
    public final short LANG_YORUBA = 106;
    public final short LANG_ZULU = 53;

    //
    //  Sublanguage IDs.
    //
    //  The name immediately following SUBLANG_ dictates which primary
    //  language ID that sublanguage ID can be combined with to form a
    //  valid language ID.
    //

    // language neutral
    public final short SUBLANG_NEUTRAL = 0;
    // user default
    public final short SUBLANG_DEFAULT = 1;
    // system default
    public final short SUBLANG_SYS_DEFAULT = 2;
    // default custom language/locale
    public final short SUBLANG_CUSTOM_DEFAULT = 3;
    // custom language/locale
    public final short SUBLANG_CUSTOM_UNSPECIFIED = 4;
    // Default custom MUI language/locale
    public final short SUBLANG_UI_CUSTOM_DEFAULT = 5;


    // Afrikaans (South Africa) = &H0436 af-ZA
    public final short SUBLANG_AFRIKAANS_SOUTH_AFRICA = 1;
    // Albanian (Albania) = &H041c sq-AL
    public final short SUBLANG_ALBANIAN_ALBANIA = 1;
    // Alsatian (France) = &H0484
    public final short SUBLANG_ALSATIAN_FRANCE = 1;
    // Amharic (Ethiopia) = &H045e
    public final short SUBLANG_AMHARIC_ETHIOPIA = 1;
    // Arabic (Saudi Arabia)
    public final short SUBLANG_ARABIC_SAUDI_ARABIA = 1;
    // Arabic (Iraq)
    public final short SUBLANG_ARABIC_IRAQ = 2;
    // Arabic (Egypt)
    public final short SUBLANG_ARABIC_EGYPT = 3;
    // Arabic (Libya)
    public final short SUBLANG_ARABIC_LIBYA = 4;
    // Arabic (Algeria)
    public final short SUBLANG_ARABIC_ALGERIA = 5;
    // Arabic (Morocco)
    public final short SUBLANG_ARABIC_MOROCCO = 6;
    // Arabic (Tunisia)
    public final short SUBLANG_ARABIC_TUNISIA = 7;
    // Arabic (Oman)
    public final short SUBLANG_ARABIC_OMAN = 8;
    // Arabic (Yemen)
    public final short SUBLANG_ARABIC_YEMEN = 9;
    // Arabic (Syria)
    public final short SUBLANG_ARABIC_SYRIA = 10;
    // Arabic (Jordan)
    public final short SUBLANG_ARABIC_JORDAN = 11;
    // Arabic (Lebanon)
    public final short SUBLANG_ARABIC_LEBANON = 12;
    // Arabic (Kuwait)
    public final short SUBLANG_ARABIC_KUWAIT = 13;
    // Arabic (U.A.E)
    public final short SUBLANG_ARABIC_UAE = 14;
    // Arabic (Bahrain)
    public final short SUBLANG_ARABIC_BAHRAIN = 15;
    // Arabic (Qatar)
    public final short SUBLANG_ARABIC_QATAR = 16;
    // Armenian (Armenia) = &H042b hy-AM
    public final short SUBLANG_ARMENIAN_ARMENIA = 1;
    // Assamese (India) = &H044d
    public final short SUBLANG_ASSAMESE_INDIA = 1;
    // Azeri (Latin)
    public final short SUBLANG_AZERI_LATIN = 1;
    // Azeri (Cyrillic)
    public final short SUBLANG_AZERI_CYRILLIC = 2;
    // Bashkir (Russia) = &H046d ba-RU
    public final short SUBLANG_BASHKIR_RUSSIA = 1;
    // Basque (Basque) = &H042d eu-ES
    public final short SUBLANG_BASQUE_BASQUE = 1;
    // Belarusian (Belarus) = &H0423 be-BY
    public final short SUBLANG_BELARUSIAN_BELARUS = 1;
    // Bengali (India)
    public final short SUBLANG_BENGALI_INDIA = 1;
    // Bengali (Bangladesh)
    public final short SUBLANG_BENGALI_BANGLADESH = 2;
    // Bosnian (Bosnia and Herzegovina - Latin) = &H141a bs-BA-Latn
    public final short SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN = 5;
    // Bosnian (Bosnia and Herzegovina - Cyrillic) = &H201a bs-BA-Cyrl
    public final short SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC = 8;
    // Breton (France) = &H047e
    public final short SUBLANG_BRETON_FRANCE = 1;
    // Bulgarian (Bulgaria) = &H0402
    public final short SUBLANG_BULGARIAN_BULGARIA = 1;
    // Catalan (Catalan) = &H0403
    public final short SUBLANG_CATALAN_CATALAN = 1;
    // Chinese (Taiwan) = &H0404 zh-TW
    public final short SUBLANG_CHINESE_TRADITIONAL = 1;
    // Chinese (PR China) = &H0804 zh-CN
    public final short SUBLANG_CHINESE_SIMPLIFIED = 2;
    // Chinese (Hong Kong S.A.R., P.R.C.) = &H0c04 zh-HK
    public final short SUBLANG_CHINESE_HONGKONG = 3;
    // Chinese (Singapore) = &H1004 zh-SG
    public final short SUBLANG_CHINESE_SINGAPORE = 4;
    // Chinese (Macau S.A.R.) = &H1404 zh-MO
    public final short SUBLANG_CHINESE_MACAU = 5;
    // Corsican (France) = &H0483
    public final short SUBLANG_CORSICAN_FRANCE = 1;
    // Czech (Czech Republic) = &H0405
    public final short SUBLANG_CZECH_CZECH_REPUBLIC = 1;
    // Croatian (Croatia)
    public final short SUBLANG_CROATIAN_CROATIA = 1;
    // Croatian (Bosnia and Herzegovina - Latin) = &H101a hr-BA
    public final short SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN = 4;
    // Danish (Denmark) = &H0406
    public final short SUBLANG_DANISH_DENMARK = 1;
    // Dari (Afghanistan)
    public final short SUBLANG_DARI_AFGHANISTAN = 1;
    // Divehi (Maldives) = &H0465 div-MV
    public final short SUBLANG_DIVEHI_MALDIVES = 1;
    // Dutch
    public final short SUBLANG_DUTCH = 1;
    // Dutch (Belgian)
    public final short SUBLANG_DUTCH_BELGIAN = 2;
    // English (USA)
    public final short SUBLANG_ENGLISH_US = 1;
    // English (UK)
    public final short SUBLANG_ENGLISH_UK = 2;
    // English (Australian)
    public final short SUBLANG_ENGLISH_AUS = 3;
    // English (Canadian)
    public final short SUBLANG_ENGLISH_CAN = 4;
    // English (New Zealand)
    public final short SUBLANG_ENGLISH_NZ = 5;
    // English (Irish)
    public final short SUBLANG_ENGLISH_EIRE = 6;
    // English (South Africa)
    public final short SUBLANG_ENGLISH_SOUTH_AFRICA = 7;
    // English (Jamaica)
    public final short SUBLANG_ENGLISH_JAMAICA = 8;
    // English (Caribbean)
    public final short SUBLANG_ENGLISH_CARIBBEAN = 9;
    // English (Belize)
    public final short SUBLANG_ENGLISH_BELIZE = 10;
    // English (Trinidad)
    public final short SUBLANG_ENGLISH_TRINIDAD = 11;
    // English (Zimbabwe)
    public final short SUBLANG_ENGLISH_ZIMBABWE = 12;
    // English (Philippines)
    public final short SUBLANG_ENGLISH_PHILIPPINES = 13;
    // English (India)
    public final short SUBLANG_ENGLISH_INDIA = 16;
    // English (Malaysia)
    public final short SUBLANG_ENGLISH_MALAYSIA = 17;
    // English (Singapore)
    public final short SUBLANG_ENGLISH_SINGAPORE = 18;
    // Estonian (Estonia) = &H0425 et-EE
    public final short SUBLANG_ESTONIAN_ESTONIA = 1;
    // Faroese (Faroe Islands) = &H0438 fo-FO
    public final short SUBLANG_FAEROESE_FAROE_ISLANDS = 1;
    // Filipino (Philippines) = &H0464 fil-PH
    public final short SUBLANG_FILIPINO_PHILIPPINES = 1;
    // Finnish (Finland) = &H040b
    public final short SUBLANG_FINNISH_FINLAND = 1;
    // French
    public final short SUBLANG_FRENCH = 1;
    // French (Belgian)
    public final short SUBLANG_FRENCH_BELGIAN = 2;
    // French (Canadian)
    public final short SUBLANG_FRENCH_CANADIAN = 3;
    // French (Swiss)
    public final short SUBLANG_FRENCH_SWISS = 4;
    // French (Luxembourg)
    public final short SUBLANG_FRENCH_LUXEMBOURG = 5;
    // French (Monaco)
    public final short SUBLANG_FRENCH_MONACO = 6;
    // Frisian (Netherlands) = &H0462 fy-NL
    public final short SUBLANG_FRISIAN_NETHERLANDS = 1;
    // Galician (Galician) = &H0456 gl-ES
    public final short SUBLANG_GALICIAN_GALICIAN = 1;
    // Georgian (Georgia) = &H0437 ka-GE
    public final short SUBLANG_GEORGIAN_GEORGIA = 1;
    // German
    public final short SUBLANG_GERMAN = 1;
    // German (Swiss)
    public final short SUBLANG_GERMAN_SWISS = 2;
    // German (Austrian)
    public final short SUBLANG_GERMAN_AUSTRIAN = 3;
    // German (Luxembourg)
    public final short SUBLANG_GERMAN_LUXEMBOURG = 4;
    // German (Liechtenstein)
    public final short SUBLANG_GERMAN_LIECHTENSTEIN = 5;
    // Greek (Greece)
    public final short SUBLANG_GREEK_GREECE = 1;
    // Greenlandic (Greenland) = &H046f kl-GL
    public final short SUBLANG_GREENLANDIC_GREENLAND = 1;
    // Gujarati (India (Gujarati Script)) = &H0447 gu-IN
    public final short SUBLANG_GUJARATI_INDIA = 1;
    // Hausa (Latin, Nigeria) = &H0468 ha-NG-Latn
    public final short SUBLANG_HAUSA_NIGERIA_LATIN = 1;
    // Hebrew (Israel) = &H040d
    public final short SUBLANG_HEBREW_ISRAEL = 1;
    // Hindi (India) = &H0439 hi-IN
    public final short SUBLANG_HINDI_INDIA = 1;
    // Hungarian (Hungary) = &H040e
    public final short SUBLANG_HUNGARIAN_HUNGARY = 1;
    // Icelandic (Iceland) = &H040f
    public final short SUBLANG_ICELANDIC_ICELAND = 1;
    // Igbo (Nigeria) = &H0470 ig-NG
    public final short SUBLANG_IGBO_NIGERIA = 1;
    // Indonesian (Indonesia) = &H0421 id-ID
    public final short SUBLANG_INDONESIAN_INDONESIA = 1;
    // Inuktitut (Syllabics) (Canada) = &H045d iu-CA-Cans
    public final short SUBLANG_INUKTITUT_CANADA = 1;
    // Inuktitut (Canada - Latin)
    public final short SUBLANG_INUKTITUT_CANADA_LATIN = 2;
    // Irish (Ireland)
    public final short SUBLANG_IRISH_IRELAND = 2;
    // Italian
    public final short SUBLANG_ITALIAN = 1;
    // Italian (Swiss)
    public final short SUBLANG_ITALIAN_SWISS = 2;
    // Japanese (Japan) = &H0411
    public final short SUBLANG_JAPANESE_JAPAN = 1;
    // Kannada (India (Kannada Script)) = &H044b kn-IN
    public final short SUBLANG_KANNADA_INDIA = 1;
    // Kashmiri (South Asia)
    public final short SUBLANG_KASHMIRI_SASIA = 2;
    // For app compatibility only
    public final short SUBLANG_KASHMIRI_INDIA = 2;
    // Kazakh (Kazakhstan) = &H043f kk-KZ
    public final short SUBLANG_KAZAK_KAZAKHSTAN = 1;
    // Khmer (Cambodia) = &H0453 kh-KH
    public final short SUBLANG_KHMER_CAMBODIA = 1;
    // K'iche (Guatemala)
    public final short SUBLANG_KICHE_GUATEMALA = 1;
    // Kinyarwanda (Rwanda) = &H0487 rw-RW
    public final short SUBLANG_KINYARWANDA_RWANDA = 1;
    // Konkani (India) = &H0457 kok-IN
    public final short SUBLANG_KONKANI_INDIA = 1;
    // Korean (Extended Wansung)
    public final short SUBLANG_KOREAN = 1;
    // Kyrgyz (Kyrgyzstan) = &H0440 ky-KG
    public final short SUBLANG_KYRGYZ_KYRGYZSTAN = 1;
    // Lao (Lao PDR) = &H0454 lo-LA
    public final short SUBLANG_LAO_LAO = 1;
    // Latvian (Latvia) = &H0426 lv-LV
    public final short SUBLANG_LATVIAN_LATVIA = 1;
    // Lithuanian
    public final short SUBLANG_LITHUANIAN = 1;
    // Lower Sorbian (Germany) = &H082e wee-DE
    public final short SUBLANG_LOWER_SORBIAN_GERMANY = 2;
    // Luxembourgish (Luxembourg) = &H046e lb-LU
    public final short SUBLANG_LUXEMBOURGISH_LUXEMBOURG = 1;
    // Macedonian (Macedonia (FYROM)) = &H042f mk-MK
    public final short SUBLANG_MACEDONIAN_MACEDONIA = 1;
    // Malay (Malaysia)
    public final short SUBLANG_MALAY_MALAYSIA = 1;
    // Malay (Brunei Darussalam)
    public final short SUBLANG_MALAY_BRUNEI_DARUSSALAM = 2;
    // Malayalam (India (Malayalam Script) ) = &H044c ml-IN
    public final short SUBLANG_MALAYALAM_INDIA = 1;
    // Maltese (Malta) = &H043a mt-MT
    public final short SUBLANG_MALTESE_MALTA = 1;
    // Maori (New Zealand) = &H0481 mi-NZ
    public final short SUBLANG_MAORI_NEW_ZEALAND = 1;
    // Mapudungun (Chile) = &H047a arn-CL
    public final short SUBLANG_MAPUDUNGUN_CHILE = 1;
    // Marathi (India) = &H044e mr-IN
    public final short SUBLANG_MARATHI_INDIA = 1;
    // Mohawk (Mohawk) = &H047c moh-CA
    public final short SUBLANG_MOHAWK_MOHAWK = 1;
    // Mongolian (Cyrillic, Mongolia)
    public final short SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA = 1;
    // Mongolian (PRC)
    public final short SUBLANG_MONGOLIAN_PRC = 2;
    // Nepali (India)
    public final short SUBLANG_NEPALI_INDIA = 2;
    // Nepali (Nepal) = &H0461 ne-NP
    public final short SUBLANG_NEPALI_NEPAL = 1;
    // Norwegian (Bokmal)
    public final short SUBLANG_NORWEGIAN_BOKMAL = 1;
    // Norwegian (Nynorsk)
    public final short SUBLANG_NORWEGIAN_NYNORSK = 2;
    // Occitan (France) = &H0482 oc-FR
    public final short SUBLANG_OCCITAN_FRANCE = 1;
    // Oriya (India (Oriya Script)) = &H0448 or-IN
    public final short SUBLANG_ORIYA_INDIA = 1;
    // Pashto (Afghanistan)
    public final short SUBLANG_PASHTO_AFGHANISTAN = 1;
    // Persian (Iran) = &H0429 fa-IR
    public final short SUBLANG_PERSIAN_IRAN = 1;
    // Polish (Poland) = &H0415
    public final short SUBLANG_POLISH_POLAND = 1;
    // Portuguese
    public final short SUBLANG_PORTUGUESE = 2;
    // Portuguese (Brazilian)
    public final short SUBLANG_PORTUGUESE_BRAZILIAN = 1;
    // Punjabi (India (Gurmukhi Script)) = &H0446 pa-IN
    public final short SUBLANG_PUNJABI_INDIA = 1;
    // Quechua (Bolivia)
    public final short SUBLANG_QUECHUA_BOLIVIA = 1;
    // Quechua (Ecuador)
    public final short SUBLANG_QUECHUA_ECUADOR = 2;
    // Quechua (Peru)
    public final short SUBLANG_QUECHUA_PERU = 3;
    // Romanian (Romania) = &H0418
    public final short SUBLANG_ROMANIAN_ROMANIA = 1;
    // Romansh (Switzerland) = &H0417 rm-CH
    public final short SUBLANG_ROMANSH_SWITZERLAND = 1;
    // Russian (Russia) = &H0419
    public final short SUBLANG_RUSSIAN_RUSSIA = 1;
    // Northern Sami (Norway)
    public final short SUBLANG_SAMI_NORTHERN_NORWAY = 1;
    // Northern Sami (Sweden)
    public final short SUBLANG_SAMI_NORTHERN_SWEDEN = 2;
    // Northern Sami (Finland)
    public final short SUBLANG_SAMI_NORTHERN_FINLAND = 3;
    // Lule Sami (Norway)
    public final short SUBLANG_SAMI_LULE_NORWAY = 4;
    // Lule Sami (Sweden)
    public final short SUBLANG_SAMI_LULE_SWEDEN = 5;
    // Southern Sami (Norway)
    public final short SUBLANG_SAMI_SOUTHERN_NORWAY = 6;
    // Southern Sami (Sweden)
    public final short SUBLANG_SAMI_SOUTHERN_SWEDEN = 7;
    // Skolt Sami (Finland)
    public final short SUBLANG_SAMI_SKOLT_FINLAND = 8;
    // Inari Sami (Finland)
    public final short SUBLANG_SAMI_INARI_FINLAND = 9;
    // Sanskrit (India) = &H044f sa-IN
    public final short SUBLANG_SANSKRIT_INDIA = 1;
    // Serbian (Bosnia and Herzegovina - Latin)
    public final short SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN = 6;
    // Serbian (Bosnia and Herzegovina - Cyrillic)
    public final short SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC = 7;
    // Croatian (Croatia) = &H041a hr-HR
    public final short SUBLANG_SERBIAN_CROATIA = 1;
    // Serbian (Latin)
    public final short SUBLANG_SERBIAN_LATIN = 2;
    // Serbian (Cyrillic)
    public final short SUBLANG_SERBIAN_CYRILLIC = 3;
    // Sindhi (India) reserved = &H0459
    public final short SUBLANG_SINDHI_INDIA = 1;
    // Sindhi (Pakistan) reserved = &H0859
    public final short SUBLANG_SINDHI_PAKISTAN = 2;
    // For app compatibility only
    public final short SUBLANG_SINDHI_AFGHANISTAN = 2;
    // Sinhalese (Sri Lanka)
    public final short SUBLANG_SINHALESE_SRI_LANKA = 1;
    // Northern Sotho (South Africa)
    public final short SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA = 1;
    // Slovak (Slovakia) = &H041b sk-SK
    public final short SUBLANG_SLOVAK_SLOVAKIA = 1;
    // Slovenian (Slovenia) = &H0424 sl-SI
    public final short SUBLANG_SLOVENIAN_SLOVENIA = 1;
    // Spanish (Castilian)
    public final short SUBLANG_SPANISH = 1;
    // Spanish (Mexican)
    public final short SUBLANG_SPANISH_MEXICAN = 2;
    // Spanish (Modern)
    public final short SUBLANG_SPANISH_MODERN = 3;
    // Spanish (Guatemala)
    public final short SUBLANG_SPANISH_GUATEMALA = 4;
    // Spanish (Costa Rica)
    public final short SUBLANG_SPANISH_COSTA_RICA = 5;
    // Spanish (Panama)
    public final short SUBLANG_SPANISH_PANAMA = 6;
    // Spanish (Dominican Republic)
    public final short SUBLANG_SPANISH_DOMINICAN_REPUBLIC = 7;
    // Spanish (Venezuela)
    public final short SUBLANG_SPANISH_VENEZUELA = 8;
    // Spanish (Colombia)
    public final short SUBLANG_SPANISH_COLOMBIA = 9;
    // Spanish (Peru)
    public final short SUBLANG_SPANISH_PERU = 10;
    // Spanish (Argentina)
    public final short SUBLANG_SPANISH_ARGENTINA = 11;
    // Spanish (Ecuador)
    public final short SUBLANG_SPANISH_ECUADOR = 12;
    // Spanish (Chile)
    public final short SUBLANG_SPANISH_CHILE = 13;
    // Spanish (Uruguay)
    public final short SUBLANG_SPANISH_URUGUAY = 14;
    // Spanish (Paraguay)
    public final short SUBLANG_SPANISH_PARAGUAY = 15;
    // Spanish (Bolivia)
    public final short SUBLANG_SPANISH_BOLIVIA = 16;
    // Spanish (El Salvador)
    public final short SUBLANG_SPANISH_EL_SALVADOR = 17;
    // Spanish (Honduras)
    public final short SUBLANG_SPANISH_HONDURAS = 18;
    // Spanish (Nicaragua)
    public final short SUBLANG_SPANISH_NICARAGUA = 19;
    // Spanish (Puerto Rico)
    public final short SUBLANG_SPANISH_PUERTO_RICO = 20;
    // Spanish (United States)
    public final short SUBLANG_SPANISH_US = 21;
    // Swahili (Kenya) = &H0441 sw-KE
    public final short SUBLANG_SWAHILI_KENYA = 1;
    // Swedish
    public final short SUBLANG_SWEDISH = 1;
    // Swedish (Finland)
    public final short SUBLANG_SWEDISH_FINLAND = 2;
    // Syriac (Syria) = &H045a syr-SY
    public final short SUBLANG_SYRIAC_SYRIA = 1;
    // Tajik (Tajikistan) = &H0428 tg-TJ-Cyrl
    public final short SUBLANG_TAJIK_TAJIKISTAN = 1;
    // Tamazight (Latin, Algeria) = &H085f tmz-DZ-Latn
    public final short SUBLANG_TAMAZIGHT_ALGERIA_LATIN = 2;
    // Tamil (India)
    public final short SUBLANG_TAMIL_INDIA = 1;
    // Tatar (Russia) = &H0444 tt-RU
    public final short SUBLANG_TATAR_RUSSIA = 1;
    // Telugu (India (Telugu Script)) = &H044a te-IN
    public final short SUBLANG_TELUGU_INDIA = 1;
    // Thai (Thailand) = &H041e th-TH
    public final short SUBLANG_THAI_THAILAND = 1;
    // Tibetan (PRC)
    public final short SUBLANG_TIBETAN_PRC = 1;
    // Tigrigna (Eritrea)
    public final short SUBLANG_TIGRIGNA_ERITREA = 2;
    // Setswana / Tswana (South Africa) = &H0432 tn-ZA
    public final short SUBLANG_TSWANA_SOUTH_AFRICA = 1;
    // Turkish (Turkey) = &H041f tr-TR
    public final short SUBLANG_TURKISH_TURKEY = 1;
    // Turkmen (Turkmenistan) = &H0442 tk-TM
    public final short SUBLANG_TURKMEN_TURKMENISTAN = 1;
    // Uighur (PRC) = &H0480 ug-CN
    public final short SUBLANG_UIGHUR_PRC = 1;
    // Ukrainian (Ukraine) = &H0422 uk-UA
    public final short SUBLANG_UKRAINIAN_UKRAINE = 1;
    // Upper Sorbian (Germany) = &H042e wen-DE
    public final short SUBLANG_UPPER_SORBIAN_GERMANY = 1;
    // Urdu (Pakistan)
    public final short SUBLANG_URDU_PAKISTAN = 1;
    // Urdu (India)
    public final short SUBLANG_URDU_INDIA = 2;
    // Uzbek (Latin)
    public final short SUBLANG_UZBEK_LATIN = 1;
    // Uzbek (Cyrillic)
    public final short SUBLANG_UZBEK_CYRILLIC = 2;
    // Vietnamese (Vietnam) = &H042a vi-VN
    public final short SUBLANG_VIETNAMESE_VIETNAM = 1;
    // Welsh (United Kingdom) = &H0452 cy-GB
    public final short SUBLANG_WELSH_UNITED_KINGDOM = 1;
    // Wolof (Senegal)
    public final short SUBLANG_WOLOF_SENEGAL = 1;
    // isiXhosa / Xhosa (South Africa) = &H0434 xh-ZA
    public final short SUBLANG_XHOSA_SOUTH_AFRICA = 1;
    // Yakut (Russia) = &H0485 sah-RU
    public final short SUBLANG_YAKUT_RUSSIA = 1;
    // Yi (PRC)) = &H0478
    public final short SUBLANG_YI_PRC = 1;
    // Yoruba (Nigeria) 046a yo-NG
    public final short SUBLANG_YORUBA_NIGERIA = 1;
    // isiZulu / Zulu (South Africa) = &H0435 zu-ZA
    public final short SUBLANG_ZULU_SOUTH_AFRICA = 1;


    //
    //  A language ID is a 16 bit value which is the combination of a
    //  primary language ID and a secondary language ID.  The bits are
    //  allocated as follows:
    //
    //       +-----------------------+-------------------------+
    //       |     Sublanguage ID    |   Primary Language ID   |
    //       +-----------------------+-------------------------+
    //        15                   10 9                       0   bit
    //


    //Neutral language

    public final short LANG_SUBLANG_NEUTRAL = 0;

		 
	
}
