//****************************************************************************
// Name:        DFTTSSampleCSharp with DFTTS Desktop SDK v 3.5.0
// Purpose:
// Author:      Digital Future
// Modified by:
// Created:     06/26/2008, updated 7/21/2008
// RCS-ID:
// Copyright:   (C) Digital Future 2007-2008. All rights reserved.
// Licence:     see license document
//***************************************************************************/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Security.Permissions;

namespace DFTTSSampleCSharp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }

        #region "API Enums and Constants"

        public const int NEOSPEECH_NUM_VOICES = 12;

        public const int NUM_ENGINE_INITIALIZATIONS = 16;

        public enum DFTTSPredefinedSpeechParams
        {

            DF_TTS_DEFAULT_PITCH = 100,
            ///*100%*/
            DF_TTS_DEFAULT_SPEED = 100,
            ///*100%*/
            DF_TTS_DEFAULT_VOLUME = 100,
            ///*100%*/
            DF_TTS_DEFAULT_PAUSE = 670,
            ///*670 msec*/
            DF_TTS_NEOSPEECH_MIN_PITCH = 50,
            DF_TTS_NEOSPEECH_MAX_PITCH = 200,
            DF_TTS_NEOSPEECH_MIN_SPEED = 50,
            DF_TTS_NEOSPEECH_MAX_SPEED = 400,
            DF_TTS_NEOSPEECH_MIN_VOLUME = 0,
            DF_TTS_NEOSPEECH_MAX_VOLUME = 500,
            DF_TTS_NEOSPEECH_MIN_PAUSE = 0,
            DF_TTS_NEOSPEECH_MAX_PAUSE = 20000,
            DF_TTS_CEPSTRAL_MIN_PITCH = 100,
            DF_TTS_CEPSTRAL_MAX_PITCH = 500,
            DF_TTS_CEPSTRAL_MIN_SPEED = 0,
            DF_TTS_CEPSTRAL_MAX_SPEED = 400,
            DF_TTS_CEPSTRAL_MIN_VOLUME = 0,
            DF_TTS_CEPSTRAL_MAX_VOLUME = 500,
            DF_TTS_ATTNV_MIN_SPEED = 13,
            DF_TTS_ATTNV_MAX_SPEED = 800,
            DF_TTS_ATTNV_MIN_VOLUME = 0,
            DF_TTS_ATTNV_MAX_VOLUME = 500,
            DF_TTS_ATTNV_MIN_PITCH = 0,
            ///*AT&T NV do not support this*/
            DF_TTS_ATTNV_MAX_PITCH = 0,
            ///*AT&T NV do not support this*/
            DF_TTS_MACOSXSPMAN_MIN_PITCH = 1,
            DF_TTS_MACOSXSPMAN_MAX_PITCH = 1000,
            DF_TTS_MACOSXSPMAN_MIN_SPEED = 1,
            DF_TTS_MACOSXSPMAN_MAX_SPEED = 1000,
            DF_TTS_MACOSXSPMAN_MIN_VOLUME = 100,
            DF_TTS_MACOSXSPMAN_MAX_VOLUME = 500,
            DF_TTS_MSSAPI_MIN_PITCH = 30,
            DF_TTS_MSSAPI_MAX_PITCH = 350,
            DF_TTS_MSSAPI_MIN_SPEED = 30,
            DF_TTS_MSSAPI_MAX_SPEED = 350,
            DF_TTS_MSSAPI_MIN_VOLUME = 0,
            DF_TTS_MSSAPI_MAX_VOLUME = 100

        }

        public enum DFTTSVoiceEngineType
        {

            NOENGINE = -4,
            ALLENGINES = -3,
            NEOSPEECHVOICETEXT = 0,
            CEPSTRAL,
            ATTNV,
            MSSAPI,
            MACOSXSPMAN

        }

        public enum InitDFTTSEngineReturnValue
        {

            INIT_DFTTS_ENGINE_SUCCESS,
            INIT_DFTTS_ENGINE_ERROR_DB_PATH_DIFFERENT,
            INIT_DFTTS_ENGINE_ERROR_CHANNEL_MEM_FAIL,
            INIT_DFTTS_ENGINE_ERROR_DB_MORPHEME_ANALYSIS_FAIL,
            INIT_DFTTS_ENGINE_ERROR_DB_BREAK_INDEX_FAIL,
            INIT_DFTTS_ENGINE_ERROR_DB_TEXT_PREP_FAIL,
            INIT_DFTTS_ENGINE_ERROR_DB_ACOU_MODEL_FAIL,
            INIT_DFTTS_ENGINE_ERROR_DB_UNIT_SEL_FAIL,
            INIT_DFTTS_ENGINE_ERROR_DB_PROS_MODEL_FAIL,
            INIT_DFTTS_ENGINE_ERROR_DB_SPEECH_DB_FAIL,
            INIT_DFTTS_ENGINE_ERROR_DB_PITCH_LOC_INFO_FAIL,
            INIT_DFTTS_ENGINE_ERROR_FAILED,
            INIT_DFTTS_ENGINE_ERROR_INVALIDARG,
            INIT_DFTTS_ENGINE_ERROR_OUTOFMEMORY,
            INIT_DFTTS_ENGINE_ERROR_NOTIMPL,
            INIT_DFTTS_ENGINE_ERROR_ABORT,
            INIT_DFTTS_ENGINE_ERROR_UNKNOWN,
            INIT_DFTTS_ENGINE_ERROR_BADHANDLE,
            INIT_DFTTS_ENGINE_ERROR_EXCEPTION,
            INIT_DFTTS_ENGINE_ERROR_EMPTY,
            INIT_DFTTS_ENGINE_ERROR_FULL,
            INIT_DFTTS_ENGINE_ERROR_INVALIDSTATE,
            INIT_DFTTS_ENGINE_ERROR_BADVERSION,
            INIT_DFTTS_ENGINE_ERROR_INSUFFICIENT_BUFFER,
            INIT_DFTTS_ENGINE_ERROR_UNSUPPORTED,
            INIT_DFTTS_ENGINE_ERROR_NOLICENSE,
            INIT_DFTTS_ENGINE_ERROR_CREATECHILDPROCESS_FAILED,
            INIT_DFTTS_ENGINE_ERROR_NOENVIRONMENTPATH,
            INIT_DFTTS_ENGINE_ERROR_TIMEOUT,
            INIT_DFTTS_ENGINE_ERROR_OUTOFRESOURCES,
            INIT_DFTTS_ENGINE_ERROR_NOVOICES,
            INIT_DFTTS_ENGINE_ERROR_CREATEFAIL,
            INIT_DFTTS_ENGINE_ERROR_CONNECTFAIL,
            INIT_DFTTS_ENGINE_ERROR_BINDFAIL,
            INIT_DFTTS_ENGINE_ERROR_LISTENFAIL,
            INIT_DFTTS_ENGINE_ERROR_CONNECTIONCLOSED,
            INIT_DFTTS_ENGINE_ERROR_ACCEPTFAIL,
            INIT_DFTTS_ENGINE_ERROR_SOCKETTIMEOUT,
            INIT_DFTTS_ENGINE_ERROR_SOCKETERROR,
            INIT_DFTTS_ENGINE_ERROR_NOMORESERVERS,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EWOULDBLOCK,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EINPROGRESS,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EALREADY,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTSOCK,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EDESTADDRREQ,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EMSGSIZE,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROTOTYPE,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOPROTOOPT,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROTONOSUPPORT,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ESOCKTNOSUPPORT,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EOPNOTSUPP,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EPFNOSUPPORT,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EAFNOSUPPORT,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EADDRINUSE,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EADDRNOTAVAIL,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETDOWN,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETUNREACH,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETRESET,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNABORTED,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNRESET,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOBUFS,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EISCONN,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTCONN,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ESHUTDOWN,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ETOOMANYREFS,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNREFUSED,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ELOOP,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENAMETOOLONG,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EHOSTDOWN,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EHOSTUNREACH,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTEMPTY,
            INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROCLIM,
            INIT_DFTTS_ENGINE_ERROR_THREADSTARTED,
            INIT_DFTTS_ENGINE_ERROR_THREADNOTSTARTED,
            INIT_DFTTS_ENGINE_ERROR_THREADCOULDNOTCREATE,
            INIT_DFTTS_ENGINE_ERROR_BADNVFILE,
            INIT_DFTTS_ENGINE_ERROR_NOAUDIODRIVER,
            INIT_DFTTS_ENGINE_ERROR_DICTNOTFOUND,
            INIT_DFTTS_ENGINE_ERROR_OTHER

        }

        public enum UninitDFTTSEngineReturnValue
        {

            UNINIT_DFTTS_ENGINE_SUCCESS,
            UNINIT_DFTTS_ENGINE_FAIL

        }

        public enum LoadDFTTSUserDictReturnValue
        {

            LOAD_USER_DICT_SUCCESS,
            LOAD_USER_DICT_ERROR_DICTIDX_NOT_VALID,
            LOAD_USER_DICT_ERROR_DICT_ALREADY_LOADED,
            LOAD_USER_DICT_ERROR_DICT_WORD_ALREADY_LOADED,
            LOAD_USER_DICT_ERROR_NO_DICT_FILE_OR_ENTRY,
            LOAD_USER_DICT_ERROR_INVALID_DICT_FILE,
            LOAD_USER_DICT_ERROR_INVALID_VOICE,
            LOAD_USER_DICT_ERROR_INVALID_ARG,
            LOAD_USER_DICT_ERROR_INVALID_PHONEME_SET,
            LOAD_USER_DICT_ERROR_INVALID_PHONEME,
            LOAD_USER_DICT_ERROR_INVALID_PARTOFSP,
            LOAD_USER_DICT_ERROR_DENIED,
            LOAD_USER_DICT_ERROR_OUTOFMEMORY,
            LOAD_USER_DICT_ERROR_INTERNAL,
            LOAD_USER_DICT_ERROR_OTHER

        }


        public enum UnloadDFTTSUserDictReturnValue
        {

            UNLOAD_USER_DICT_SUCCESS,
            UNLOAD_USER_DICT_ERROR_DICTIDX_NOT_VALID,
            UNLOAD_USER_DICT_ERROR_DICT_UNLOADED,
            UNLOAD_USER_DICT_ERROR_NO_DICT_FILE_OR_ENTRY,
            UNLOAD_USER_DICT_ERROR_INVALID_PARTOFSP,
            UNLOAD_USER_DICT_ERROR_INVALID_PHONEME_SET,
            UNLOAD_USER_DICT_ERROR_INTERNAL,
            UNLOAD_USER_DICT_ERROR_OTHER

        }

        public enum DFTTSTextType
        {

            DFTTS_TEXT_TYPE_PLAIN,
            DFTTS_TEXT_TYPE_XML

        }

        public enum DFTTSSpeakReturnValue
        {

            DFTTS_SPEAK_SUCCESS,
            DFTTS_SPEAK_ERROR_CHANNEL_MEM_FAIL,
            DFTTS_SPEAK_ERROR_TEXT_NULL,
            DFTTS_SPEAK_ERROR_TEXT_ZERO_LEN,
            DFTTS_SPEAK_ERROR_DB_NOT_LOADED,
            DFTTS_SPEAK_ERROR_SET_SOUND_CARD_FAIL,
            DFTTS_SPEAK_ERROR_UNIMPLEMENTED,
            DFTTS_SPEAK_ERROR_INTERNAL,
            DFTTS_SPEAK_ERROR_INVALID_PARAM,
            DFTTS_SPEAK_ERROR_INVALID_POINTER,
            DFTTS_SPEAK_ERROR_UNKNOWN_ENCODING,
            DFTTS_SPEAK_ERROR_OBJECT_NOT_FOUND,
            DFTTS_SPEAK_ERROR_INTERRUPTED,
            DFTTS_SPEAK_ERROR_INVALID_VOICE,
            DFTTS_SPEAK_ERROR_WRONG_EVENT,
            DFTTS_SPEAK_ERROR_ENGINE_INUSE,
            DFTTS_SPEAK_ERROR_NETWORK_ERROR,
            DFTTS_SPEAK_ERROR_INVALID_KEY,
            DFTTS_SPEAK_ERROR_QUEUE_FULL,
            DFTTS_SPEAK_ERROR_TOKEN_TIMEOUT,
            DFTTS_SPEAK_ERROR_FAILED,
            DFTTS_SPEAK_ERROR_INVALIDARG,
            DFTTS_SPEAK_ERROR_OUTOFMEMORY,
            DFTTS_SPEAK_ERROR_NOTIMPL,
            DFTTS_SPEAK_ERROR_ABORT,
            DFTTS_SPEAK_ERROR_UNKNOWN,
            DFTTS_SPEAK_ERROR_BADHANDLE,
            DFTTS_SPEAK_ERROR_EXCEPTION,
            DFTTS_SPEAK_ERROR_EMPTY,
            DFTTS_SPEAK_ERROR_FULL,
            DFTTS_SPEAK_ERROR_INVALIDSTATE,
            DFTTS_SPEAK_ERROR_BADVERSION,
            DFTTS_SPEAK_ERROR_INSUFFICIENT_BUFFER,
            DFTTS_SPEAK_ERROR_UNSUPPORTED,
            DFTTS_SPEAK_ERROR_NOLICENSE,
            DFTTS_SPEAK_ERROR_CREATECHILDPROCESS_FAILED,
            DFTTS_SPEAK_ERROR_NOENVIRONMENTPATH,
            DFTTS_SPEAK_ERROR_TIMEOUT,
            DFTTS_SPEAK_ERROR_OUTOFRESOURCES,
            DFTTS_SPEAK_ERROR_NOVOICES,
            DFTTS_SPEAK_ERROR_CREATEFAIL,
            DFTTS_SPEAK_ERROR_CONNECTFAIL,
            DFTTS_SPEAK_ERROR_BINDFAIL,
            DFTTS_SPEAK_ERROR_LISTENFAIL,
            DFTTS_SPEAK_ERROR_CONNECTIONCLOSED,
            DFTTS_SPEAK_ERROR_ACCEPTFAIL,
            DFTTS_SPEAK_ERROR_SOCKETTIMEOUT,
            DFTTS_SPEAK_ERROR_SOCKETERROR,
            DFTTS_SPEAK_ERROR_NOMORESERVERS,
            DFTTS_SPEAK_ERROR_SOCKET_EWOULDBLOCK,
            DFTTS_SPEAK_ERROR_SOCKET_EINPROGRESS,
            DFTTS_SPEAK_ERROR_SOCKET_EALREADY,
            DFTTS_SPEAK_ERROR_SOCKET_ENOTSOCK,
            DFTTS_SPEAK_ERROR_SOCKET_EDESTADDRREQ,
            DFTTS_SPEAK_ERROR_SOCKET_EMSGSIZE,
            DFTTS_SPEAK_ERROR_SOCKET_EPROTOTYPE,
            DFTTS_SPEAK_ERROR_SOCKET_ENOPROTOOPT,
            DFTTS_SPEAK_ERROR_SOCKET_EPROTONOSUPPORT,
            DFTTS_SPEAK_ERROR_SOCKET_ESOCKTNOSUPPORT,
            DFTTS_SPEAK_ERROR_SOCKET_EOPNOTSUPP,
            DFTTS_SPEAK_ERROR_SOCKET_EPFNOSUPPORT,
            DFTTS_SPEAK_ERROR_SOCKET_EAFNOSUPPORT,
            DFTTS_SPEAK_ERROR_SOCKET_EADDRINUSE,
            DFTTS_SPEAK_ERROR_SOCKET_EADDRNOTAVAIL,
            DFTTS_SPEAK_ERROR_SOCKET_ENETDOWN,
            DFTTS_SPEAK_ERROR_SOCKET_ENETUNREACH,
            DFTTS_SPEAK_ERROR_SOCKET_ENETRESET,
            DFTTS_SPEAK_ERROR_SOCKET_ECONNABORTED,
            DFTTS_SPEAK_ERROR_SOCKET_ECONNRESET,
            DFTTS_SPEAK_ERROR_SOCKET_ENOBUFS,
            DFTTS_SPEAK_ERROR_SOCKET_EISCONN,
            DFTTS_SPEAK_ERROR_SOCKET_ENOTCONN,
            DFTTS_SPEAK_ERROR_SOCKET_ESHUTDOWN,
            DFTTS_SPEAK_ERROR_SOCKET_ETOOMANYREFS,
            DFTTS_SPEAK_ERROR_SOCKET_ECONNREFUSED,
            DFTTS_SPEAK_ERROR_SOCKET_ELOOP,
            DFTTS_SPEAK_ERROR_SOCKET_ENAMETOOLONG,
            DFTTS_SPEAK_ERROR_SOCKET_EHOSTDOWN,
            DFTTS_SPEAK_ERROR_SOCKET_EHOSTUNREACH,
            DFTTS_SPEAK_ERROR_SOCKET_ENOTEMPTY,
            DFTTS_SPEAK_ERROR_SOCKET_EPROCLIM,
            DFTTS_SPEAK_ERROR_THREADSTARTED,
            DFTTS_SPEAK_ERROR_THREADNOTSTARTED,
            DFTTS_SPEAK_ERROR_THREADCOULDNOTCREATE,
            DFTTS_SPEAK_ERROR_BADNVFILE,
            DFTTS_SPEAK_ERROR_NOAUDIODRIVER,
            DFTTS_SPEAK_ERROR_DICTNOTFOUND,
            DFTTS_SPEAK_ERROR_ALREADYPLAYING,
            DFTTS_SPEAK_ERROR_AUDIOFORMATNOTSUPPORTED,
            DFTTS_SPEAK_ERROR_XML_INVALID,
            DFTTS_SPEAK_ERROR_WL_INVALID,
            DFTTS_SPEAK_ERROR_INVALIDPHONESET,
            DFTTS_SPEAK_ERROR_INVALIDPHONEME,
            DFTTS_SPEAK_ERROR_MSGQ_CREATEFAILED,
            DFTTS_SPEAK_ERROR_MSGQ_ALREADYEXISTS,
            DFTTS_SPEAK_ERROR_MSGQ_NOTFOUND,
            DFTTS_SPEAK_ERROR_MSGQ_INVALIDOP,
            DFTTS_SPEAK_ERROR_MSGQ_NOTOPEN,
            DFTTS_SPEAK_ERROR_MSGQ_LOCKFAILED,
            DFTTS_SPEAK_ERROR_MSGQ_ABANDONED,
            DFTTS_SPEAK_ERROR_MSGQ_OPENFAILED,
            DFTTS_SPEAK_ERROR_OTHER

        }


        public enum DFTTSPauseReturnValue
        {

            DFTTS_PAUSE_SUCCESS,
            DFTTS_PAUSE_ERROR_UNIMPLEMENTED,
            DFTTS_PAUSE_ERROR_INTERNAL,
            DFTTS_PAUSE_ERROR_INVALID_PARAM,
            DFTTS_PAUSE_ERROR_INVALID_POINTER,
            DFTTS_PAUSE_ERROR_OBJECT_NOT_FOUND,
            DFTTS_PAUSE_ERROR_UNKNOWN_ENCODING,
            DFTTS_PAUSE_ERROR_INTERRUPTED,
            DFTTS_PAUSE_ERROR_INVALID_VOICE,
            DFTTS_PAUSE_ERROR_WRONG_EVENT,
            DFTTS_PAUSE_ERROR_ENGINE_INUSE,
            DFTTS_PAUSE_ERROR_NETWORK_ERROR,
            DFTTS_PAUSE_ERROR_INVALID_KEY,
            DFTTS_PAUSE_ERROR_QUEUE_FULL,
            DFTTS_PAUSE_ERROR_TOKEN_TIMEOUT,
            DFTTS_PAUSE_ERROR_OTHER

        }


        public enum DFTTSResumeReturnValue
        {

            DFTTS_RESUME_SUCCESS,
            DFTTS_RESUME_ERROR_UNIMPLEMENTED,
            DFTTS_RESUME_ERROR_INTERNAL,
            DFTTS_RESUME_ERROR_INVALID_PARAM,
            DFTTS_RESUME_ERROR_INVALID_POINTER,
            DFTTS_RESUME_ERROR_OBJECT_NOT_FOUND,
            DFTTS_RESUME_ERROR_UNKNOWN_ENCODING,
            DFTTS_RESUME_ERROR_INTERRUPTED,
            DFTTS_RESUME_ERROR_INVALID_VOICE,
            DFTTS_RESUME_ERROR_WRONG_EVENT,
            DFTTS_RESUME_ERROR_ENGINE_INUSE,
            DFTTS_RESUME_ERROR_NETWORK_ERROR,
            DFTTS_RESUME_ERROR_INVALID_KEY,
            DFTTS_RESUME_ERROR_QUEUE_FULL,
            DFTTS_RESUME_ERROR_TOKEN_TIMEOUT,
            DFTTS_RESUME_ERROR_FAILED,
            DFTTS_RESUME_ERROR_INVALIDARG,
            DFTTS_RESUME_ERROR_OUTOFMEMORY,
            DFTTS_RESUME_ERROR_NOTIMPL,
            DFTTS_RESUME_ERROR_ABORT,
            DFTTS_RESUME_ERROR_UNKNOWN,
            DFTTS_RESUME_ERROR_BADHANDLE,
            DFTTS_RESUME_ERROR_EXCEPTION,
            DFTTS_RESUME_ERROR_EMPTY,
            DFTTS_RESUME_ERROR_FULL,
            DFTTS_RESUME_ERROR_INVALIDSTATE,
            DFTTS_RESUME_ERROR_BADVERSION,
            DFTTS_RESUME_ERROR_INSUFFICIENT_BUFFER,
            DFTTS_RESUME_ERROR_UNSUPPORTED,
            DFTTS_RESUME_ERROR_NOLICENSE,
            DFTTS_RESUME_ERROR_CREATECHILDPROCESS_FAILED,
            DFTTS_RESUME_ERROR_NOENVIRONMENTPATH,
            DFTTS_RESUME_ERROR_TIMEOUT,
            DFTTS_RESUME_ERROR_OUTOFRESOURCES,
            DFTTS_RESUME_ERROR_NOVOICES,
            DFTTS_RESUME_ERROR_CREATEFAIL,
            DFTTS_RESUME_ERROR_CONNECTFAIL,
            DFTTS_RESUME_ERROR_BINDFAIL,
            DFTTS_RESUME_ERROR_LISTENFAIL,
            DFTTS_RESUME_ERROR_CONNECTIONCLOSED,
            DFTTS_RESUME_ERROR_ACCEPTFAIL,
            DFTTS_RESUME_ERROR_SOCKETTIMEOUT,
            DFTTS_RESUME_ERROR_SOCKETERROR,
            DFTTS_RESUME_ERROR_NOMORESERVERS,
            DFTTS_RESUME_ERROR_SOCKET_EWOULDBLOCK,
            DFTTS_RESUME_ERROR_SOCKET_EINPROGRESS,
            DFTTS_RESUME_ERROR_SOCKET_EALREADY,
            DFTTS_RESUME_ERROR_SOCKET_ENOTSOCK,
            DFTTS_RESUME_ERROR_SOCKET_EDESTADDRREQ,
            DFTTS_RESUME_ERROR_SOCKET_EMSGSIZE,
            DFTTS_RESUME_ERROR_SOCKET_EPROTOTYPE,
            DFTTS_RESUME_ERROR_SOCKET_ENOPROTOOPT,
            DFTTS_RESUME_ERROR_SOCKET_EPROTONOSUPPORT,
            DFTTS_RESUME_ERROR_SOCKET_ESOCKTNOSUPPORT,
            DFTTS_RESUME_ERROR_SOCKET_EOPNOTSUPP,
            DFTTS_RESUME_ERROR_SOCKET_EPFNOSUPPORT,
            DFTTS_RESUME_ERROR_SOCKET_EAFNOSUPPORT,
            DFTTS_RESUME_ERROR_SOCKET_EADDRINUSE,
            DFTTS_RESUME_ERROR_SOCKET_EADDRNOTAVAIL,
            DFTTS_RESUME_ERROR_SOCKET_ENETDOWN,
            DFTTS_RESUME_ERROR_SOCKET_ENETUNREACH,
            DFTTS_RESUME_ERROR_SOCKET_ENETRESET,
            DFTTS_RESUME_ERROR_SOCKET_ECONNABORTED,
            DFTTS_RESUME_ERROR_SOCKET_ECONNRESET,
            DFTTS_RESUME_ERROR_SOCKET_ENOBUFS,
            DFTTS_RESUME_ERROR_SOCKET_EISCONN,
            DFTTS_RESUME_ERROR_SOCKET_ENOTCONN,
            DFTTS_RESUME_ERROR_SOCKET_ESHUTDOWN,
            DFTTS_RESUME_ERROR_SOCKET_ETOOMANYREFS,
            DFTTS_RESUME_ERROR_SOCKET_ECONNREFUSED,
            DFTTS_RESUME_ERROR_SOCKET_ELOOP,
            DFTTS_RESUME_ERROR_SOCKET_ENAMETOOLONG,
            DFTTS_RESUME_ERROR_SOCKET_EHOSTDOWN,
            DFTTS_RESUME_ERROR_SOCKET_EHOSTUNREACH,
            DFTTS_RESUME_ERROR_SOCKET_ENOTEMPTY,
            DFTTS_RESUME_ERROR_SOCKET_EPROCLIM,
            DFTTS_RESUME_ERROR_THREADSTARTED,
            DFTTS_RESUME_ERROR_THREADNOTSTARTED,
            DFTTS_RESUME_ERROR_THREADCOULDNOTCREATE,
            DFTTS_RESUME_ERROR_BADNVFILE,
            DFTTS_RESUME_ERROR_NOAUDIODRIVER,
            DFTTS_RESUME_ERROR_DICTNOTFOUND,
            DFTTS_RESUME_ERROR_ALREADYPLAYING,
            DFTTS_RESUME_ERROR_AUDIOFORMATNOTSUPPORTED,
            DFTTS_RESUME_ERROR_XML_INVALID,
            DFTTS_RESUME_ERROR_WL_INVALID,
            DFTTS_RESUME_ERROR_INVALIDPHONESET,
            DFTTS_RESUME_ERROR_INVALIDPHONEME,
            DFTTS_RESUME_ERROR_MSGQ_CREATEFAILED,
            DFTTS_RESUME_ERROR_MSGQ_ALREADYEXISTS,
            DFTTS_RESUME_ERROR_MSGQ_NOTFOUND,
            DFTTS_RESUME_ERROR_MSGQ_INVALIDOP,
            DFTTS_RESUME_ERROR_MSGQ_NOTOPEN,
            DFTTS_RESUME_ERROR_MSGQ_LOCKFAILED,
            DFTTS_RESUME_ERROR_MSGQ_ABANDONED,
            DFTTS_RESUME_ERROR_MSGQ_OPENFAILED,
            DFTTS_RESUME_ERROR_NOTHING_TO_RESUME,
            DFTTS_RESUME_ERROR_OTHER


        }

        public enum DFTTSStopReturnValue
        {

            DFTTS_STOP_SUCCESS,
            DFTTS_STOP_ERROR_INVALID_POINTER,
            DFTTS_STOP_ERROR_INVALID_ARG,
            DFTTS_STOP_ERROR_OUT_OF_MEMORY,
            DFTTS_STOP_ERROR_INVALID_FLAGS,
            DFTTS_STOP_ERROR_ENGINE_INUSE,
            DFTTS_STOP_ERROR_OTHER

        }

        public enum DFTTSExportReturnValue
        {

            DFTTS_EXPORT_SUCCESS,
            DFTTS_EXPORT_ERROR_FORMAT_NOT_SUPPORTED,
            DFTTS_EXPORT_ERROR_CHANNEL_MEM_FAIL,
            DFTTS_EXPORT_ERROR_TEXT_NULL,
            DFTTS_EXPORT_ERROR_TEXT_ZERO_LEN,
            DFTTS_EXPORT_ERROR_DB_NOT_LOADED,
            DFTTS_EXPORT_ERROR_GEN_FILE_FAIL,
            DFTTS_EXPORT_ERROR_BUFFER_NULL,
            DFTTS_EXPORT_ERROR_THREAD_IN_USE,
            DFTTS_EXPORT_ERROR_UNIMPLEMENTED,
            DFTTS_EXPORT_ERROR_INTERNAL,
            DFTTS_EXPORT_ERROR_INVALID_PARAM,
            DFTTS_EXPORT_ERROR_INVALID_POINTER,
            DFTTS_EXPORT_ERROR_OBJECT_NOT_FOUND,
            DFTTS_EXPORT_ERROR_UNKNOWN_ENCODING,
            DFTTS_EXPORT_ERROR_INTERRUPTED,
            DFTTS_EXPORT_ERROR_INVALID_VOICE,
            DFTTS_EXPORT_ERROR_WRONG_EVENT,
            DFTTS_EXPORT_ERROR_ENGINE_INUSE,
            DFTTS_EXPORT_ERROR_NETWORK_ERROR,
            DFTTS_EXPORT_ERROR_INVALID_KEY,
            DFTTS_EXPORT_ERROR_QUEUE_FULL,
            DFTTS_EXPORT_ERROR_TOKEN_TIMEOUT,
            DFTTS_EXPORT_ERROR_FAILED,
            DFTTS_EXPORT_ERROR_INVALIDARG,
            DFTTS_EXPORT_ERROR_OUTOFMEMORY,
            DFTTS_EXPORT_ERROR_NOTIMPL,
            DFTTS_EXPORT_ERROR_ABORT,
            DFTTS_EXPORT_ERROR_UNKNOWN,
            DFTTS_EXPORT_ERROR_BADHANDLE,
            DFTTS_EXPORT_ERROR_EXCEPTION,
            DFTTS_EXPORT_ERROR_EMPTY,
            DFTTS_EXPORT_ERROR_FULL,
            DFTTS_EXPORT_ERROR_INVALIDSTATE,
            DFTTS_EXPORT_ERROR_BADVERSION,
            DFTTS_EXPORT_ERROR_INSUFFICIENT_BUFFER,
            DFTTS_EXPORT_ERROR_UNSUPPORTED,
            DFTTS_EXPORT_ERROR_NOLICENSE,
            DFTTS_EXPORT_ERROR_CREATECHILDPROCESS_FAILED,
            DFTTS_EXPORT_ERROR_NOENVIRONMENTPATH,
            DFTTS_EXPORT_ERROR_TIMEOUT,
            DFTTS_EXPORT_ERROR_OUTOFRESOURCES,
            DFTTS_EXPORT_ERROR_NOVOICES,
            DFTTS_EXPORT_ERROR_CREATEFAIL,
            DFTTS_EXPORT_ERROR_CONNECTFAIL,
            DFTTS_EXPORT_ERROR_BINDFAIL,
            DFTTS_EXPORT_ERROR_LISTENFAIL,
            DFTTS_EXPORT_ERROR_CONNECTIONCLOSED,
            DFTTS_EXPORT_ERROR_ACCEPTFAIL,
            DFTTS_EXPORT_ERROR_SOCKETTIMEOUT,
            DFTTS_EXPORT_ERROR_SOCKETERROR,
            DFTTS_EXPORT_ERROR_NOMORESERVERS,
            DFTTS_EXPORT_ERROR_SOCKET_EWOULDBLOCK,
            DFTTS_EXPORT_ERROR_SOCKET_EINPROGRESS,
            DFTTS_EXPORT_ERROR_SOCKET_EALREADY,
            DFTTS_EXPORT_ERROR_SOCKET_ENOTSOCK,
            DFTTS_EXPORT_ERROR_SOCKET_EDESTADDRREQ,
            DFTTS_EXPORT_ERROR_SOCKET_EMSGSIZE,
            DFTTS_EXPORT_ERROR_SOCKET_EPROTOTYPE,
            DFTTS_EXPORT_ERROR_SOCKET_ENOPROTOOPT,
            DFTTS_EXPORT_ERROR_SOCKET_EPROTONOSUPPORT,
            DFTTS_EXPORT_ERROR_SOCKET_ESOCKTNOSUPPORT,
            DFTTS_EXPORT_ERROR_SOCKET_EOPNOTSUPP,
            DFTTS_EXPORT_ERROR_SOCKET_EPFNOSUPPORT,
            DFTTS_EXPORT_ERROR_SOCKET_EAFNOSUPPORT,
            DFTTS_EXPORT_ERROR_SOCKET_EADDRINUSE,
            DFTTS_EXPORT_ERROR_SOCKET_EADDRNOTAVAIL,
            DFTTS_EXPORT_ERROR_SOCKET_ENETDOWN,
            DFTTS_EXPORT_ERROR_SOCKET_ENETUNREACH,
            DFTTS_EXPORT_ERROR_SOCKET_ENETRESET,
            DFTTS_EXPORT_ERROR_SOCKET_ECONNABORTED,
            DFTTS_EXPORT_ERROR_SOCKET_ECONNRESET,
            DFTTS_EXPORT_ERROR_SOCKET_ENOBUFS,
            DFTTS_EXPORT_ERROR_SOCKET_EISCONN,
            DFTTS_EXPORT_ERROR_SOCKET_ENOTCONN,
            DFTTS_EXPORT_ERROR_SOCKET_ESHUTDOWN,
            DFTTS_EXPORT_ERROR_SOCKET_ETOOMANYREFS,
            DFTTS_EXPORT_ERROR_SOCKET_ECONNREFUSED,
            DFTTS_EXPORT_ERROR_SOCKET_ELOOP,
            DFTTS_EXPORT_ERROR_SOCKET_ENAMETOOLONG,
            DFTTS_EXPORT_ERROR_SOCKET_EHOSTDOWN,
            DFTTS_EXPORT_ERROR_SOCKET_EHOSTUNREACH,
            DFTTS_EXPORT_ERROR_SOCKET_ENOTEMPTY,
            DFTTS_EXPORT_ERROR_SOCKET_EPROCLIM,
            DFTTS_EXPORT_ERROR_THREADSTARTED,
            DFTTS_EXPORT_ERROR_THREADNOTSTARTED,
            DFTTS_EXPORT_ERROR_THREADCOULDNOTCREATE,
            DFTTS_EXPORT_ERROR_BADNVFILE,
            DFTTS_EXPORT_ERROR_NOAUDIODRIVER,
            DFTTS_EXPORT_ERROR_DICTNOTFOUND,
            DFTTS_EXPORT_ERROR_ALREADYPLAYING,
            DFTTS_EXPORT_ERROR_AUDIOFORMATNOTSUPPORTED,
            DFTTS_EXPORT_ERROR_XML_INVALID,
            DFTTS_EXPORT_ERROR_WL_INVALID,
            DFTTS_EXPORT_ERROR_INVALIDPHONESET,
            DFTTS_EXPORT_ERROR_INVALIDPHONEME,
            DFTTS_EXPORT_ERROR_MSGQ_CREATEFAILED,
            DFTTS_EXPORT_ERROR_MSGQ_ALREADYEXISTS,
            DFTTS_EXPORT_ERROR_MSGQ_NOTFOUND,
            DFTTS_EXPORT_ERROR_MSGQ_INVALIDOP,
            DFTTS_EXPORT_ERROR_MSGQ_NOTOPEN,
            DFTTS_EXPORT_ERROR_MSGQ_LOCKFAILED,
            DFTTS_EXPORT_ERROR_MSGQ_ABANDONED,
            DFTTS_EXPORT_ERROR_MSGQ_OPENFAILED,
            DFTTS_EXPORT_ERROR_OTHER

        }

        public enum DFTTSVoiceInfoReturnValue
        {

            GET_DFTTS_VI_SUCCESS,
            GET_DFTTS_VI_NO_MORE_ITEMS,
            GET_DFTTS_VI_ERROR_BUFFER_TOO_SMALL,
            GET_DFTTS_VI_ERROR_OTHER

        }

        //
        //  Language IDs.
        //
        //  The following two combinations of primary language ID and
        //  sublanguage ID have special semantics:
        //
        //    Primary Language ID   Sublanguage ID      Result
        //    -------------------   ---------------     ------------------------
        //    LANG_NEUTRAL          SUBLANG_NEUTRAL     Language neutral
        //    LANG_NEUTRAL          SUBLANG_DEFAULT     User default language
        //    LANG_NEUTRAL          SUBLANG_SYS_DEFAULT System default language
        //    LANG_INVARIANT        SUBLANG_NEUTRAL     Invariant locale
        //

        //
        //  Primary language IDs.
        //

        public const int LANG_NEUTRAL = 0;
        public const int LANG_INVARIANT = 127;

        public const int LANG_AFRIKAANS = 54;
        public const int LANG_ALBANIAN = 28;
        public const int LANG_ALSATIAN = 132;
        public const int LANG_AMHARIC = 94;
        public const int LANG_ARABIC = 1;
        public const int LANG_ARMENIAN = 43;
        public const int LANG_ASSAMESE = 77;
        public const int LANG_AZERI = 44;
        public const int LANG_BASHKIR = 109;
        public const int LANG_BASQUE = 45;
        public const int LANG_BELARUSIAN = 35;
        public const int LANG_BENGALI = 69;
        public const int LANG_BRETON = 126;
        // Use with SUBLANG_BOSNIAN_* Sublanguage IDs
        public const int LANG_BOSNIAN = 26;
        // Use with the ConvertDefaultLocale function
        public const int LANG_BOSNIAN_NEUTRAL = 30746;
        public const int LANG_BULGARIAN = 2;
        public const int LANG_CATALAN = 3;
        // Use with SUBLANG_CHINESE_* Sublanguage IDs
        public const int LANG_CHINESE = 4;
        // Use with the ConvertDefaultLocale function
        public const int LANG_CHINESE_SIMPLIFIED = 4;
        // Use with the ConvertDefaultLocale function
        public const int LANG_CHINESE_TRADITIONAL = 31748;
        public const int LANG_CORSICAN = 131;
        public const int LANG_CROATIAN = 26;
        public const int LANG_CZECH = 5;
        public const int LANG_DANISH = 6;
        public const int LANG_DARI = 140;
        public const int LANG_DIVEHI = 101;
        public const int LANG_DUTCH = 19;
        public const int LANG_ENGLISH = 9;
        public const int LANG_ESTONIAN = 37;
        public const int LANG_FAEROESE = 56;
        // Deprecated: use LANG_PERSIAN instead
        public const int LANG_FARSI = 41;
        public const int LANG_FILIPINO = 100;
        public const int LANG_FINNISH = 11;
        public const int LANG_FRENCH = 12;
        public const int LANG_FRISIAN = 98;
        public const int LANG_GALICIAN = 86;
        public const int LANG_GEORGIAN = 55;
        public const int LANG_GERMAN = 7;
        public const int LANG_GREEK = 8;
        public const int LANG_GREENLANDIC = 111;
        public const int LANG_GUJARATI = 71;
        public const int LANG_HAUSA = 104;
        public const int LANG_HEBREW = 13;
        public const int LANG_HINDI = 57;
        public const int LANG_HUNGARIAN = 14;
        public const int LANG_ICELANDIC = 15;
        public const int LANG_IGBO = 112;
        public const int LANG_INDONESIAN = 33;
        public const int LANG_INUKTITUT = 93;
        // Use with the SUBLANG_IRISH_IRELAND Sublanguage ID
        public const int LANG_IRISH = 60;
        public const int LANG_ITALIAN = 16;
        public const int LANG_JAPANESE = 17;
        public const int LANG_KANNADA = 75;
        public const int LANG_KASHMIRI = 96;
        public const int LANG_KAZAK = 63;
        public const int LANG_KHMER = 83;
        public const int LANG_KICHE = 134;
        public const int LANG_KINYARWANDA = 135;
        public const int LANG_KONKANI = 87;
        public const int LANG_KOREAN = 18;
        public const int LANG_KYRGYZ = 64;
        public const int LANG_LAO = 84;
        public const int LANG_LATVIAN = 38;
        public const int LANG_LITHUANIAN = 39;
        public const int LANG_LOWER_SORBIAN = 46;
        public const int LANG_LUXEMBOURGISH = 110;
        // the Former Yugoslav Republic of Macedonia
        public const int LANG_MACEDONIAN = 47;
        public const int LANG_MALAY = 62;
        public const int LANG_MALAYALAM = 76;
        public const int LANG_MALTESE = 58;
        public const int LANG_MANIPURI = 88;
        public const int LANG_MAORI = 129;
        public const int LANG_MAPUDUNGUN = 122;
        public const int LANG_MARATHI = 78;
        public const int LANG_MOHAWK = 124;
        public const int LANG_MONGOLIAN = 80;
        public const int LANG_NEPALI = 97;
        public const int LANG_NORWEGIAN = 20;
        public const int LANG_OCCITAN = 130;
        public const int LANG_ORIYA = 72;
        public const int LANG_PASHTO = 99;
        public const int LANG_PERSIAN = 41;
        public const int LANG_POLISH = 21;
        public const int LANG_PORTUGUESE = 22;
        public const int LANG_PUNJABI = 70;
        public const int LANG_QUECHUA = 107;
        public const int LANG_ROMANIAN = 24;
        public const int LANG_ROMANSH = 23;
        public const int LANG_RUSSIAN = 25;
        public const int LANG_SAMI = 59;
        public const int LANG_SANSKRIT = 79;
        // Use with the SUBLANG_SERBIAN_* Sublanguage IDs
        public const int LANG_SERBIAN = 26;
        // Use with the ConvertDefaultLocale function
        public const int LANG_SERBIAN_NEUTRAL = 31770;
        public const int LANG_SINDHI = 89;
        public const int LANG_SINHALESE = 91;
        public const int LANG_SLOVAK = 27;
        public const int LANG_SLOVENIAN = 36;
        public const int LANG_SOTHO = 108;
        public const int LANG_SPANISH = 10;
        public const int LANG_SWAHILI = 65;
        public const int LANG_SWEDISH = 29;
        public const int LANG_SYRIAC = 90;
        public const int LANG_TAJIK = 40;
        public const int LANG_TAMAZIGHT = 95;
        public const int LANG_TAMIL = 73;
        public const int LANG_TATAR = 68;
        public const int LANG_TELUGU = 74;
        public const int LANG_THAI = 30;
        public const int LANG_TIBETAN = 81;
        public const int LANG_TIGRIGNA = 115;
        public const int LANG_TSWANA = 50;
        public const int LANG_TURKISH = 31;
        public const int LANG_TURKMEN = 66;
        public const int LANG_UIGHUR = 128;
        public const int LANG_UKRAINIAN = 34;
        public const int LANG_UPPER_SORBIAN = 46;
        public const int LANG_URDU = 32;
        public const int LANG_UZBEK = 67;
        public const int LANG_VIETNAMESE = 42;
        public const int LANG_WELSH = 82;
        public const int LANG_WOLOF = 136;
        public const int LANG_XHOSA = 52;
        public const int LANG_YAKUT = 133;
        public const int LANG_YI = 120;
        public const int LANG_YORUBA = 106;
        public const int LANG_ZULU = 53;

        //
        //  Sublanguage IDs.
        //
        //  The name immediately following SUBLANG_ dictates which primary
        //  language ID that sublanguage ID can be combined with to form a
        //  valid language ID.
        //

        // language neutral
        public const int SUBLANG_NEUTRAL = 0;
        // user default
        public const int SUBLANG_DEFAULT = 1;
        // system default
        public const int SUBLANG_SYS_DEFAULT = 2;
        // default custom language/locale
        public const int SUBLANG_CUSTOM_DEFAULT = 3;
        // custom language/locale
        public const int SUBLANG_CUSTOM_UNSPECIFIED = 4;
        // Default custom MUI language/locale
        public const int SUBLANG_UI_CUSTOM_DEFAULT = 5;


        // Afrikaans (South Africa) = &H0436 af-ZA
        public const int SUBLANG_AFRIKAANS_SOUTH_AFRICA = 1;
        // Albanian (Albania) = &H041c sq-AL
        public const int SUBLANG_ALBANIAN_ALBANIA = 1;
        // Alsatian (France) = &H0484
        public const int SUBLANG_ALSATIAN_FRANCE = 1;
        // Amharic (Ethiopia) = &H045e
        public const int SUBLANG_AMHARIC_ETHIOPIA = 1;
        // Arabic (Saudi Arabia)
        public const int SUBLANG_ARABIC_SAUDI_ARABIA = 1;
        // Arabic (Iraq)
        public const int SUBLANG_ARABIC_IRAQ = 2;
        // Arabic (Egypt)
        public const int SUBLANG_ARABIC_EGYPT = 3;
        // Arabic (Libya)
        public const int SUBLANG_ARABIC_LIBYA = 4;
        // Arabic (Algeria)
        public const int SUBLANG_ARABIC_ALGERIA = 5;
        // Arabic (Morocco)
        public const int SUBLANG_ARABIC_MOROCCO = 6;
        // Arabic (Tunisia)
        public const int SUBLANG_ARABIC_TUNISIA = 7;
        // Arabic (Oman)
        public const int SUBLANG_ARABIC_OMAN = 8;
        // Arabic (Yemen)
        public const int SUBLANG_ARABIC_YEMEN = 9;
        // Arabic (Syria)
        public const int SUBLANG_ARABIC_SYRIA = 10;
        // Arabic (Jordan)
        public const int SUBLANG_ARABIC_JORDAN = 11;
        // Arabic (Lebanon)
        public const int SUBLANG_ARABIC_LEBANON = 12;
        // Arabic (Kuwait)
        public const int SUBLANG_ARABIC_KUWAIT = 13;
        // Arabic (U.A.E)
        public const int SUBLANG_ARABIC_UAE = 14;
        // Arabic (Bahrain)
        public const int SUBLANG_ARABIC_BAHRAIN = 15;
        // Arabic (Qatar)
        public const int SUBLANG_ARABIC_QATAR = 16;
        // Armenian (Armenia) = &H042b hy-AM
        public const int SUBLANG_ARMENIAN_ARMENIA = 1;
        // Assamese (India) = &H044d
        public const int SUBLANG_ASSAMESE_INDIA = 1;
        // Azeri (Latin)
        public const int SUBLANG_AZERI_LATIN = 1;
        // Azeri (Cyrillic)
        public const int SUBLANG_AZERI_CYRILLIC = 2;
        // Bashkir (Russia) = &H046d ba-RU
        public const int SUBLANG_BASHKIR_RUSSIA = 1;
        // Basque (Basque) = &H042d eu-ES
        public const int SUBLANG_BASQUE_BASQUE = 1;
        // Belarusian (Belarus) = &H0423 be-BY
        public const int SUBLANG_BELARUSIAN_BELARUS = 1;
        // Bengali (India)
        public const int SUBLANG_BENGALI_INDIA = 1;
        // Bengali (Bangladesh)
        public const int SUBLANG_BENGALI_BANGLADESH = 2;
        // Bosnian (Bosnia and Herzegovina - Latin) = &H141a bs-BA-Latn
        public const int SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN = 5;
        // Bosnian (Bosnia and Herzegovina - Cyrillic) = &H201a bs-BA-Cyrl
        public const int SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC = 8;
        // Breton (France) = &H047e
        public const int SUBLANG_BRETON_FRANCE = 1;
        // Bulgarian (Bulgaria) = &H0402
        public const int SUBLANG_BULGARIAN_BULGARIA = 1;
        // Catalan (Catalan) = &H0403
        public const int SUBLANG_CATALAN_CATALAN = 1;
        // Chinese (Taiwan) = &H0404 zh-TW
        public const int SUBLANG_CHINESE_TRADITIONAL = 1;
        // Chinese (PR China) = &H0804 zh-CN
        public const int SUBLANG_CHINESE_SIMPLIFIED = 2;
        // Chinese (Hong Kong S.A.R., P.R.C.) = &H0c04 zh-HK
        public const int SUBLANG_CHINESE_HONGKONG = 3;
        // Chinese (Singapore) = &H1004 zh-SG
        public const int SUBLANG_CHINESE_SINGAPORE = 4;
        // Chinese (Macau S.A.R.) = &H1404 zh-MO
        public const int SUBLANG_CHINESE_MACAU = 5;
        // Corsican (France) = &H0483
        public const int SUBLANG_CORSICAN_FRANCE = 1;
        // Czech (Czech Republic) = &H0405
        public const int SUBLANG_CZECH_CZECH_REPUBLIC = 1;
        // Croatian (Croatia)
        public const int SUBLANG_CROATIAN_CROATIA = 1;
        // Croatian (Bosnia and Herzegovina - Latin) = &H101a hr-BA
        public const int SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN = 4;
        // Danish (Denmark) = &H0406
        public const int SUBLANG_DANISH_DENMARK = 1;
        // Dari (Afghanistan)
        public const int SUBLANG_DARI_AFGHANISTAN = 1;
        // Divehi (Maldives) = &H0465 div-MV
        public const int SUBLANG_DIVEHI_MALDIVES = 1;
        // Dutch
        public const int SUBLANG_DUTCH = 1;
        // Dutch (Belgian)
        public const int SUBLANG_DUTCH_BELGIAN = 2;
        // English (USA)
        public const int SUBLANG_ENGLISH_US = 1;
        // English (UK)
        public const int SUBLANG_ENGLISH_UK = 2;
        // English (Australian)
        public const int SUBLANG_ENGLISH_AUS = 3;
        // English (Canadian)
        public const int SUBLANG_ENGLISH_CAN = 4;
        // English (New Zealand)
        public const int SUBLANG_ENGLISH_NZ = 5;
        // English (Irish)
        public const int SUBLANG_ENGLISH_EIRE = 6;
        // English (South Africa)
        public const int SUBLANG_ENGLISH_SOUTH_AFRICA = 7;
        // English (Jamaica)
        public const int SUBLANG_ENGLISH_JAMAICA = 8;
        // English (Caribbean)
        public const int SUBLANG_ENGLISH_CARIBBEAN = 9;
        // English (Belize)
        public const int SUBLANG_ENGLISH_BELIZE = 10;
        // English (Trinidad)
        public const int SUBLANG_ENGLISH_TRINIDAD = 11;
        // English (Zimbabwe)
        public const int SUBLANG_ENGLISH_ZIMBABWE = 12;
        // English (Philippines)
        public const int SUBLANG_ENGLISH_PHILIPPINES = 13;
        // English (India)
        public const int SUBLANG_ENGLISH_INDIA = 16;
        // English (Malaysia)
        public const int SUBLANG_ENGLISH_MALAYSIA = 17;
        // English (Singapore)
        public const int SUBLANG_ENGLISH_SINGAPORE = 18;
        // Estonian (Estonia) = &H0425 et-EE
        public const int SUBLANG_ESTONIAN_ESTONIA = 1;
        // Faroese (Faroe Islands) = &H0438 fo-FO
        public const int SUBLANG_FAEROESE_FAROE_ISLANDS = 1;
        // Filipino (Philippines) = &H0464 fil-PH
        public const int SUBLANG_FILIPINO_PHILIPPINES = 1;
        // Finnish (Finland) = &H040b
        public const int SUBLANG_FINNISH_FINLAND = 1;
        // French
        public const int SUBLANG_FRENCH = 1;
        // French (Belgian)
        public const int SUBLANG_FRENCH_BELGIAN = 2;
        // French (Canadian)
        public const int SUBLANG_FRENCH_CANADIAN = 3;
        // French (Swiss)
        public const int SUBLANG_FRENCH_SWISS = 4;
        // French (Luxembourg)
        public const int SUBLANG_FRENCH_LUXEMBOURG = 5;
        // French (Monaco)
        public const int SUBLANG_FRENCH_MONACO = 6;
        // Frisian (Netherlands) = &H0462 fy-NL
        public const int SUBLANG_FRISIAN_NETHERLANDS = 1;
        // Galician (Galician) = &H0456 gl-ES
        public const int SUBLANG_GALICIAN_GALICIAN = 1;
        // Georgian (Georgia) = &H0437 ka-GE
        public const int SUBLANG_GEORGIAN_GEORGIA = 1;
        // German
        public const int SUBLANG_GERMAN = 1;
        // German (Swiss)
        public const int SUBLANG_GERMAN_SWISS = 2;
        // German (Austrian)
        public const int SUBLANG_GERMAN_AUSTRIAN = 3;
        // German (Luxembourg)
        public const int SUBLANG_GERMAN_LUXEMBOURG = 4;
        // German (Liechtenstein)
        public const int SUBLANG_GERMAN_LIECHTENSTEIN = 5;
        // Greek (Greece)
        public const int SUBLANG_GREEK_GREECE = 1;
        // Greenlandic (Greenland) = &H046f kl-GL
        public const int SUBLANG_GREENLANDIC_GREENLAND = 1;
        // Gujarati (India (Gujarati Script)) = &H0447 gu-IN
        public const int SUBLANG_GUJARATI_INDIA = 1;
        // Hausa (Latin, Nigeria) = &H0468 ha-NG-Latn
        public const int SUBLANG_HAUSA_NIGERIA_LATIN = 1;
        // Hebrew (Israel) = &H040d
        public const int SUBLANG_HEBREW_ISRAEL = 1;
        // Hindi (India) = &H0439 hi-IN
        public const int SUBLANG_HINDI_INDIA = 1;
        // Hungarian (Hungary) = &H040e
        public const int SUBLANG_HUNGARIAN_HUNGARY = 1;
        // Icelandic (Iceland) = &H040f
        public const int SUBLANG_ICELANDIC_ICELAND = 1;
        // Igbo (Nigeria) = &H0470 ig-NG
        public const int SUBLANG_IGBO_NIGERIA = 1;
        // Indonesian (Indonesia) = &H0421 id-ID
        public const int SUBLANG_INDONESIAN_INDONESIA = 1;
        // Inuktitut (Syllabics) (Canada) = &H045d iu-CA-Cans
        public const int SUBLANG_INUKTITUT_CANADA = 1;
        // Inuktitut (Canada - Latin)
        public const int SUBLANG_INUKTITUT_CANADA_LATIN = 2;
        // Irish (Ireland)
        public const int SUBLANG_IRISH_IRELAND = 2;
        // Italian
        public const int SUBLANG_ITALIAN = 1;
        // Italian (Swiss)
        public const int SUBLANG_ITALIAN_SWISS = 2;
        // Japanese (Japan) = &H0411
        public const int SUBLANG_JAPANESE_JAPAN = 1;
        // Kannada (India (Kannada Script)) = &H044b kn-IN
        public const int SUBLANG_KANNADA_INDIA = 1;
        // Kashmiri (South Asia)
        public const int SUBLANG_KASHMIRI_SASIA = 2;
        // For app compatibility only
        public const int SUBLANG_KASHMIRI_INDIA = 2;
        // Kazakh (Kazakhstan) = &H043f kk-KZ
        public const int SUBLANG_KAZAK_KAZAKHSTAN = 1;
        // Khmer (Cambodia) = &H0453 kh-KH
        public const int SUBLANG_KHMER_CAMBODIA = 1;
        // K'iche (Guatemala)
        public const int SUBLANG_KICHE_GUATEMALA = 1;
        // Kinyarwanda (Rwanda) = &H0487 rw-RW
        public const int SUBLANG_KINYARWANDA_RWANDA = 1;
        // Konkani (India) = &H0457 kok-IN
        public const int SUBLANG_KONKANI_INDIA = 1;
        // Korean (Extended Wansung)
        public const int SUBLANG_KOREAN = 1;
        // Kyrgyz (Kyrgyzstan) = &H0440 ky-KG
        public const int SUBLANG_KYRGYZ_KYRGYZSTAN = 1;
        // Lao (Lao PDR) = &H0454 lo-LA
        public const int SUBLANG_LAO_LAO = 1;
        // Latvian (Latvia) = &H0426 lv-LV
        public const int SUBLANG_LATVIAN_LATVIA = 1;
        // Lithuanian
        public const int SUBLANG_LITHUANIAN = 1;
        // Lower Sorbian (Germany) = &H082e wee-DE
        public const int SUBLANG_LOWER_SORBIAN_GERMANY = 2;
        // Luxembourgish (Luxembourg) = &H046e lb-LU
        public const int SUBLANG_LUXEMBOURGISH_LUXEMBOURG = 1;
        // Macedonian (Macedonia (FYROM)) = &H042f mk-MK
        public const int SUBLANG_MACEDONIAN_MACEDONIA = 1;
        // Malay (Malaysia)
        public const int SUBLANG_MALAY_MALAYSIA = 1;
        // Malay (Brunei Darussalam)
        public const int SUBLANG_MALAY_BRUNEI_DARUSSALAM = 2;
        // Malayalam (India (Malayalam Script) ) = &H044c ml-IN
        public const int SUBLANG_MALAYALAM_INDIA = 1;
        // Maltese (Malta) = &H043a mt-MT
        public const int SUBLANG_MALTESE_MALTA = 1;
        // Maori (New Zealand) = &H0481 mi-NZ
        public const int SUBLANG_MAORI_NEW_ZEALAND = 1;
        // Mapudungun (Chile) = &H047a arn-CL
        public const int SUBLANG_MAPUDUNGUN_CHILE = 1;
        // Marathi (India) = &H044e mr-IN
        public const int SUBLANG_MARATHI_INDIA = 1;
        // Mohawk (Mohawk) = &H047c moh-CA
        public const int SUBLANG_MOHAWK_MOHAWK = 1;
        // Mongolian (Cyrillic, Mongolia)
        public const int SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA = 1;
        // Mongolian (PRC)
        public const int SUBLANG_MONGOLIAN_PRC = 2;
        // Nepali (India)
        public const int SUBLANG_NEPALI_INDIA = 2;
        // Nepali (Nepal) = &H0461 ne-NP
        public const int SUBLANG_NEPALI_NEPAL = 1;
        // Norwegian (Bokmal)
        public const int SUBLANG_NORWEGIAN_BOKMAL = 1;
        // Norwegian (Nynorsk)
        public const int SUBLANG_NORWEGIAN_NYNORSK = 2;
        // Occitan (France) = &H0482 oc-FR
        public const int SUBLANG_OCCITAN_FRANCE = 1;
        // Oriya (India (Oriya Script)) = &H0448 or-IN
        public const int SUBLANG_ORIYA_INDIA = 1;
        // Pashto (Afghanistan)
        public const int SUBLANG_PASHTO_AFGHANISTAN = 1;
        // Persian (Iran) = &H0429 fa-IR
        public const int SUBLANG_PERSIAN_IRAN = 1;
        // Polish (Poland) = &H0415
        public const int SUBLANG_POLISH_POLAND = 1;
        // Portuguese
        public const int SUBLANG_PORTUGUESE = 2;
        // Portuguese (Brazilian)
        public const int SUBLANG_PORTUGUESE_BRAZILIAN = 1;
        // Punjabi (India (Gurmukhi Script)) = &H0446 pa-IN
        public const int SUBLANG_PUNJABI_INDIA = 1;
        // Quechua (Bolivia)
        public const int SUBLANG_QUECHUA_BOLIVIA = 1;
        // Quechua (Ecuador)
        public const int SUBLANG_QUECHUA_ECUADOR = 2;
        // Quechua (Peru)
        public const int SUBLANG_QUECHUA_PERU = 3;
        // Romanian (Romania) = &H0418
        public const int SUBLANG_ROMANIAN_ROMANIA = 1;
        // Romansh (Switzerland) = &H0417 rm-CH
        public const int SUBLANG_ROMANSH_SWITZERLAND = 1;
        // Russian (Russia) = &H0419
        public const int SUBLANG_RUSSIAN_RUSSIA = 1;
        // Northern Sami (Norway)
        public const int SUBLANG_SAMI_NORTHERN_NORWAY = 1;
        // Northern Sami (Sweden)
        public const int SUBLANG_SAMI_NORTHERN_SWEDEN = 2;
        // Northern Sami (Finland)
        public const int SUBLANG_SAMI_NORTHERN_FINLAND = 3;
        // Lule Sami (Norway)
        public const int SUBLANG_SAMI_LULE_NORWAY = 4;
        // Lule Sami (Sweden)
        public const int SUBLANG_SAMI_LULE_SWEDEN = 5;
        // Southern Sami (Norway)
        public const int SUBLANG_SAMI_SOUTHERN_NORWAY = 6;
        // Southern Sami (Sweden)
        public const int SUBLANG_SAMI_SOUTHERN_SWEDEN = 7;
        // Skolt Sami (Finland)
        public const int SUBLANG_SAMI_SKOLT_FINLAND = 8;
        // Inari Sami (Finland)
        public const int SUBLANG_SAMI_INARI_FINLAND = 9;
        // Sanskrit (India) = &H044f sa-IN
        public const int SUBLANG_SANSKRIT_INDIA = 1;
        // Serbian (Bosnia and Herzegovina - Latin)
        public const int SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN = 6;
        // Serbian (Bosnia and Herzegovina - Cyrillic)
        public const int SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC = 7;
        // Croatian (Croatia) = &H041a hr-HR
        public const int SUBLANG_SERBIAN_CROATIA = 1;
        // Serbian (Latin)
        public const int SUBLANG_SERBIAN_LATIN = 2;
        // Serbian (Cyrillic)
        public const int SUBLANG_SERBIAN_CYRILLIC = 3;
        // Sindhi (India) reserved = &H0459
        public const int SUBLANG_SINDHI_INDIA = 1;
        // Sindhi (Pakistan) reserved = &H0859
        public const int SUBLANG_SINDHI_PAKISTAN = 2;
        // For app compatibility only
        public const int SUBLANG_SINDHI_AFGHANISTAN = 2;
        // Sinhalese (Sri Lanka)
        public const int SUBLANG_SINHALESE_SRI_LANKA = 1;
        // Northern Sotho (South Africa)
        public const int SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA = 1;
        // Slovak (Slovakia) = &H041b sk-SK
        public const int SUBLANG_SLOVAK_SLOVAKIA = 1;
        // Slovenian (Slovenia) = &H0424 sl-SI
        public const int SUBLANG_SLOVENIAN_SLOVENIA = 1;
        // Spanish (Castilian)
        public const int SUBLANG_SPANISH = 1;
        // Spanish (Mexican)
        public const int SUBLANG_SPANISH_MEXICAN = 2;
        // Spanish (Modern)
        public const int SUBLANG_SPANISH_MODERN = 3;
        // Spanish (Guatemala)
        public const int SUBLANG_SPANISH_GUATEMALA = 4;
        // Spanish (Costa Rica)
        public const int SUBLANG_SPANISH_COSTA_RICA = 5;
        // Spanish (Panama)
        public const int SUBLANG_SPANISH_PANAMA = 6;
        // Spanish (Dominican Republic)
        public const int SUBLANG_SPANISH_DOMINICAN_REPUBLIC = 7;
        // Spanish (Venezuela)
        public const int SUBLANG_SPANISH_VENEZUELA = 8;
        // Spanish (Colombia)
        public const int SUBLANG_SPANISH_COLOMBIA = 9;
        // Spanish (Peru)
        public const int SUBLANG_SPANISH_PERU = 10;
        // Spanish (Argentina)
        public const int SUBLANG_SPANISH_ARGENTINA = 11;
        // Spanish (Ecuador)
        public const int SUBLANG_SPANISH_ECUADOR = 12;
        // Spanish (Chile)
        public const int SUBLANG_SPANISH_CHILE = 13;
        // Spanish (Uruguay)
        public const int SUBLANG_SPANISH_URUGUAY = 14;
        // Spanish (Paraguay)
        public const int SUBLANG_SPANISH_PARAGUAY = 15;
        // Spanish (Bolivia)
        public const int SUBLANG_SPANISH_BOLIVIA = 16;
        // Spanish (El Salvador)
        public const int SUBLANG_SPANISH_EL_SALVADOR = 17;
        // Spanish (Honduras)
        public const int SUBLANG_SPANISH_HONDURAS = 18;
        // Spanish (Nicaragua)
        public const int SUBLANG_SPANISH_NICARAGUA = 19;
        // Spanish (Puerto Rico)
        public const int SUBLANG_SPANISH_PUERTO_RICO = 20;
        // Spanish (United States)
        public const int SUBLANG_SPANISH_US = 21;
        // Swahili (Kenya) = &H0441 sw-KE
        public const int SUBLANG_SWAHILI_KENYA = 1;
        // Swedish
        public const int SUBLANG_SWEDISH = 1;
        // Swedish (Finland)
        public const int SUBLANG_SWEDISH_FINLAND = 2;
        // Syriac (Syria) = &H045a syr-SY
        public const int SUBLANG_SYRIAC_SYRIA = 1;
        // Tajik (Tajikistan) = &H0428 tg-TJ-Cyrl
        public const int SUBLANG_TAJIK_TAJIKISTAN = 1;
        // Tamazight (Latin, Algeria) = &H085f tmz-DZ-Latn
        public const int SUBLANG_TAMAZIGHT_ALGERIA_LATIN = 2;
        // Tamil (India)
        public const int SUBLANG_TAMIL_INDIA = 1;
        // Tatar (Russia) = &H0444 tt-RU
        public const int SUBLANG_TATAR_RUSSIA = 1;
        // Telugu (India (Telugu Script)) = &H044a te-IN
        public const int SUBLANG_TELUGU_INDIA = 1;
        // Thai (Thailand) = &H041e th-TH
        public const int SUBLANG_THAI_THAILAND = 1;
        // Tibetan (PRC)
        public const int SUBLANG_TIBETAN_PRC = 1;
        // Tigrigna (Eritrea)
        public const int SUBLANG_TIGRIGNA_ERITREA = 2;
        // Setswana / Tswana (South Africa) = &H0432 tn-ZA
        public const int SUBLANG_TSWANA_SOUTH_AFRICA = 1;
        // Turkish (Turkey) = &H041f tr-TR
        public const int SUBLANG_TURKISH_TURKEY = 1;
        // Turkmen (Turkmenistan) = &H0442 tk-TM
        public const int SUBLANG_TURKMEN_TURKMENISTAN = 1;
        // Uighur (PRC) = &H0480 ug-CN
        public const int SUBLANG_UIGHUR_PRC = 1;
        // Ukrainian (Ukraine) = &H0422 uk-UA
        public const int SUBLANG_UKRAINIAN_UKRAINE = 1;
        // Upper Sorbian (Germany) = &H042e wen-DE
        public const int SUBLANG_UPPER_SORBIAN_GERMANY = 1;
        // Urdu (Pakistan)
        public const int SUBLANG_URDU_PAKISTAN = 1;
        // Urdu (India)
        public const int SUBLANG_URDU_INDIA = 2;
        // Uzbek (Latin)
        public const int SUBLANG_UZBEK_LATIN = 1;
        // Uzbek (Cyrillic)
        public const int SUBLANG_UZBEK_CYRILLIC = 2;
        // Vietnamese (Vietnam) = &H042a vi-VN
        public const int SUBLANG_VIETNAMESE_VIETNAM = 1;
        // Welsh (United Kingdom) = &H0452 cy-GB
        public const int SUBLANG_WELSH_UNITED_KINGDOM = 1;
        // Wolof (Senegal)
        public const int SUBLANG_WOLOF_SENEGAL = 1;
        // isiXhosa / Xhosa (South Africa) = &H0434 xh-ZA
        public const int SUBLANG_XHOSA_SOUTH_AFRICA = 1;
        // Yakut (Russia) = &H0485 sah-RU
        public const int SUBLANG_YAKUT_RUSSIA = 1;
        // Yi (PRC)) = &H0478
        public const int SUBLANG_YI_PRC = 1;
        // Yoruba (Nigeria) 046a yo-NG
        public const int SUBLANG_YORUBA_NIGERIA = 1;
        // isiZulu / Zulu (South Africa) = &H0435 zu-ZA
        public const int SUBLANG_ZULU_SOUTH_AFRICA = 1;


        //
        //  A language ID is a 16 bit value which is the combination of a
        //  primary language ID and a secondary language ID.  The bits are
        //  allocated as follows:
        //
        //       +-----------------------+-------------------------+
        //       |     Sublanguage ID    |   Primary Language ID   |
        //       +-----------------------+-------------------------+
        //        15                   10 9                       0   bit
        //


        //Neutral language

        public const int LANG_SUBLANG_NEUTRAL = 0;


        public enum NeoSpeechVoiceTextAudioFormat
        {

            VT_FILE_API_FMT_S16PCM = 0,
            VT_FILE_API_FMT_ALAW = 1,
            VT_FILE_API_FMT_MULAW = 2,
            VT_FILE_API_FMT_DADPCM = 3,
            VT_FILE_API_FMT_S16PCM_WAVE = 4,
            VT_FILE_API_FMT_U08PCM_WAVE = 5,
            VT_FILE_API_FMT_IMA_WAVE = 6,
            VT_FILE_API_FMT_ALAW_WAVE = 7,
            VT_FILE_API_FMT_MULAW_WAVE = 8,
            VT_FILE_API_FMT_MULAW_AU = 9

        }

        //Export formats for Cepstral voices

        //You need to set the following instead:

        //szAudioEncoding [possible values: 
        //   * "riff": Microsoft RIFF (WAV) file 
        //   * "pcm16", "pcm8" PCM 16 bit/8 bit WAV _
        //   * "ulaw" - -Law (8-bit by definition), "alaw" - A-Law (8-bit by definition) 
        //   * "snd": Sun/NeXT .au (SND) format. 
        //   * "raw": unheadered audio data, native byte order 
        //    * "le": unheadered audio data, little-endian (LSB first) 
        //    * "be": unheadered audio data, big-endian (MSB first) 
        //    * NOTE: that not all encoding types may be supported by all formats. For instance, SND doesn't support A-Law. ], _
        //iAudioSamplingRate [possible values: 8000 (8 KHz), 16000 (16 KHz), 11025 (11.025 kHz), etc ], _
        //iAudioChannels [possible values: 1 (mono), 2 (stereo)]

        //Export formats for AT&T NV (INTERNAL USE ONLY) _
        //Currently only PCM WAV supported  (all audio format arguments will be ignored)




        public enum NeoSpeechVoiceID
        {

            NEOSPEECH_KATE_ENG = 0,

            NEOSPEECH_PAUL_ENG = 1,


            NEOSPEECH_MIYU_JPN = 0,

            NEOSPEECH_SHOW_JPN = 1,

            NEOSPEECH_MISAKI_JPN = 2,


            NEOSPEECH_LILY_CHI = 0,

            NEOSPEECH_WANG_CHI = 1,


            NEOSPEECH_JUNWOO_KOR = 3,

            NEOSPEECH_SUJIN_KOR = 8,

            NEOSPEECH_YUMI_KOR = 10,

            NEOSPEECH_GYURI_KOR = 11,

            NEOSPEECH_DAYOUNG_KOR = 12

        }



        public const string NEOSPEECH_KATE_ENG_NAMESTR = "Kate";

        public const string NEOSPEECH_PAUL_ENG_NAMESTR = "Paul";


        public const string NEOSPEECH_MIYU_JPN_NAMESTR = "Miyu";

        public const string NEOSPEECH_SHOW_JPN_NAMESTR = "Show";

        public const string NEOSPEECH_MISAKI_JPN_NAMESTR = "Misaki";


        public const string NEOSPEECH_LILY_CHI_NAMESTR = "Lily";

        public const string NEOSPEECH_WANG_CHI_NAMESTR = "Wang";


        public const string NEOSPEECH_JUNWOO_KOR_NAMESTR = "Junwoo";

        public const string NEOSPEECH_SUJIN_KOR_NAMESTR = "Sujin";

        public const string NEOSPEECH_YUMI_KOR_NAMESTR = "Yumi";

        public const string NEOSPEECH_GYURI_KOR_NAMESTR = "Gyuri";

        public const string NEOSPEECH_DAYOUNG_KOR_NAMESTR = "Dayoung";

        //Messages used for speech events
        public const int WM_USER = 1024;

        public const int WIN_SPEAK_MSG = WM_USER + 12359;

        public const int WIN_EXPORT_MSG = WM_USER + 12360;

        #endregion

        #region "P/Invoke declarations"


        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int GetDFTTSVoice(int iVoiceInfoIdIn, ref int pvetOut, byte[] szVoiceNameOut, ref int piVoiceNameLenOut, ref int piVoiceIDOut, ref int plangOut);


        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern void InitDFTTSEngineEx3(IntPtr hwndWinOwner,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathKate,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathPaul,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathMiyu,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathShow,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathMisaki,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathLily,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathWang,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathJunwoo,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathSujin,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathYumi,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathGyuri,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechDBFolderPathDayoung,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathKate,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathPaul,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathMiyu,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathShow,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathMisaki,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathLily,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathWang,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathJunwoo,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathSujin,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathYumi,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathGyuri,
                       [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePathDayoung,
                        int[] psiLoadedEngines,
                        int[] psiLoadedEnginesReturnValues
                );



        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int UninitDFTTSEngine();

        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int MakeLanguage(int mainlang, int sublang);


        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int GetMainLanguage(int lang);


        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int GetSubLanguage(int lang);


        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int LoadDFTTSUserDict(int iDictIndex,
               [MarshalAs(UnmanagedType.LPStr)] string szDictName,
               [MarshalAs(UnmanagedType.LPStr)] string szDictFileName, int vet, int lang,
               [MarshalAs(UnmanagedType.LPStr)] string szVoiceName,
               [MarshalAs(UnmanagedType.LPStr)] string szDictContents);

        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int UnloadDFTTSUserDict(int iDictIndex,
            [MarshalAs(UnmanagedType.LPStr)] string szDictName,
            int vet, int lang);

        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int DFTTSSpeak(IntPtr hwndWinOwner, int vet,
                [MarshalAs(UnmanagedType.LPStr)] string szVoiceName,
                int iVoiceID, int lang,
                [MarshalAs(UnmanagedType.LPStr)] string szText,
                int iPitch,
                int iSpeed, int iVolume, int iPause, int iDictID, int ttTextType, int ofOutPutFormat);


        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int DFTTSPause(int vet, int lang);

        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int DFTTSResume(int vet, int lang);

        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int DFTTSStop(int vet, int lang);

        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int DFTTSExportToFileEx(int vet,
                [MarshalAs(UnmanagedType.LPStr)] string szVoiceName,
                int iVoiceID, int lang,
                [MarshalAs(UnmanagedType.LPStr)] string szText,
                int iPitch, int iSpeed,
                int iVolume, int iPause, int iDictID, int ttTextType,
                [MarshalAs(UnmanagedType.LPStr)] string szFilePath,
                int ffFileFormat,
                [MarshalAs(UnmanagedType.LPStr)] string szAudioEncoding,
                int iAudioSamplingRate,
                int iAudioChannels);

        [DllImport("dftts.dll", CharSet = CharSet.Auto)]
        public static extern int GetDFTTSEngineInfo(int vetVType, int lang, int ttspParam, int[] iValue, [MarshalAs(UnmanagedType.LPStr)] string szNeoSpeechLicFilePath);


        #endregion

        #region "Private Variables"

        private IntPtr hWnd;

        private bool bIsPaused = false;

        private System.Text.ASCIIEncoding ascii = new System.Text.ASCIIEncoding();

        //Change this to your preference
        private string sExportFileName = "test.wav";

        //We use this class to add to the ComboBox Items (it must implement a property for the item display)
        private class cVoiceData
        {

            public int vet;
            public int lang;
            public string sVoiceName;
            public int iVoiceId;


            public string sValue
            {
                
                get
                {
                    return sVoiceName;
                }
               
                set
                {
                    sVoiceName = value;
                }

            }

        }

        #endregion

        private void Form1_Load(object sender, System.EventArgs e)
        {


            hWnd = this.Handle;

            int[] iLoadedEngines = new int[NUM_ENGINE_INITIALIZATIONS];

            int[] iLoadedEnginesReturnValues = new int[NUM_ENGINE_INITIALIZATIONS];

            for (int i = 0; i <= NUM_ENGINE_INITIALIZATIONS - 1; i++)
            {

                iLoadedEngines[i] = (int)DFTTSVoiceEngineType.NOENGINE;

                iLoadedEnginesReturnValues[i] = (int)InitDFTTSEngineReturnValue.INIT_DFTTS_ENGINE_ERROR_OTHER;

            }

            //(!YOU NEED TO CHANGE THE PATHS TO MATCH YOUR PATHS!)

            //This is order that you should supply paths:

            //Kate
            //Paul           
            //Miyu
            //Show 
            //Misaki 
            //Lily 
            //Wang 
            //Junwoo 
            //Sujin 
            //Yumi 
            //Gyuri 
            //Dayoung  
            //Kate
            //Paul           
            //Miyu
            //Show 
            //Misaki 
            //Lily 
            //Wang 
            //Junwoo 
            //Sujin 
            //Yumi 
            //Gyuri 
            //Dayoung  


            InitDFTTSEngineEx3(hWnd, "C:\\***", "C:\\Program Files\\VW\\VT\\Paul\\M16", "C:\\***", "C:\\***", "C:\\***", "C:\\***", "C:\\***", "C:\\***", "C:\\***",
            "C:\\***", "C:\\***", "C:\\***", "C:\\***", "C:\\Program Files\\VW\\VT\\Paul\\M16\\data-common\\verify\\verification.txt", "C:\\***", "C:\\***", "C:\\***", "C:\\***", "C:\\***",
            "C:\\***", "C:\\***", "C:\\***", "C:\\***", "C:\\***", iLoadedEngines, iLoadedEnginesReturnValues);

            //Catch load errors

            string sEngineName;
            sEngineName = "";

            InitDFTTSEngineReturnValue result;

            string[] sNeospVoiceNames = new string[NEOSPEECH_NUM_VOICES];

            sNeospVoiceNames[0] = NEOSPEECH_KATE_ENG_NAMESTR;
            sNeospVoiceNames[1] = NEOSPEECH_PAUL_ENG_NAMESTR;
            sNeospVoiceNames[2] = NEOSPEECH_MIYU_JPN_NAMESTR;
            sNeospVoiceNames[3] = NEOSPEECH_SHOW_JPN_NAMESTR;
            sNeospVoiceNames[4] = NEOSPEECH_MISAKI_JPN_NAMESTR;
            sNeospVoiceNames[5] = NEOSPEECH_LILY_CHI_NAMESTR;
            sNeospVoiceNames[6] = NEOSPEECH_WANG_CHI_NAMESTR;
            sNeospVoiceNames[7] = NEOSPEECH_JUNWOO_KOR_NAMESTR;
            sNeospVoiceNames[8] = NEOSPEECH_SUJIN_KOR_NAMESTR;
            sNeospVoiceNames[9] = NEOSPEECH_YUMI_KOR_NAMESTR;
            sNeospVoiceNames[10] = NEOSPEECH_GYURI_KOR_NAMESTR;
            sNeospVoiceNames[11] = NEOSPEECH_DAYOUNG_KOR_NAMESTR;


            for (int intI = 0; intI <= NUM_ENGINE_INITIALIZATIONS - 1; intI++)
            {



                if (iLoadedEngines[intI] == (int)DFTTSVoiceEngineType.NEOSPEECHVOICETEXT)
                {


                    sEngineName = "NEOPSEECHVOICETEXT Engine Load Result for voice " + sNeospVoiceNames[intI] + ": ";
                }


                else if (iLoadedEngines[intI] == (int)DFTTSVoiceEngineType.CEPSTRAL)
                {


                    sEngineName = "CEPSTRAL Engine Load Result: ";
                }


                else if (iLoadedEngines[intI] == (int)DFTTSVoiceEngineType.ATTNV)
                {


                    sEngineName = "ATTNV (INTERNAL USE ONLY) Engine Load Result: ";
                }

                else if (iLoadedEngines[intI] == (int)DFTTSVoiceEngineType.MACOSXSPMAN)
                {


                    sEngineName = "MACOSXSPMAN (MAC OS X ONLY) Engine Load Result: ";
                }


                else if (iLoadedEngines[intI] == (int)DFTTSVoiceEngineType.MSSAPI)
                {


                    sEngineName = "MSSAPI (UNMAMAGED SDK USAGE ONLY) Engine Load Result: ";

                }

                result = (InitDFTTSEngineReturnValue)iLoadedEnginesReturnValues[intI];

                Debug.Write(sEngineName + result + "\n");

            }


            //This is how to list all installed supported voices

            string szVoiceName = "*************************************************************";

            byte[] bVoiceName2 = new byte[szVoiceName.Length];
            ascii.GetBytes(szVoiceName.ToCharArray(), 0, szVoiceName.Length, bVoiceName2, 0);

            int iVoiceNameLen;
            iVoiceNameLen = 0;

            int vet;
            vet = 0;

            int lang;
            lang = 0;

            int iVoiceID;
            iVoiceID = 0;

            int z;
            z = 0;

            int iUsedNumOfVoices;
            iUsedNumOfVoices = 0;

            while (0 == 0)
            {

                DFTTSVoiceInfoReturnValue viresult;

                viresult = (DFTTSVoiceInfoReturnValue)GetDFTTSVoice(z, ref vet, bVoiceName2, 
                            ref iVoiceNameLen, ref iVoiceID, ref lang);

                //DO NOT USE MSSAPI NATIVELY FROM .NET! IT WILL CRASH THE APP!!!
                if (viresult == DFTTSVoiceInfoReturnValue.GET_DFTTS_VI_SUCCESS &&
                    vet != (int)DFTTSVoiceEngineType.MSSAPI)
                {

                    iUsedNumOfVoices++;

                    string sVNameOut = ascii.GetString(bVoiceName2, 0, iVoiceNameLen);

                    ComboBox1.DisplayMember = "sValue"; 

                    cVoiceData oVData = new cVoiceData();
                    oVData.vet = vet;
                    oVData.lang = lang;
                    oVData.sVoiceName = sVNameOut;
                    oVData.iVoiceId = iVoiceID;
                                   

                    ComboBox1.Items.Add(oVData);
                }

                else
                {

                    break;

                }

                z++;

            }

            ComboBox1.SelectedIndex = 0;

            if (iUsedNumOfVoices == 0)
            {
                MessageBox.Show("No voices can be found on your system! Please download and install at least 1 voice!");
            }

            LoadDFTTSUserDictReturnValue dictreturn = LoadDFTTSUserDictReturnValue.LOAD_USER_DICT_SUCCESS;

            //User Dictionary Loading: 
            //(read dictionary documentation per engine located in folder DictionarySystems)

            //This is how to load a dictionary for the NeoSpeech provider (the dictionary is loaded _
            //by language from a file (see file in exe directory) (the dict name, voice name, _
            //dict content do NOT matter), the dictionary number matters)

            //MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US) = 1033 - You can just use 1033

            /*dictreturn = (LoadDFTTSUserDictReturnValue)LoadDFTTSUserDict(1, null, 
                    "neospeech_userdict_eng.csv", 
                    (int)DFTTSVoiceEngineType.NEOSPEECHVOICETEXT, MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US), null, null);*/

            //This is how to load a dictionary for the Cepstral provider (the dictionary is loaded
            //by voice from a file (see file in exe directory);
            //The dictionary number, dict name, dict content do NOT matter.)

            /*dictreturn = (LoadDFTTSUserDictReturnValue)LoadDFTTSUserDict(-1, null, 
                    "cepstral_dictionary.txt",
                    (int)DFTTSVoiceEngineType.CEPSTRAL, LANG_SUBLANG_NEUTRAL, "David", null);*/

            if (dictreturn != LoadDFTTSUserDictReturnValue.LOAD_USER_DICT_SUCCESS)
            {
                MessageBox.Show("SDK Load Dictionary failed with error: " + dictreturn, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }



        }

        private void Form1_Disposed(object sender, System.EventArgs e)
        {

            //Stop the voice if it is speaking
            int iSelIndex = ComboBox1.SelectedIndex;


            cVoiceData oVData = (cVoiceData)ComboBox1.Items[iSelIndex];

            DFTTSStopReturnValue result = (DFTTSStopReturnValue)DFTTSStop(
                oVData.vet, oVData.lang);

            UninitDFTTSEngine();

        }

        private void button1_Click(object sender, System.EventArgs e)
        {

            int iSelIndex = ComboBox1.SelectedIndex;

            cVoiceData oVData = (cVoiceData)ComboBox1.Items[iSelIndex];


            DFTTSSpeakReturnValue result = (DFTTSSpeakReturnValue)DFTTSSpeak(hWnd,
                oVData.vet, oVData.sVoiceName, oVData.iVoiceId, oVData.lang,
                textBox1.Text, -1, -1, -1, -1,
                1, (int)DFTTSTextType.DFTTS_TEXT_TYPE_XML, -1);


            if (result != DFTTSSpeakReturnValue.DFTTS_SPEAK_SUCCESS)
            {

                MessageBox.Show("SDK Speak error: " + result.ToString(), "Error");

            }

        }

        private void button2_Click(object sender, System.EventArgs e)
        {

            int iSelIndex = ComboBox1.SelectedIndex;

            cVoiceData oVData = (cVoiceData)ComboBox1.Items[iSelIndex];

            if (bIsPaused)
            {

                bIsPaused = false;

                DFTTSResumeReturnValue result = (DFTTSResumeReturnValue)DFTTSResume(
                    oVData.vet, oVData.lang);

                if (result != DFTTSResumeReturnValue.DFTTS_RESUME_SUCCESS)
                {

                    MessageBox.Show("SDK Resume error: " + result.ToString(), "Error");

                }
            }

            else if (bIsPaused == false)
            {

                bIsPaused = true;

                DFTTSPauseReturnValue result = (DFTTSPauseReturnValue)DFTTSPause(
                    oVData.vet, oVData.lang);

                if (result != DFTTSPauseReturnValue.DFTTS_PAUSE_SUCCESS)
                {

                    MessageBox.Show("SDK Pause error: " + result.ToString(), "Error");

                }
            }

        }

        private void button4_Click(object sender, System.EventArgs e)
        {

            int iSelIndex = ComboBox1.SelectedIndex;

            cVoiceData oVData = (cVoiceData)ComboBox1.Items[iSelIndex];

            DFTTSStopReturnValue result = (DFTTSStopReturnValue)DFTTSStop(
                oVData.vet, oVData.lang);

            if (result != DFTTSStopReturnValue.DFTTS_STOP_SUCCESS)
            {

                MessageBox.Show("SDK Stop error: " + result.ToString(), "Error");

            }

        }

        private void button3_Click(object sender, System.EventArgs e)
        {

            int iSelIndex = ComboBox1.SelectedIndex;

            cVoiceData oVData = (cVoiceData)ComboBox1.Items[iSelIndex];

            DFTTSExportReturnValue result = (DFTTSExportReturnValue)DFTTSExportToFileEx(
                oVData.vet, oVData.sVoiceName, oVData.iVoiceId, oVData.lang,
                textBox1.Text, -1, -1, -1, -1, -1,
                (int)DFTTSTextType.DFTTS_TEXT_TYPE_PLAIN, sExportFileName,
                (int)NeoSpeechVoiceTextAudioFormat.VT_FILE_API_FMT_ALAW_WAVE,
                "pcm16", 16000, 2);


            if (result != DFTTSExportReturnValue.DFTTS_EXPORT_SUCCESS)
            {

                MessageBox.Show("SDK Export error: " + result.ToString(), "Error");

            }

        }

        //How to capture OnWord and OnExportFinished events:
        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case WIN_SPEAK_MSG:
                    StringBuilder sb = new StringBuilder();
                    sb.Append("OnWord: Start Character: ");
                    sb.Append(m.WParam);
                    sb.Append(", End Character: ");
                    sb.Append((int)m.LParam );

                    this.label1.Text = sb.ToString();
                    break;

                case WIN_EXPORT_MSG:
                    MessageBox.Show("Export succesful!", "Success");
                    break;

                default:
                    base.WndProc(ref m);
                    break;
            }

        } 


    }

}
