Attribute VB_Name = "Module2"
'///****************************************************************************
'//// Name:        DFTTSSampleVB6 with DFTTS Desktop SDK v 3.5.0
'//// Purpose:     API P/Invoke Declarations and API Data Types
'//// Author:      Digital Future
'//// Modified by:
'//// Created:     07/20/2008
'//// RCS-ID:
'//// Copyright:   (C) Digital Future 2008. All rights reserved.
'//// Licence:     see license document
'//***************************************************************************/

Public Const NEOSPEECH_NUM_VOICES As Integer = 12

Public Const NUM_ENGINE_INITIALIZATIONS As Integer = 16


Public Declare Function GetDFTTSNumVoices Lib "dftts.dll" () As Integer

Public Declare Function GetDFTTSVoice Lib "dftts.dll" (ByVal iVoiceInfoIdIn As Integer, _
                                                    ByRef pvetOut As Integer, _
                                                    ByVal szVoiceNameOut As String, _
                                                    ByRef piVoiceNameLenOut As Integer, _
                                                    ByRef piVoiceIDOut As Integer, _
                                                    ByRef plangOut As Integer _
                                                    ) As Integer

Public Declare Sub InitDFTTSEngineEx3 Lib "dftts.dll" (ByVal hwndWinOwner As Long, _
                    ByVal szNeoSpeechDBFolderPathKate As String, _
                    ByVal szNeoSpeechDBFolderPathPaul As String, _
                    ByVal szNeoSpeechDBFolderPathMiyu As String, _
                    ByVal szNeoSpeechDBFolderPathShow As String, _
                    ByVal szNeoSpeechDBFolderPathMisaki As String, _
                    ByVal szNeoSpeechDBFolderPathLily As String, _
                    ByVal szNeoSpeechDBFolderPathWang As String, _
                    ByVal szNeoSpeechDBFolderPathJunwoo As String, _
                    ByVal szNeoSpeechDBFolderPathSujin As String, _
                    ByVal szNeoSpeechDBFolderPathYumi As String, _
                    ByVal szNeoSpeechDBFolderPathGyuri As String, _
                    ByVal szNeoSpeechDBFolderPathDayoung As String, _
                    ByVal szNeoSpeechLicFilePathKate As String, _
                    ByVal szNeoSpeechLicFilePathPaul As String, _
                    ByVal szNeoSpeechLicFilePathMiyu As String, _
                    ByVal szNeoSpeechLicFilePathShow As String, _
                    ByVal szNeoSpeechLicFilePathMisaki As String, _
                    ByVal szNeoSpeechLicFilePathLily As String, _
                    ByVal szNeoSpeechLicFilePathWang As String, _
                    ByVal szNeoSpeechLicFilePathJunwoo As String, _
                    ByVal szNeoSpeechLicFilePathSujin As String, _
                    ByVal szNeoSpeechLicFilePathYumi As String, _
                    ByVal szNeoSpeechLicFilePathGyuri As String, _
                    ByVal szNeoSpeechLicFilePathDayoung As String, ByRef psiLoadedEngines As Long, ByRef psiLoadedEnginesReturnValues As Long)
                    
                    
Public Declare Function UninitDFTTSEngine Lib "dftts.dll" () As Integer

Public Declare Function MakeLanguage Lib "dftts.dll" (ByVal mainlang As Integer, _
                                        ByVal sublang As Integer _
                                        ) As Integer

Public Declare Function GetMainLanguage Lib "dftts.dll" (ByVal lang As Integer) As Integer
                                        
Public Declare Function GetSubLanguage Lib "dftts.dll" (ByVal lang As Integer) As Integer

Public Declare Function LoadDFTTSUserDict Lib "dftts.dll" (ByVal iDictIndex As Integer, _
    ByVal szDictName As String, _
    ByVal szDictFileName As String, _
    ByVal vet As Integer, ByVal lang As Integer, ByVal szVoiceName As String, _
    ByVal szDictContents As String) As Integer
    
Public Declare Function UnloadDFTTSUserDict Lib "dftts.dll" (ByVal iDictIndex As Integer, _
    ByVal szDictName As String, _
    ByVal vet As Integer, ByVal lang As Integer) As Integer

Public Declare Function DFTTSSpeak Lib "dftts.dll" (ByVal hwndWinOwner As Long, _
ByVal vet As Integer, ByVal szVoiceName As String, ByVal iVoiceID As Integer, _
                    ByVal lang As Integer, ByVal szText As String, ByVal iPitch As Integer, _
                    ByVal iSpeed As Integer, ByVal iVolume As Integer, ByVal iPause As Integer, _
                    ByVal iDictID As Integer, ByVal ttTextType As Integer, _
                    ByVal ofOutPutFormat As Integer) As Integer
                    
Public Declare Function DFTTSPause Lib "dftts.dll" (ByVal vet As Integer, _
                                                     ByVal lang As Integer) As Integer

Public Declare Function DFTTSResume Lib "dftts.dll" (ByVal vet As Integer, _
                                                     ByVal lang As Integer) As Integer

Public Declare Function DFTTSStop Lib "dftts.dll" (ByVal vet As Integer, _
                                                     ByVal lang As Integer) As Integer

                    
Public Declare Function DFTTSExportToFileEx Lib "dftts.dll" (ByVal vet As Integer, _
                    ByVal szVoiceName As String, ByVal iVoiceID As Integer, _
                    ByVal lang As Integer, ByVal szText As String, ByVal iPitch As Integer, _
                    ByVal iSpeed As Integer, ByVal iVolume As Integer, ByVal iPause As Integer, _
                    ByVal iDictID As Integer, ByVal ttTextType As Integer, _
                    ByVal szFilePath As String, ByVal ffFileFormat As Integer, _
                    ByVal szAudioEncoding As String, ByVal iAudioSamplingRate As Integer, _
                    ByVal iAudioChannels As Integer) As Integer
                    

Public Enum DFTTSPredefinedSpeechParams

    DF_TTS_DEFAULT_PITCH = 100 '/*100%*/
    DF_TTS_DEFAULT_SPEED = 100 '/*100%*/
    DF_TTS_DEFAULT_VOLUME = 100 '/*100%*/
    DF_TTS_DEFAULT_PAUSE = 670 '/*670 msec*/
    DF_TTS_NEOSPEECH_MIN_PITCH = 50
    DF_TTS_NEOSPEECH_MAX_PITCH = 200
    DF_TTS_NEOSPEECH_MIN_SPEED = 50
    DF_TTS_NEOSPEECH_MAX_SPEED = 400
    DF_TTS_NEOSPEECH_MIN_VOLUME = 0
    DF_TTS_NEOSPEECH_MAX_VOLUME = 500
    DF_TTS_NEOSPEECH_MIN_PAUSE = 0
    DF_TTS_NEOSPEECH_MAX_PAUSE = 20000
    DF_TTS_CEPSTRAL_MIN_PITCH = 100
    DF_TTS_CEPSTRAL_MAX_PITCH = 500
    DF_TTS_CEPSTRAL_MIN_SPEED = 0
    DF_TTS_CEPSTRAL_MAX_SPEED = 400
    DF_TTS_CEPSTRAL_MIN_VOLUME = 0
    DF_TTS_CEPSTRAL_MAX_VOLUME = 500
    DF_TTS_ATTNV_MIN_SPEED = 13
    DF_TTS_ATTNV_MAX_SPEED = 800
    DF_TTS_ATTNV_MIN_VOLUME = 0
    DF_TTS_ATTNV_MAX_VOLUME = 500
    DF_TTS_ATTNV_MIN_PITCH = 0 '/*AT&T NV do not support this*/
    DF_TTS_ATTNV_MAX_PITCH = 0 '/*AT&T NV do not support this*/
    DF_TTS_MACOSXSPMAN_MIN_PITCH = 1
    DF_TTS_MACOSXSPMAN_MAX_PITCH = 1000
    DF_TTS_MACOSXSPMAN_MIN_SPEED = 1
    DF_TTS_MACOSXSPMAN_MAX_SPEED = 1000
    DF_TTS_MACOSXSPMAN_MIN_VOLUME = 100
    DF_TTS_MACOSXSPMAN_MAX_VOLUME = 500
    DF_TTS_MSSAPI_MIN_PITCH = 30
    DF_TTS_MSSAPI_MAX_PITCH = 350
    DF_TTS_MSSAPI_MIN_SPEED = 30
    DF_TTS_MSSAPI_MAX_SPEED = 350
    DF_TTS_MSSAPI_MIN_VOLUME = 0
    DF_TTS_MSSAPI_MAX_VOLUME = 100

End Enum

Public Enum DFTTSVoiceEngineType

    NOENGINE = -4
    ALLENGINES = -3
    NEOSPEECHVOICETEXT = 0
    CEPSTRAL
    ATTNV
    MSSAPI
    MACOSXSPMAN
    
End Enum

Public Enum InitDFTTSEngineReturnValue

    INIT_DFTTS_ENGINE_SUCCESS
    INIT_DFTTS_ENGINE_ERROR_DB_PATH_DIFFERENT
    INIT_DFTTS_ENGINE_ERROR_CHANNEL_MEM_FAIL
    INIT_DFTTS_ENGINE_ERROR_DB_MORPHEME_ANALYSIS_FAIL
    INIT_DFTTS_ENGINE_ERROR_DB_BREAK_INDEX_FAIL
    INIT_DFTTS_ENGINE_ERROR_DB_TEXT_PREP_FAIL
    INIT_DFTTS_ENGINE_ERROR_DB_ACOU_MODEL_FAIL
    INIT_DFTTS_ENGINE_ERROR_DB_UNIT_SEL_FAIL
    INIT_DFTTS_ENGINE_ERROR_DB_PROS_MODEL_FAIL
    INIT_DFTTS_ENGINE_ERROR_DB_SPEECH_DB_FAIL
    INIT_DFTTS_ENGINE_ERROR_DB_PITCH_LOC_INFO_FAIL
    INIT_DFTTS_ENGINE_ERROR_FAILED
    INIT_DFTTS_ENGINE_ERROR_INVALIDARG
    INIT_DFTTS_ENGINE_ERROR_OUTOFMEMORY
    INIT_DFTTS_ENGINE_ERROR_NOTIMPL
    INIT_DFTTS_ENGINE_ERROR_ABORT
    INIT_DFTTS_ENGINE_ERROR_UNKNOWN
    INIT_DFTTS_ENGINE_ERROR_BADHANDLE
    INIT_DFTTS_ENGINE_ERROR_EXCEPTION
    INIT_DFTTS_ENGINE_ERROR_EMPTY
    INIT_DFTTS_ENGINE_ERROR_FULL
    INIT_DFTTS_ENGINE_ERROR_INVALIDSTATE
    INIT_DFTTS_ENGINE_ERROR_BADVERSION
    INIT_DFTTS_ENGINE_ERROR_INSUFFICIENT_BUFFER
    INIT_DFTTS_ENGINE_ERROR_UNSUPPORTED
    INIT_DFTTS_ENGINE_ERROR_NOLICENSE
    INIT_DFTTS_ENGINE_ERROR_CREATECHILDPROCESS_FAILED
    INIT_DFTTS_ENGINE_ERROR_NOENVIRONMENTPATH
    INIT_DFTTS_ENGINE_ERROR_TIMEOUT
    INIT_DFTTS_ENGINE_ERROR_OUTOFRESOURCES
    INIT_DFTTS_ENGINE_ERROR_NOVOICES
    INIT_DFTTS_ENGINE_ERROR_CREATEFAIL
    INIT_DFTTS_ENGINE_ERROR_CONNECTFAIL
    INIT_DFTTS_ENGINE_ERROR_BINDFAIL
    INIT_DFTTS_ENGINE_ERROR_LISTENFAIL
    INIT_DFTTS_ENGINE_ERROR_CONNECTIONCLOSED
    INIT_DFTTS_ENGINE_ERROR_ACCEPTFAIL
    INIT_DFTTS_ENGINE_ERROR_SOCKETTIMEOUT
    INIT_DFTTS_ENGINE_ERROR_SOCKETERROR
    INIT_DFTTS_ENGINE_ERROR_NOMORESERVERS
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EWOULDBLOCK
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EINPROGRESS
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EALREADY
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTSOCK
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EDESTADDRREQ
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EMSGSIZE
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROTOTYPE
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOPROTOOPT
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROTONOSUPPORT
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ESOCKTNOSUPPORT
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EOPNOTSUPP
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EPFNOSUPPORT
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EAFNOSUPPORT
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EADDRINUSE
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EADDRNOTAVAIL
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETDOWN
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETUNREACH
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETRESET
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNABORTED
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNRESET
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOBUFS
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EISCONN
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTCONN
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ESHUTDOWN
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ETOOMANYREFS
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNREFUSED
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ELOOP
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENAMETOOLONG
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EHOSTDOWN
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EHOSTUNREACH
    INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTEMPTY
    INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROCLIM
    INIT_DFTTS_ENGINE_ERROR_THREADSTARTED
    INIT_DFTTS_ENGINE_ERROR_THREADNOTSTARTED
    INIT_DFTTS_ENGINE_ERROR_THREADCOULDNOTCREATE
    INIT_DFTTS_ENGINE_ERROR_BADNVFILE
    INIT_DFTTS_ENGINE_ERROR_NOAUDIODRIVER
    INIT_DFTTS_ENGINE_ERROR_DICTNOTFOUND
    INIT_DFTTS_ENGINE_ERROR_OTHER
    
End Enum
    
Public Enum UninitDFTTSEngineReturnValue

    UNINIT_DFTTS_ENGINE_SUCCESS
    UNINIT_DFTTS_ENGINE_FAIL

End Enum

Public Enum LoadDFTTSUserDictReturnValue

    LOAD_USER_DICT_SUCCESS
    LOAD_USER_DICT_ERROR_DICTIDX_NOT_VALID
    LOAD_USER_DICT_ERROR_DICT_ALREADY_LOADED
    LOAD_USER_DICT_ERROR_DICT_WORD_ALREADY_LOADED
    LOAD_USER_DICT_ERROR_NO_DICT_FILE_OR_ENTRY
    LOAD_USER_DICT_ERROR_INVALID_DICT_FILE
    LOAD_USER_DICT_ERROR_INVALID_VOICE
    LOAD_USER_DICT_ERROR_INVALID_ARG
    LOAD_USER_DICT_ERROR_INVALID_PHONEME_SET
    LOAD_USER_DICT_ERROR_INVALID_PHONEME
    LOAD_USER_DICT_ERROR_INVALID_PARTOFSP
    LOAD_USER_DICT_ERROR_DENIED
    LOAD_USER_DICT_ERROR_OUTOFMEMORY
    LOAD_USER_DICT_ERROR_INTERNAL
    LOAD_USER_DICT_ERROR_OTHER

End Enum


Public Enum UnloadDFTTSUserDictReturnValue

    UNLOAD_USER_DICT_SUCCESS
    UNLOAD_USER_DICT_ERROR_DICTIDX_NOT_VALID
    UNLOAD_USER_DICT_ERROR_DICT_UNLOADED
    UNLOAD_USER_DICT_ERROR_NO_DICT_FILE_OR_ENTRY
    UNLOAD_USER_DICT_ERROR_INVALID_PARTOFSP
    UNLOAD_USER_DICT_ERROR_INVALID_PHONEME_SET
    UNLOAD_USER_DICT_ERROR_INTERNAL
    UNLOAD_USER_DICT_ERROR_OTHER

End Enum

Public Enum DFTTSTextType

    DFTTS_TEXT_TYPE_PLAIN
    DFTTS_TEXT_TYPE_XML
    
End Enum

Public Enum DFTTSSpeakReturnValue

    DFTTS_SPEAK_SUCCESS
    DFTTS_SPEAK_ERROR_CHANNEL_MEM_FAIL
    DFTTS_SPEAK_ERROR_TEXT_NULL
    DFTTS_SPEAK_ERROR_TEXT_ZERO_LEN
    DFTTS_SPEAK_ERROR_DB_NOT_LOADED
    DFTTS_SPEAK_ERROR_SET_SOUND_CARD_FAIL
    DFTTS_SPEAK_ERROR_UNIMPLEMENTED
    DFTTS_SPEAK_ERROR_INTERNAL
    DFTTS_SPEAK_ERROR_INVALID_PARAM
    DFTTS_SPEAK_ERROR_INVALID_POINTER
    DFTTS_SPEAK_ERROR_UNKNOWN_ENCODING
    DFTTS_SPEAK_ERROR_OBJECT_NOT_FOUND
    DFTTS_SPEAK_ERROR_INTERRUPTED
    DFTTS_SPEAK_ERROR_INVALID_VOICE
    DFTTS_SPEAK_ERROR_WRONG_EVENT
    DFTTS_SPEAK_ERROR_ENGINE_INUSE
    DFTTS_SPEAK_ERROR_NETWORK_ERROR
    DFTTS_SPEAK_ERROR_INVALID_KEY
    DFTTS_SPEAK_ERROR_QUEUE_FULL
    DFTTS_SPEAK_ERROR_TOKEN_TIMEOUT
    DFTTS_SPEAK_ERROR_FAILED
    DFTTS_SPEAK_ERROR_INVALIDARG
    DFTTS_SPEAK_ERROR_OUTOFMEMORY
    DFTTS_SPEAK_ERROR_NOTIMPL
    DFTTS_SPEAK_ERROR_ABORT
    DFTTS_SPEAK_ERROR_UNKNOWN
    DFTTS_SPEAK_ERROR_BADHANDLE
    DFTTS_SPEAK_ERROR_EXCEPTION
    DFTTS_SPEAK_ERROR_EMPTY
    DFTTS_SPEAK_ERROR_FULL
    DFTTS_SPEAK_ERROR_INVALIDSTATE
    DFTTS_SPEAK_ERROR_BADVERSION
    DFTTS_SPEAK_ERROR_INSUFFICIENT_BUFFER
    DFTTS_SPEAK_ERROR_UNSUPPORTED
    DFTTS_SPEAK_ERROR_NOLICENSE
    DFTTS_SPEAK_ERROR_CREATECHILDPROCESS_FAILED
    DFTTS_SPEAK_ERROR_NOENVIRONMENTPATH
    DFTTS_SPEAK_ERROR_TIMEOUT
    DFTTS_SPEAK_ERROR_OUTOFRESOURCES
    DFTTS_SPEAK_ERROR_NOVOICES
    DFTTS_SPEAK_ERROR_CREATEFAIL
    DFTTS_SPEAK_ERROR_CONNECTFAIL
    DFTTS_SPEAK_ERROR_BINDFAIL
    DFTTS_SPEAK_ERROR_LISTENFAIL
    DFTTS_SPEAK_ERROR_CONNECTIONCLOSED
    DFTTS_SPEAK_ERROR_ACCEPTFAIL
    DFTTS_SPEAK_ERROR_SOCKETTIMEOUT
    DFTTS_SPEAK_ERROR_SOCKETERROR
    DFTTS_SPEAK_ERROR_NOMORESERVERS
    DFTTS_SPEAK_ERROR_SOCKET_EWOULDBLOCK
    DFTTS_SPEAK_ERROR_SOCKET_EINPROGRESS
    DFTTS_SPEAK_ERROR_SOCKET_EALREADY
    DFTTS_SPEAK_ERROR_SOCKET_ENOTSOCK
    DFTTS_SPEAK_ERROR_SOCKET_EDESTADDRREQ
    DFTTS_SPEAK_ERROR_SOCKET_EMSGSIZE
    DFTTS_SPEAK_ERROR_SOCKET_EPROTOTYPE
    DFTTS_SPEAK_ERROR_SOCKET_ENOPROTOOPT
    DFTTS_SPEAK_ERROR_SOCKET_EPROTONOSUPPORT
    DFTTS_SPEAK_ERROR_SOCKET_ESOCKTNOSUPPORT
    DFTTS_SPEAK_ERROR_SOCKET_EOPNOTSUPP
    DFTTS_SPEAK_ERROR_SOCKET_EPFNOSUPPORT
    DFTTS_SPEAK_ERROR_SOCKET_EAFNOSUPPORT
    DFTTS_SPEAK_ERROR_SOCKET_EADDRINUSE
    DFTTS_SPEAK_ERROR_SOCKET_EADDRNOTAVAIL
    DFTTS_SPEAK_ERROR_SOCKET_ENETDOWN
    DFTTS_SPEAK_ERROR_SOCKET_ENETUNREACH
    DFTTS_SPEAK_ERROR_SOCKET_ENETRESET
    DFTTS_SPEAK_ERROR_SOCKET_ECONNABORTED
    DFTTS_SPEAK_ERROR_SOCKET_ECONNRESET
    DFTTS_SPEAK_ERROR_SOCKET_ENOBUFS
    DFTTS_SPEAK_ERROR_SOCKET_EISCONN
    DFTTS_SPEAK_ERROR_SOCKET_ENOTCONN
    DFTTS_SPEAK_ERROR_SOCKET_ESHUTDOWN
    DFTTS_SPEAK_ERROR_SOCKET_ETOOMANYREFS
    DFTTS_SPEAK_ERROR_SOCKET_ECONNREFUSED
    DFTTS_SPEAK_ERROR_SOCKET_ELOOP
    DFTTS_SPEAK_ERROR_SOCKET_ENAMETOOLONG
    DFTTS_SPEAK_ERROR_SOCKET_EHOSTDOWN
    DFTTS_SPEAK_ERROR_SOCKET_EHOSTUNREACH
    DFTTS_SPEAK_ERROR_SOCKET_ENOTEMPTY
    DFTTS_SPEAK_ERROR_SOCKET_EPROCLIM
    DFTTS_SPEAK_ERROR_THREADSTARTED
    DFTTS_SPEAK_ERROR_THREADNOTSTARTED
    DFTTS_SPEAK_ERROR_THREADCOULDNOTCREATE
    DFTTS_SPEAK_ERROR_BADNVFILE
    DFTTS_SPEAK_ERROR_NOAUDIODRIVER
    DFTTS_SPEAK_ERROR_DICTNOTFOUND
    DFTTS_SPEAK_ERROR_ALREADYPLAYING
    DFTTS_SPEAK_ERROR_AUDIOFORMATNOTSUPPORTED
    DFTTS_SPEAK_ERROR_XML_INVALID
    DFTTS_SPEAK_ERROR_WL_INVALID
    DFTTS_SPEAK_ERROR_INVALIDPHONESET
    DFTTS_SPEAK_ERROR_INVALIDPHONEME
    DFTTS_SPEAK_ERROR_MSGQ_CREATEFAILED
    DFTTS_SPEAK_ERROR_MSGQ_ALREADYEXISTS
    DFTTS_SPEAK_ERROR_MSGQ_NOTFOUND
    DFTTS_SPEAK_ERROR_MSGQ_INVALIDOP
    DFTTS_SPEAK_ERROR_MSGQ_NOTOPEN
    DFTTS_SPEAK_ERROR_MSGQ_LOCKFAILED
    DFTTS_SPEAK_ERROR_MSGQ_ABANDONED
    DFTTS_SPEAK_ERROR_MSGQ_OPENFAILED
    DFTTS_SPEAK_ERROR_OTHER
    
End Enum


Public Enum DFTTSPauseReturnValue

    DFTTS_PAUSE_SUCCESS
    DFTTS_PAUSE_ERROR_UNIMPLEMENTED
    DFTTS_PAUSE_ERROR_INTERNAL
    DFTTS_PAUSE_ERROR_INVALID_PARAM
    DFTTS_PAUSE_ERROR_INVALID_POINTER
    DFTTS_PAUSE_ERROR_OBJECT_NOT_FOUND
    DFTTS_PAUSE_ERROR_UNKNOWN_ENCODING
    DFTTS_PAUSE_ERROR_INTERRUPTED
    DFTTS_PAUSE_ERROR_INVALID_VOICE
    DFTTS_PAUSE_ERROR_WRONG_EVENT
    DFTTS_PAUSE_ERROR_ENGINE_INUSE
    DFTTS_PAUSE_ERROR_NETWORK_ERROR
    DFTTS_PAUSE_ERROR_INVALID_KEY
    DFTTS_PAUSE_ERROR_QUEUE_FULL
    DFTTS_PAUSE_ERROR_TOKEN_TIMEOUT
    DFTTS_PAUSE_ERROR_OTHER

End Enum


Public Enum DFTTSResumeReturnValue

    DFTTS_RESUME_SUCCESS
    DFTTS_RESUME_ERROR_UNIMPLEMENTED
    DFTTS_RESUME_ERROR_INTERNAL
    DFTTS_RESUME_ERROR_INVALID_PARAM
    DFTTS_RESUME_ERROR_INVALID_POINTER
    DFTTS_RESUME_ERROR_OBJECT_NOT_FOUND
    DFTTS_RESUME_ERROR_UNKNOWN_ENCODING
    DFTTS_RESUME_ERROR_INTERRUPTED
    DFTTS_RESUME_ERROR_INVALID_VOICE
    DFTTS_RESUME_ERROR_WRONG_EVENT
    DFTTS_RESUME_ERROR_ENGINE_INUSE
    DFTTS_RESUME_ERROR_NETWORK_ERROR
    DFTTS_RESUME_ERROR_INVALID_KEY
    DFTTS_RESUME_ERROR_QUEUE_FULL
    DFTTS_RESUME_ERROR_TOKEN_TIMEOUT
    DFTTS_RESUME_ERROR_FAILED
    DFTTS_RESUME_ERROR_INVALIDARG
    DFTTS_RESUME_ERROR_OUTOFMEMORY
    DFTTS_RESUME_ERROR_NOTIMPL
    DFTTS_RESUME_ERROR_ABORT
    DFTTS_RESUME_ERROR_UNKNOWN
    DFTTS_RESUME_ERROR_BADHANDLE
    DFTTS_RESUME_ERROR_EXCEPTION
    DFTTS_RESUME_ERROR_EMPTY
    DFTTS_RESUME_ERROR_FULL
    DFTTS_RESUME_ERROR_INVALIDSTATE
    DFTTS_RESUME_ERROR_BADVERSION
    DFTTS_RESUME_ERROR_INSUFFICIENT_BUFFER
    DFTTS_RESUME_ERROR_UNSUPPORTED
    DFTTS_RESUME_ERROR_NOLICENSE
    DFTTS_RESUME_ERROR_CREATECHILDPROCESS_FAILED
    DFTTS_RESUME_ERROR_NOENVIRONMENTPATH
    DFTTS_RESUME_ERROR_TIMEOUT
    DFTTS_RESUME_ERROR_OUTOFRESOURCES
    DFTTS_RESUME_ERROR_NOVOICES
    DFTTS_RESUME_ERROR_CREATEFAIL
    DFTTS_RESUME_ERROR_CONNECTFAIL
    DFTTS_RESUME_ERROR_BINDFAIL
    DFTTS_RESUME_ERROR_LISTENFAIL
    DFTTS_RESUME_ERROR_CONNECTIONCLOSED
    DFTTS_RESUME_ERROR_ACCEPTFAIL
    DFTTS_RESUME_ERROR_SOCKETTIMEOUT
    DFTTS_RESUME_ERROR_SOCKETERROR
    DFTTS_RESUME_ERROR_NOMORESERVERS
    DFTTS_RESUME_ERROR_SOCKET_EWOULDBLOCK
    DFTTS_RESUME_ERROR_SOCKET_EINPROGRESS
    DFTTS_RESUME_ERROR_SOCKET_EALREADY
    DFTTS_RESUME_ERROR_SOCKET_ENOTSOCK
    DFTTS_RESUME_ERROR_SOCKET_EDESTADDRREQ
    DFTTS_RESUME_ERROR_SOCKET_EMSGSIZE
    DFTTS_RESUME_ERROR_SOCKET_EPROTOTYPE
    DFTTS_RESUME_ERROR_SOCKET_ENOPROTOOPT
    DFTTS_RESUME_ERROR_SOCKET_EPROTONOSUPPORT
    DFTTS_RESUME_ERROR_SOCKET_ESOCKTNOSUPPORT
    DFTTS_RESUME_ERROR_SOCKET_EOPNOTSUPP
    DFTTS_RESUME_ERROR_SOCKET_EPFNOSUPPORT
    DFTTS_RESUME_ERROR_SOCKET_EAFNOSUPPORT
    DFTTS_RESUME_ERROR_SOCKET_EADDRINUSE
    DFTTS_RESUME_ERROR_SOCKET_EADDRNOTAVAIL
    DFTTS_RESUME_ERROR_SOCKET_ENETDOWN
    DFTTS_RESUME_ERROR_SOCKET_ENETUNREACH
    DFTTS_RESUME_ERROR_SOCKET_ENETRESET
    DFTTS_RESUME_ERROR_SOCKET_ECONNABORTED
    DFTTS_RESUME_ERROR_SOCKET_ECONNRESET
    DFTTS_RESUME_ERROR_SOCKET_ENOBUFS
    DFTTS_RESUME_ERROR_SOCKET_EISCONN
    DFTTS_RESUME_ERROR_SOCKET_ENOTCONN
    DFTTS_RESUME_ERROR_SOCKET_ESHUTDOWN
    DFTTS_RESUME_ERROR_SOCKET_ETOOMANYREFS
    DFTTS_RESUME_ERROR_SOCKET_ECONNREFUSED
    DFTTS_RESUME_ERROR_SOCKET_ELOOP
    DFTTS_RESUME_ERROR_SOCKET_ENAMETOOLONG
    DFTTS_RESUME_ERROR_SOCKET_EHOSTDOWN
    DFTTS_RESUME_ERROR_SOCKET_EHOSTUNREACH
    DFTTS_RESUME_ERROR_SOCKET_ENOTEMPTY
    DFTTS_RESUME_ERROR_SOCKET_EPROCLIM
    DFTTS_RESUME_ERROR_THREADSTARTED
    DFTTS_RESUME_ERROR_THREADNOTSTARTED
    DFTTS_RESUME_ERROR_THREADCOULDNOTCREATE
    DFTTS_RESUME_ERROR_BADNVFILE
    DFTTS_RESUME_ERROR_NOAUDIODRIVER
    DFTTS_RESUME_ERROR_DICTNOTFOUND
    DFTTS_RESUME_ERROR_ALREADYPLAYING
    DFTTS_RESUME_ERROR_AUDIOFORMATNOTSUPPORTED
    DFTTS_RESUME_ERROR_XML_INVALID
    DFTTS_RESUME_ERROR_WL_INVALID
    DFTTS_RESUME_ERROR_INVALIDPHONESET
    DFTTS_RESUME_ERROR_INVALIDPHONEME
    DFTTS_RESUME_ERROR_MSGQ_CREATEFAILED
    DFTTS_RESUME_ERROR_MSGQ_ALREADYEXISTS
    DFTTS_RESUME_ERROR_MSGQ_NOTFOUND
    DFTTS_RESUME_ERROR_MSGQ_INVALIDOP
    DFTTS_RESUME_ERROR_MSGQ_NOTOPEN
    DFTTS_RESUME_ERROR_MSGQ_LOCKFAILED
    DFTTS_RESUME_ERROR_MSGQ_ABANDONED
    DFTTS_RESUME_ERROR_MSGQ_OPENFAILED
    DFTTS_RESUME_ERROR_NOTHING_TO_RESUME
    DFTTS_RESUME_ERROR_OTHER


End Enum

Public Enum DFTTSStopReturnValue

    DFTTS_STOP_SUCCESS
    DFTTS_STOP_ERROR_INVALID_POINTER
    DFTTS_STOP_ERROR_INVALID_ARG
    DFTTS_STOP_ERROR_OUT_OF_MEMORY
    DFTTS_STOP_ERROR_INVALID_FLAGS
    DFTTS_STOP_ERROR_ENGINE_INUSE
    DFTTS_STOP_ERROR_OTHER
    
End Enum

Public Enum DFTTSExportReturnValue

    DFTTS_EXPORT_SUCCESS
    DFTTS_EXPORT_ERROR_FORMAT_NOT_SUPPORTED
    DFTTS_EXPORT_ERROR_CHANNEL_MEM_FAIL
    DFTTS_EXPORT_ERROR_TEXT_NULL
    DFTTS_EXPORT_ERROR_TEXT_ZERO_LEN
    DFTTS_EXPORT_ERROR_DB_NOT_LOADED
    DFTTS_EXPORT_ERROR_GEN_FILE_FAIL
    DFTTS_EXPORT_ERROR_BUFFER_NULL
    DFTTS_EXPORT_ERROR_THREAD_IN_USE
    DFTTS_EXPORT_ERROR_UNIMPLEMENTED
    DFTTS_EXPORT_ERROR_INTERNAL
    DFTTS_EXPORT_ERROR_INVALID_PARAM
    DFTTS_EXPORT_ERROR_INVALID_POINTER
    DFTTS_EXPORT_ERROR_OBJECT_NOT_FOUND
    DFTTS_EXPORT_ERROR_UNKNOWN_ENCODING
    DFTTS_EXPORT_ERROR_INTERRUPTED
    DFTTS_EXPORT_ERROR_INVALID_VOICE
    DFTTS_EXPORT_ERROR_WRONG_EVENT
    DFTTS_EXPORT_ERROR_ENGINE_INUSE
    DFTTS_EXPORT_ERROR_NETWORK_ERROR
    DFTTS_EXPORT_ERROR_INVALID_KEY
    DFTTS_EXPORT_ERROR_QUEUE_FULL
    DFTTS_EXPORT_ERROR_TOKEN_TIMEOUT
    DFTTS_EXPORT_ERROR_FAILED
    DFTTS_EXPORT_ERROR_INVALIDARG
    DFTTS_EXPORT_ERROR_OUTOFMEMORY
    DFTTS_EXPORT_ERROR_NOTIMPL
    DFTTS_EXPORT_ERROR_ABORT
    DFTTS_EXPORT_ERROR_UNKNOWN
    DFTTS_EXPORT_ERROR_BADHANDLE
    DFTTS_EXPORT_ERROR_EXCEPTION
    DFTTS_EXPORT_ERROR_EMPTY
    DFTTS_EXPORT_ERROR_FULL
    DFTTS_EXPORT_ERROR_INVALIDSTATE
    DFTTS_EXPORT_ERROR_BADVERSION
    DFTTS_EXPORT_ERROR_INSUFFICIENT_BUFFER
    DFTTS_EXPORT_ERROR_UNSUPPORTED
    DFTTS_EXPORT_ERROR_NOLICENSE
    DFTTS_EXPORT_ERROR_CREATECHILDPROCESS_FAILED
    DFTTS_EXPORT_ERROR_NOENVIRONMENTPATH
    DFTTS_EXPORT_ERROR_TIMEOUT
    DFTTS_EXPORT_ERROR_OUTOFRESOURCES
    DFTTS_EXPORT_ERROR_NOVOICES
    DFTTS_EXPORT_ERROR_CREATEFAIL
    DFTTS_EXPORT_ERROR_CONNECTFAIL
    DFTTS_EXPORT_ERROR_BINDFAIL
    DFTTS_EXPORT_ERROR_LISTENFAIL
    DFTTS_EXPORT_ERROR_CONNECTIONCLOSED
    DFTTS_EXPORT_ERROR_ACCEPTFAIL
    DFTTS_EXPORT_ERROR_SOCKETTIMEOUT
    DFTTS_EXPORT_ERROR_SOCKETERROR
    DFTTS_EXPORT_ERROR_NOMORESERVERS
    DFTTS_EXPORT_ERROR_SOCKET_EWOULDBLOCK
    DFTTS_EXPORT_ERROR_SOCKET_EINPROGRESS
    DFTTS_EXPORT_ERROR_SOCKET_EALREADY
    DFTTS_EXPORT_ERROR_SOCKET_ENOTSOCK
    DFTTS_EXPORT_ERROR_SOCKET_EDESTADDRREQ
    DFTTS_EXPORT_ERROR_SOCKET_EMSGSIZE
    DFTTS_EXPORT_ERROR_SOCKET_EPROTOTYPE
    DFTTS_EXPORT_ERROR_SOCKET_ENOPROTOOPT
    DFTTS_EXPORT_ERROR_SOCKET_EPROTONOSUPPORT
    DFTTS_EXPORT_ERROR_SOCKET_ESOCKTNOSUPPORT
    DFTTS_EXPORT_ERROR_SOCKET_EOPNOTSUPP
    DFTTS_EXPORT_ERROR_SOCKET_EPFNOSUPPORT
    DFTTS_EXPORT_ERROR_SOCKET_EAFNOSUPPORT
    DFTTS_EXPORT_ERROR_SOCKET_EADDRINUSE
    DFTTS_EXPORT_ERROR_SOCKET_EADDRNOTAVAIL
    DFTTS_EXPORT_ERROR_SOCKET_ENETDOWN
    DFTTS_EXPORT_ERROR_SOCKET_ENETUNREACH
    DFTTS_EXPORT_ERROR_SOCKET_ENETRESET
    DFTTS_EXPORT_ERROR_SOCKET_ECONNABORTED
    DFTTS_EXPORT_ERROR_SOCKET_ECONNRESET
    DFTTS_EXPORT_ERROR_SOCKET_ENOBUFS
    DFTTS_EXPORT_ERROR_SOCKET_EISCONN
    DFTTS_EXPORT_ERROR_SOCKET_ENOTCONN
    DFTTS_EXPORT_ERROR_SOCKET_ESHUTDOWN
    DFTTS_EXPORT_ERROR_SOCKET_ETOOMANYREFS
    DFTTS_EXPORT_ERROR_SOCKET_ECONNREFUSED
    DFTTS_EXPORT_ERROR_SOCKET_ELOOP
    DFTTS_EXPORT_ERROR_SOCKET_ENAMETOOLONG
    DFTTS_EXPORT_ERROR_SOCKET_EHOSTDOWN
    DFTTS_EXPORT_ERROR_SOCKET_EHOSTUNREACH
    DFTTS_EXPORT_ERROR_SOCKET_ENOTEMPTY
    DFTTS_EXPORT_ERROR_SOCKET_EPROCLIM
    DFTTS_EXPORT_ERROR_THREADSTARTED
    DFTTS_EXPORT_ERROR_THREADNOTSTARTED
    DFTTS_EXPORT_ERROR_THREADCOULDNOTCREATE
    DFTTS_EXPORT_ERROR_BADNVFILE
    DFTTS_EXPORT_ERROR_NOAUDIODRIVER
    DFTTS_EXPORT_ERROR_DICTNOTFOUND
    DFTTS_EXPORT_ERROR_ALREADYPLAYING
    DFTTS_EXPORT_ERROR_AUDIOFORMATNOTSUPPORTED
    DFTTS_EXPORT_ERROR_XML_INVALID
    DFTTS_EXPORT_ERROR_WL_INVALID
    DFTTS_EXPORT_ERROR_INVALIDPHONESET
    DFTTS_EXPORT_ERROR_INVALIDPHONEME
    DFTTS_EXPORT_ERROR_MSGQ_CREATEFAILED
    DFTTS_EXPORT_ERROR_MSGQ_ALREADYEXISTS
    DFTTS_EXPORT_ERROR_MSGQ_NOTFOUND
    DFTTS_EXPORT_ERROR_MSGQ_INVALIDOP
    DFTTS_EXPORT_ERROR_MSGQ_NOTOPEN
    DFTTS_EXPORT_ERROR_MSGQ_LOCKFAILED
    DFTTS_EXPORT_ERROR_MSGQ_ABANDONED
    DFTTS_EXPORT_ERROR_MSGQ_OPENFAILED
    DFTTS_EXPORT_ERROR_OTHER

End Enum

Public Enum DFTTSVoiceInfoReturnValue

    GET_DFTTS_VI_SUCCESS
    GET_DFTTS_VI_NO_MORE_ITEMS
    GET_DFTTS_VI_ERROR_BUFFER_TOO_SMALL
    GET_DFTTS_VI_ERROR_OTHER

End Enum

'
'  Language IDs.
'
'  The following two combinations of primary language ID and
'  sublanguage ID have special semantics:
'
'    Primary Language ID   Sublanguage ID      Result
'    -------------------   ---------------     ------------------------
'    LANG_NEUTRAL          SUBLANG_NEUTRAL     Language neutral
'    LANG_NEUTRAL          SUBLANG_DEFAULT     User default language
'    LANG_NEUTRAL          SUBLANG_SYS_DEFAULT System default language
'    LANG_INVARIANT        SUBLANG_NEUTRAL     Invariant locale
'

'
'  Primary language IDs.
'

Public Const LANG_NEUTRAL = &H0
Public Const LANG_INVARIANT = &H7F

Public Const LANG_AFRIKAANS = &H36
Public Const LANG_ALBANIAN = &H1C
Public Const LANG_ALSATIAN = &H84
Public Const LANG_AMHARIC = &H5E
Public Const LANG_ARABIC = &H1
Public Const LANG_ARMENIAN = &H2B
Public Const LANG_ASSAMESE = &H4D
Public Const LANG_AZERI = &H2C
Public Const LANG_BASHKIR = &H6D
Public Const LANG_BASQUE = &H2D
Public Const LANG_BELARUSIAN = &H23
Public Const LANG_BENGALI = &H45
Public Const LANG_BRETON = &H7E
Public Const LANG_BOSNIAN = &H1A                       ' Use with SUBLANG_BOSNIAN_* Sublanguage IDs
Public Const LANG_BOSNIAN_NEUTRAL = &H781A             ' Use with the ConvertDefaultLocale function
Public Const LANG_BULGARIAN = &H2
Public Const LANG_CATALAN = &H3
Public Const LANG_CHINESE = &H4                        ' Use with SUBLANG_CHINESE_* Sublanguage IDs
Public Const LANG_CHINESE_SIMPLIFIED = &H4             ' Use with the ConvertDefaultLocale function
Public Const LANG_CHINESE_TRADITIONAL = &H7C04         ' Use with the ConvertDefaultLocale function
Public Const LANG_CORSICAN = &H83
Public Const LANG_CROATIAN = &H1A
Public Const LANG_CZECH = &H5
Public Const LANG_DANISH = &H6
Public Const LANG_DARI = &H8C
Public Const LANG_DIVEHI = &H65
Public Const LANG_DUTCH = &H13
Public Const LANG_ENGLISH = &H9
Public Const LANG_ESTONIAN = &H25
Public Const LANG_FAEROESE = &H38
Public Const LANG_FARSI = &H29                         ' Deprecated: use LANG_PERSIAN instead
Public Const LANG_FILIPINO = &H64
Public Const LANG_FINNISH = &HB
Public Const LANG_FRENCH = &HC
Public Const LANG_FRISIAN = &H62
Public Const LANG_GALICIAN = &H56
Public Const LANG_GEORGIAN = &H37
Public Const LANG_GERMAN = &H7
Public Const LANG_GREEK = &H8
Public Const LANG_GREENLANDIC = &H6F
Public Const LANG_GUJARATI = &H47
Public Const LANG_HAUSA = &H68
Public Const LANG_HEBREW = &HD
Public Const LANG_HINDI = &H39
Public Const LANG_HUNGARIAN = &HE
Public Const LANG_ICELANDIC = &HF
Public Const LANG_IGBO = &H70
Public Const LANG_INDONESIAN = &H21
Public Const LANG_INUKTITUT = &H5D
Public Const LANG_IRISH = &H3C                         ' Use with the SUBLANG_IRISH_IRELAND Sublanguage ID
Public Const LANG_ITALIAN = &H10
Public Const LANG_JAPANESE = &H11
Public Const LANG_KANNADA = &H4B
Public Const LANG_KASHMIRI = &H60
Public Const LANG_KAZAK = &H3F
Public Const LANG_KHMER = &H53
Public Const LANG_KICHE = &H86
Public Const LANG_KINYARWANDA = &H87
Public Const LANG_KONKANI = &H57
Public Const LANG_KOREAN = &H12
Public Const LANG_KYRGYZ = &H40
Public Const LANG_LAO = &H54
Public Const LANG_LATVIAN = &H26
Public Const LANG_LITHUANIAN = &H27
Public Const LANG_LOWER_SORBIAN = &H2E
Public Const LANG_LUXEMBOURGISH = &H6E
Public Const LANG_MACEDONIAN = &H2F                    ' the Former Yugoslav Republic of Macedonia
Public Const LANG_MALAY = &H3E
Public Const LANG_MALAYALAM = &H4C
Public Const LANG_MALTESE = &H3A
Public Const LANG_MANIPURI = &H58
Public Const LANG_MAORI = &H81
Public Const LANG_MAPUDUNGUN = &H7A
Public Const LANG_MARATHI = &H4E
Public Const LANG_MOHAWK = &H7C
Public Const LANG_MONGOLIAN = &H50
Public Const LANG_NEPALI = &H61
Public Const LANG_NORWEGIAN = &H14
Public Const LANG_OCCITAN = &H82
Public Const LANG_ORIYA = &H48
Public Const LANG_PASHTO = &H63
Public Const LANG_PERSIAN = &H29
Public Const LANG_POLISH = &H15
Public Const LANG_PORTUGUESE = &H16
Public Const LANG_PUNJABI = &H46
Public Const LANG_QUECHUA = &H6B
Public Const LANG_ROMANIAN = &H18
Public Const LANG_ROMANSH = &H17
Public Const LANG_RUSSIAN = &H19
Public Const LANG_SAMI = &H3B
Public Const LANG_SANSKRIT = &H4F
Public Const LANG_SERBIAN = &H1A                       ' Use with the SUBLANG_SERBIAN_* Sublanguage IDs
Public Const LANG_SERBIAN_NEUTRAL = &H7C1A             ' Use with the ConvertDefaultLocale function
Public Const LANG_SINDHI = &H59
Public Const LANG_SINHALESE = &H5B
Public Const LANG_SLOVAK = &H1B
Public Const LANG_SLOVENIAN = &H24
Public Const LANG_SOTHO = &H6C
Public Const LANG_SPANISH = &HA
Public Const LANG_SWAHILI = &H41
Public Const LANG_SWEDISH = &H1D
Public Const LANG_SYRIAC = &H5A
Public Const LANG_TAJIK = &H28
Public Const LANG_TAMAZIGHT = &H5F
Public Const LANG_TAMIL = &H49
Public Const LANG_TATAR = &H44
Public Const LANG_TELUGU = &H4A
Public Const LANG_THAI = &H1E
Public Const LANG_TIBETAN = &H51
Public Const LANG_TIGRIGNA = &H73
Public Const LANG_TSWANA = &H32
Public Const LANG_TURKISH = &H1F
Public Const LANG_TURKMEN = &H42
Public Const LANG_UIGHUR = &H80
Public Const LANG_UKRAINIAN = &H22
Public Const LANG_UPPER_SORBIAN = &H2E
Public Const LANG_URDU = &H20
Public Const LANG_UZBEK = &H43
Public Const LANG_VIETNAMESE = &H2A
Public Const LANG_WELSH = &H52
Public Const LANG_WOLOF = &H88
Public Const LANG_XHOSA = &H34
Public Const LANG_YAKUT = &H85
Public Const LANG_YI = &H78
Public Const LANG_YORUBA = &H6A
Public Const LANG_ZULU = &H35

'
'  Sublanguage IDs.
'
'  The name immediately following SUBLANG_ dictates which primary
'  language ID that sublanguage ID can be combined with to form a
'  valid language ID.
'

Public Const SUBLANG_NEUTRAL = &H0                                 ' language neutral
Public Const SUBLANG_DEFAULT = &H1                                 ' user default
Public Const SUBLANG_SYS_DEFAULT = &H2                             ' system default
Public Const SUBLANG_CUSTOM_DEFAULT = &H3                          ' default custom language/locale
Public Const SUBLANG_CUSTOM_UNSPECIFIED = &H4                      ' custom language/locale
Public Const SUBLANG_UI_CUSTOM_DEFAULT = &H5                       ' Default custom MUI language/locale


Public Const SUBLANG_AFRIKAANS_SOUTH_AFRICA = &H1                  ' Afrikaans (South Africa) = &H0436 af-ZA
Public Const SUBLANG_ALBANIAN_ALBANIA = &H1                        ' Albanian (Albania) = &H041c sq-AL
Public Const SUBLANG_ALSATIAN_FRANCE = &H1                         ' Alsatian (France) = &H0484
Public Const SUBLANG_AMHARIC_ETHIOPIA = &H1                        ' Amharic (Ethiopia) = &H045e
Public Const SUBLANG_ARABIC_SAUDI_ARABIA = &H1                     ' Arabic (Saudi Arabia)
Public Const SUBLANG_ARABIC_IRAQ = &H2                             ' Arabic (Iraq)
Public Const SUBLANG_ARABIC_EGYPT = &H3                            ' Arabic (Egypt)
Public Const SUBLANG_ARABIC_LIBYA = &H4                            ' Arabic (Libya)
Public Const SUBLANG_ARABIC_ALGERIA = &H5                          ' Arabic (Algeria)
Public Const SUBLANG_ARABIC_MOROCCO = &H6                          ' Arabic (Morocco)
Public Const SUBLANG_ARABIC_TUNISIA = &H7                          ' Arabic (Tunisia)
Public Const SUBLANG_ARABIC_OMAN = &H8                             ' Arabic (Oman)
Public Const SUBLANG_ARABIC_YEMEN = &H9                            ' Arabic (Yemen)
Public Const SUBLANG_ARABIC_SYRIA = &HA                            ' Arabic (Syria)
Public Const SUBLANG_ARABIC_JORDAN = &HB                           ' Arabic (Jordan)
Public Const SUBLANG_ARABIC_LEBANON = &HC                          ' Arabic (Lebanon)
Public Const SUBLANG_ARABIC_KUWAIT = &HD                           ' Arabic (Kuwait)
Public Const SUBLANG_ARABIC_UAE = &HE                              ' Arabic (U.A.E)
Public Const SUBLANG_ARABIC_BAHRAIN = &HF                          ' Arabic (Bahrain)
Public Const SUBLANG_ARABIC_QATAR = &H10                           ' Arabic (Qatar)
Public Const SUBLANG_ARMENIAN_ARMENIA = &H1                        ' Armenian (Armenia) = &H042b hy-AM
Public Const SUBLANG_ASSAMESE_INDIA = &H1                          ' Assamese (India) = &H044d
Public Const SUBLANG_AZERI_LATIN = &H1                             ' Azeri (Latin)
Public Const SUBLANG_AZERI_CYRILLIC = &H2                          ' Azeri (Cyrillic)
Public Const SUBLANG_BASHKIR_RUSSIA = &H1                          ' Bashkir (Russia) = &H046d ba-RU
Public Const SUBLANG_BASQUE_BASQUE = &H1                           ' Basque (Basque) = &H042d eu-ES
Public Const SUBLANG_BELARUSIAN_BELARUS = &H1                      ' Belarusian (Belarus) = &H0423 be-BY
Public Const SUBLANG_BENGALI_INDIA = &H1                           ' Bengali (India)
Public Const SUBLANG_BENGALI_BANGLADESH = &H2                      ' Bengali (Bangladesh)
Public Const SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN = &H5        ' Bosnian (Bosnia and Herzegovina - Latin) = &H141a bs-BA-Latn
Public Const SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC = &H8     ' Bosnian (Bosnia and Herzegovina - Cyrillic) = &H201a bs-BA-Cyrl
Public Const SUBLANG_BRETON_FRANCE = &H1                           ' Breton (France) = &H047e
Public Const SUBLANG_BULGARIAN_BULGARIA = &H1                      ' Bulgarian (Bulgaria) = &H0402
Public Const SUBLANG_CATALAN_CATALAN = &H1                         ' Catalan (Catalan) = &H0403
Public Const SUBLANG_CHINESE_TRADITIONAL = &H1                     ' Chinese (Taiwan) = &H0404 zh-TW
Public Const SUBLANG_CHINESE_SIMPLIFIED = &H2                      ' Chinese (PR China) = &H0804 zh-CN
Public Const SUBLANG_CHINESE_HONGKONG = &H3                        ' Chinese (Hong Kong S.A.R., P.R.C.) = &H0c04 zh-HK
Public Const SUBLANG_CHINESE_SINGAPORE = &H4                       ' Chinese (Singapore) = &H1004 zh-SG
Public Const SUBLANG_CHINESE_MACAU = &H5                           ' Chinese (Macau S.A.R.) = &H1404 zh-MO
Public Const SUBLANG_CORSICAN_FRANCE = &H1                         ' Corsican (France) = &H0483
Public Const SUBLANG_CZECH_CZECH_REPUBLIC = &H1                    ' Czech (Czech Republic) = &H0405
Public Const SUBLANG_CROATIAN_CROATIA = &H1                        ' Croatian (Croatia)
Public Const SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN = &H4       ' Croatian (Bosnia and Herzegovina - Latin) = &H101a hr-BA
Public Const SUBLANG_DANISH_DENMARK = &H1                          ' Danish (Denmark) = &H0406
Public Const SUBLANG_DARI_AFGHANISTAN = &H1                        ' Dari (Afghanistan)
Public Const SUBLANG_DIVEHI_MALDIVES = &H1                         ' Divehi (Maldives) = &H0465 div-MV
Public Const SUBLANG_DUTCH = &H1                                   ' Dutch
Public Const SUBLANG_DUTCH_BELGIAN = &H2                           ' Dutch (Belgian)
Public Const SUBLANG_ENGLISH_US = &H1                              ' English (USA)
Public Const SUBLANG_ENGLISH_UK = &H2                              ' English (UK)
Public Const SUBLANG_ENGLISH_AUS = &H3                             ' English (Australian)
Public Const SUBLANG_ENGLISH_CAN = &H4                             ' English (Canadian)
Public Const SUBLANG_ENGLISH_NZ = &H5                              ' English (New Zealand)
Public Const SUBLANG_ENGLISH_EIRE = &H6                            ' English (Irish)
Public Const SUBLANG_ENGLISH_SOUTH_AFRICA = &H7                    ' English (South Africa)
Public Const SUBLANG_ENGLISH_JAMAICA = &H8                         ' English (Jamaica)
Public Const SUBLANG_ENGLISH_CARIBBEAN = &H9                       ' English (Caribbean)
Public Const SUBLANG_ENGLISH_BELIZE = &HA                          ' English (Belize)
Public Const SUBLANG_ENGLISH_TRINIDAD = &HB                        ' English (Trinidad)
Public Const SUBLANG_ENGLISH_ZIMBABWE = &HC                        ' English (Zimbabwe)
Public Const SUBLANG_ENGLISH_PHILIPPINES = &HD                     ' English (Philippines)
Public Const SUBLANG_ENGLISH_INDIA = &H10                          ' English (India)
Public Const SUBLANG_ENGLISH_MALAYSIA = &H11                       ' English (Malaysia)
Public Const SUBLANG_ENGLISH_SINGAPORE = &H12                      ' English (Singapore)
Public Const SUBLANG_ESTONIAN_ESTONIA = &H1                        ' Estonian (Estonia) = &H0425 et-EE
Public Const SUBLANG_FAEROESE_FAROE_ISLANDS = &H1                  ' Faroese (Faroe Islands) = &H0438 fo-FO
Public Const SUBLANG_FILIPINO_PHILIPPINES = &H1                    ' Filipino (Philippines) = &H0464 fil-PH
Public Const SUBLANG_FINNISH_FINLAND = &H1                         ' Finnish (Finland) = &H040b
Public Const SUBLANG_FRENCH = &H1                                  ' French
Public Const SUBLANG_FRENCH_BELGIAN = &H2                          ' French (Belgian)
Public Const SUBLANG_FRENCH_CANADIAN = &H3                         ' French (Canadian)
Public Const SUBLANG_FRENCH_SWISS = &H4                            ' French (Swiss)
Public Const SUBLANG_FRENCH_LUXEMBOURG = &H5                       ' French (Luxembourg)
Public Const SUBLANG_FRENCH_MONACO = &H6                           ' French (Monaco)
Public Const SUBLANG_FRISIAN_NETHERLANDS = &H1                     ' Frisian (Netherlands) = &H0462 fy-NL
Public Const SUBLANG_GALICIAN_GALICIAN = &H1                       ' Galician (Galician) = &H0456 gl-ES
Public Const SUBLANG_GEORGIAN_GEORGIA = &H1                        ' Georgian (Georgia) = &H0437 ka-GE
Public Const SUBLANG_GERMAN = &H1                                  ' German
Public Const SUBLANG_GERMAN_SWISS = &H2                            ' German (Swiss)
Public Const SUBLANG_GERMAN_AUSTRIAN = &H3                         ' German (Austrian)
Public Const SUBLANG_GERMAN_LUXEMBOURG = &H4                       ' German (Luxembourg)
Public Const SUBLANG_GERMAN_LIECHTENSTEIN = &H5                    ' German (Liechtenstein)
Public Const SUBLANG_GREEK_GREECE = &H1                            ' Greek (Greece)
Public Const SUBLANG_GREENLANDIC_GREENLAND = &H1                   ' Greenlandic (Greenland) = &H046f kl-GL
Public Const SUBLANG_GUJARATI_INDIA = &H1                          ' Gujarati (India (Gujarati Script)) = &H0447 gu-IN
Public Const SUBLANG_HAUSA_NIGERIA_LATIN = &H1                     ' Hausa (Latin, Nigeria) = &H0468 ha-NG-Latn
Public Const SUBLANG_HEBREW_ISRAEL = &H1                           ' Hebrew (Israel) = &H040d
Public Const SUBLANG_HINDI_INDIA = &H1                             ' Hindi (India) = &H0439 hi-IN
Public Const SUBLANG_HUNGARIAN_HUNGARY = &H1                       ' Hungarian (Hungary) = &H040e
Public Const SUBLANG_ICELANDIC_ICELAND = &H1                       ' Icelandic (Iceland) = &H040f
Public Const SUBLANG_IGBO_NIGERIA = &H1                            ' Igbo (Nigeria) = &H0470 ig-NG
Public Const SUBLANG_INDONESIAN_INDONESIA = &H1                    ' Indonesian (Indonesia) = &H0421 id-ID
Public Const SUBLANG_INUKTITUT_CANADA = &H1                        ' Inuktitut (Syllabics) (Canada) = &H045d iu-CA-Cans
Public Const SUBLANG_INUKTITUT_CANADA_LATIN = &H2                  ' Inuktitut (Canada - Latin)
Public Const SUBLANG_IRISH_IRELAND = &H2                           ' Irish (Ireland)
Public Const SUBLANG_ITALIAN = &H1                                 ' Italian
Public Const SUBLANG_ITALIAN_SWISS = &H2                           ' Italian (Swiss)
Public Const SUBLANG_JAPANESE_JAPAN = &H1                          ' Japanese (Japan) = &H0411
Public Const SUBLANG_KANNADA_INDIA = &H1                           ' Kannada (India (Kannada Script)) = &H044b kn-IN
Public Const SUBLANG_KASHMIRI_SASIA = &H2                          ' Kashmiri (South Asia)
Public Const SUBLANG_KASHMIRI_INDIA = &H2                          ' For app compatibility only
Public Const SUBLANG_KAZAK_KAZAKHSTAN = &H1                        ' Kazakh (Kazakhstan) = &H043f kk-KZ
Public Const SUBLANG_KHMER_CAMBODIA = &H1                          ' Khmer (Cambodia) = &H0453 kh-KH
Public Const SUBLANG_KICHE_GUATEMALA = &H1                         ' K'iche (Guatemala)
Public Const SUBLANG_KINYARWANDA_RWANDA = &H1                      ' Kinyarwanda (Rwanda) = &H0487 rw-RW
Public Const SUBLANG_KONKANI_INDIA = &H1                           ' Konkani (India) = &H0457 kok-IN
Public Const SUBLANG_KOREAN = &H1                                  ' Korean (Extended Wansung)
Public Const SUBLANG_KYRGYZ_KYRGYZSTAN = &H1                       ' Kyrgyz (Kyrgyzstan) = &H0440 ky-KG
Public Const SUBLANG_LAO_LAO = &H1                                 ' Lao (Lao PDR) = &H0454 lo-LA
Public Const SUBLANG_LATVIAN_LATVIA = &H1                          ' Latvian (Latvia) = &H0426 lv-LV
Public Const SUBLANG_LITHUANIAN = &H1                              ' Lithuanian
Public Const SUBLANG_LOWER_SORBIAN_GERMANY = &H2                   ' Lower Sorbian (Germany) = &H082e wee-DE
Public Const SUBLANG_LUXEMBOURGISH_LUXEMBOURG = &H1                ' Luxembourgish (Luxembourg) = &H046e lb-LU
Public Const SUBLANG_MACEDONIAN_MACEDONIA = &H1                    ' Macedonian (Macedonia (FYROM)) = &H042f mk-MK
Public Const SUBLANG_MALAY_MALAYSIA = &H1                          ' Malay (Malaysia)
Public Const SUBLANG_MALAY_BRUNEI_DARUSSALAM = &H2                 ' Malay (Brunei Darussalam)
Public Const SUBLANG_MALAYALAM_INDIA = &H1                         ' Malayalam (India (Malayalam Script) ) = &H044c ml-IN
Public Const SUBLANG_MALTESE_MALTA = &H1                           ' Maltese (Malta) = &H043a mt-MT
Public Const SUBLANG_MAORI_NEW_ZEALAND = &H1                       ' Maori (New Zealand) = &H0481 mi-NZ
Public Const SUBLANG_MAPUDUNGUN_CHILE = &H1                        ' Mapudungun (Chile) = &H047a arn-CL
Public Const SUBLANG_MARATHI_INDIA = &H1                           ' Marathi (India) = &H044e mr-IN
Public Const SUBLANG_MOHAWK_MOHAWK = &H1                           ' Mohawk (Mohawk) = &H047c moh-CA
Public Const SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA = &H1             ' Mongolian (Cyrillic, Mongolia)
Public Const SUBLANG_MONGOLIAN_PRC = &H2                           ' Mongolian (PRC)
Public Const SUBLANG_NEPALI_INDIA = &H2                            ' Nepali (India)
Public Const SUBLANG_NEPALI_NEPAL = &H1                            ' Nepali (Nepal) = &H0461 ne-NP
Public Const SUBLANG_NORWEGIAN_BOKMAL = &H1                        ' Norwegian (Bokmal)
Public Const SUBLANG_NORWEGIAN_NYNORSK = &H2                       ' Norwegian (Nynorsk)
Public Const SUBLANG_OCCITAN_FRANCE = &H1                          ' Occitan (France) = &H0482 oc-FR
Public Const SUBLANG_ORIYA_INDIA = &H1                             ' Oriya (India (Oriya Script)) = &H0448 or-IN
Public Const SUBLANG_PASHTO_AFGHANISTAN = &H1                      ' Pashto (Afghanistan)
Public Const SUBLANG_PERSIAN_IRAN = &H1                            ' Persian (Iran) = &H0429 fa-IR
Public Const SUBLANG_POLISH_POLAND = &H1                           ' Polish (Poland) = &H0415
Public Const SUBLANG_PORTUGUESE = &H2                              ' Portuguese
Public Const SUBLANG_PORTUGUESE_BRAZILIAN = &H1                    ' Portuguese (Brazilian)
Public Const SUBLANG_PUNJABI_INDIA = &H1                           ' Punjabi (India (Gurmukhi Script)) = &H0446 pa-IN
Public Const SUBLANG_QUECHUA_BOLIVIA = &H1                         ' Quechua (Bolivia)
Public Const SUBLANG_QUECHUA_ECUADOR = &H2                         ' Quechua (Ecuador)
Public Const SUBLANG_QUECHUA_PERU = &H3                            ' Quechua (Peru)
Public Const SUBLANG_ROMANIAN_ROMANIA = &H1                        ' Romanian (Romania) = &H0418
Public Const SUBLANG_ROMANSH_SWITZERLAND = &H1                     ' Romansh (Switzerland) = &H0417 rm-CH
Public Const SUBLANG_RUSSIAN_RUSSIA = &H1                          ' Russian (Russia) = &H0419
Public Const SUBLANG_SAMI_NORTHERN_NORWAY = &H1                    ' Northern Sami (Norway)
Public Const SUBLANG_SAMI_NORTHERN_SWEDEN = &H2                    ' Northern Sami (Sweden)
Public Const SUBLANG_SAMI_NORTHERN_FINLAND = &H3                   ' Northern Sami (Finland)
Public Const SUBLANG_SAMI_LULE_NORWAY = &H4                        ' Lule Sami (Norway)
Public Const SUBLANG_SAMI_LULE_SWEDEN = &H5                        ' Lule Sami (Sweden)
Public Const SUBLANG_SAMI_SOUTHERN_NORWAY = &H6                    ' Southern Sami (Norway)
Public Const SUBLANG_SAMI_SOUTHERN_SWEDEN = &H7                    ' Southern Sami (Sweden)
Public Const SUBLANG_SAMI_SKOLT_FINLAND = &H8                      ' Skolt Sami (Finland)
Public Const SUBLANG_SAMI_INARI_FINLAND = &H9                      ' Inari Sami (Finland)
Public Const SUBLANG_SANSKRIT_INDIA = &H1                          ' Sanskrit (India) = &H044f sa-IN
Public Const SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN = &H6        ' Serbian (Bosnia and Herzegovina - Latin)
Public Const SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC = &H7     ' Serbian (Bosnia and Herzegovina - Cyrillic)
Public Const SUBLANG_SERBIAN_CROATIA = &H1                         ' Croatian (Croatia) = &H041a hr-HR
Public Const SUBLANG_SERBIAN_LATIN = &H2                           ' Serbian (Latin)
Public Const SUBLANG_SERBIAN_CYRILLIC = &H3                        ' Serbian (Cyrillic)
Public Const SUBLANG_SINDHI_INDIA = &H1                            ' Sindhi (India) reserved = &H0459
Public Const SUBLANG_SINDHI_PAKISTAN = &H2                         ' Sindhi (Pakistan) reserved = &H0859
Public Const SUBLANG_SINDHI_AFGHANISTAN = &H2                      ' For app compatibility only
Public Const SUBLANG_SINHALESE_SRI_LANKA = &H1                     ' Sinhalese (Sri Lanka)
Public Const SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA = &H1             ' Northern Sotho (South Africa)
Public Const SUBLANG_SLOVAK_SLOVAKIA = &H1                         ' Slovak (Slovakia) = &H041b sk-SK
Public Const SUBLANG_SLOVENIAN_SLOVENIA = &H1                      ' Slovenian (Slovenia) = &H0424 sl-SI
Public Const SUBLANG_SPANISH = &H1                                 ' Spanish (Castilian)
Public Const SUBLANG_SPANISH_MEXICAN = &H2                         ' Spanish (Mexican)
Public Const SUBLANG_SPANISH_MODERN = &H3                          ' Spanish (Modern)
Public Const SUBLANG_SPANISH_GUATEMALA = &H4                       ' Spanish (Guatemala)
Public Const SUBLANG_SPANISH_COSTA_RICA = &H5                      ' Spanish (Costa Rica)
Public Const SUBLANG_SPANISH_PANAMA = &H6                          ' Spanish (Panama)
Public Const SUBLANG_SPANISH_DOMINICAN_REPUBLIC = &H7              ' Spanish (Dominican Republic)
Public Const SUBLANG_SPANISH_VENEZUELA = &H8                       ' Spanish (Venezuela)
Public Const SUBLANG_SPANISH_COLOMBIA = &H9                        ' Spanish (Colombia)
Public Const SUBLANG_SPANISH_PERU = &HA                            ' Spanish (Peru)
Public Const SUBLANG_SPANISH_ARGENTINA = &HB                       ' Spanish (Argentina)
Public Const SUBLANG_SPANISH_ECUADOR = &HC                         ' Spanish (Ecuador)
Public Const SUBLANG_SPANISH_CHILE = &HD                           ' Spanish (Chile)
Public Const SUBLANG_SPANISH_URUGUAY = &HE                         ' Spanish (Uruguay)
Public Const SUBLANG_SPANISH_PARAGUAY = &HF                        ' Spanish (Paraguay)
Public Const SUBLANG_SPANISH_BOLIVIA = &H10                        ' Spanish (Bolivia)
Public Const SUBLANG_SPANISH_EL_SALVADOR = &H11                    ' Spanish (El Salvador)
Public Const SUBLANG_SPANISH_HONDURAS = &H12                       ' Spanish (Honduras)
Public Const SUBLANG_SPANISH_NICARAGUA = &H13                      ' Spanish (Nicaragua)
Public Const SUBLANG_SPANISH_PUERTO_RICO = &H14                    ' Spanish (Puerto Rico)
Public Const SUBLANG_SPANISH_US = &H15                             ' Spanish (United States)
Public Const SUBLANG_SWAHILI_KENYA = &H1                           ' Swahili (Kenya) = &H0441 sw-KE
Public Const SUBLANG_SWEDISH = &H1                                 ' Swedish
Public Const SUBLANG_SWEDISH_FINLAND = &H2                         ' Swedish (Finland)
Public Const SUBLANG_SYRIAC_SYRIA = &H1                            ' Syriac (Syria) = &H045a syr-SY
Public Const SUBLANG_TAJIK_TAJIKISTAN = &H1                        ' Tajik (Tajikistan) = &H0428 tg-TJ-Cyrl
Public Const SUBLANG_TAMAZIGHT_ALGERIA_LATIN = &H2                 ' Tamazight (Latin, Algeria) = &H085f tmz-DZ-Latn
Public Const SUBLANG_TAMIL_INDIA = &H1                             ' Tamil (India)
Public Const SUBLANG_TATAR_RUSSIA = &H1                            ' Tatar (Russia) = &H0444 tt-RU
Public Const SUBLANG_TELUGU_INDIA = &H1                            ' Telugu (India (Telugu Script)) = &H044a te-IN
Public Const SUBLANG_THAI_THAILAND = &H1                           ' Thai (Thailand) = &H041e th-TH
Public Const SUBLANG_TIBETAN_PRC = &H1                             ' Tibetan (PRC)
Public Const SUBLANG_TIGRIGNA_ERITREA = &H2                        ' Tigrigna (Eritrea)
Public Const SUBLANG_TSWANA_SOUTH_AFRICA = &H1                     ' Setswana / Tswana (South Africa) = &H0432 tn-ZA
Public Const SUBLANG_TURKISH_TURKEY = &H1                          ' Turkish (Turkey) = &H041f tr-TR
Public Const SUBLANG_TURKMEN_TURKMENISTAN = &H1                    ' Turkmen (Turkmenistan) = &H0442 tk-TM
Public Const SUBLANG_UIGHUR_PRC = &H1                              ' Uighur (PRC) = &H0480 ug-CN
Public Const SUBLANG_UKRAINIAN_UKRAINE = &H1                       ' Ukrainian (Ukraine) = &H0422 uk-UA
Public Const SUBLANG_UPPER_SORBIAN_GERMANY = &H1                   ' Upper Sorbian (Germany) = &H042e wen-DE
Public Const SUBLANG_URDU_PAKISTAN = &H1                           ' Urdu (Pakistan)
Public Const SUBLANG_URDU_INDIA = &H2                              ' Urdu (India)
Public Const SUBLANG_UZBEK_LATIN = &H1                             ' Uzbek (Latin)
Public Const SUBLANG_UZBEK_CYRILLIC = &H2                          ' Uzbek (Cyrillic)
Public Const SUBLANG_VIETNAMESE_VIETNAM = &H1                      ' Vietnamese (Vietnam) = &H042a vi-VN
Public Const SUBLANG_WELSH_UNITED_KINGDOM = &H1                    ' Welsh (United Kingdom) = &H0452 cy-GB
Public Const SUBLANG_WOLOF_SENEGAL = &H1                           ' Wolof (Senegal)
Public Const SUBLANG_XHOSA_SOUTH_AFRICA = &H1                      ' isiXhosa / Xhosa (South Africa) = &H0434 xh-ZA
Public Const SUBLANG_YAKUT_RUSSIA = &H1                            ' Yakut (Russia) = &H0485 sah-RU
Public Const SUBLANG_YI_PRC = &H1                                  ' Yi (PRC)) = &H0478
Public Const SUBLANG_YORUBA_NIGERIA = &H1                          ' Yoruba (Nigeria) 046a yo-NG
Public Const SUBLANG_ZULU_SOUTH_AFRICA = &H1                       ' isiZulu / Zulu (South Africa) = &H0435 zu-ZA


'
'  A language ID is a 16 bit value which is the combination of a
'  primary language ID and a secondary language ID.  The bits are
'  allocated as follows:
'
'       +-----------------------+-------------------------+
'       |     Sublanguage ID    |   Primary Language ID   |
'       +-----------------------+-------------------------+
'        15                   10 9                       0   bit
'


'Neutral language

Public Const LANG_SUBLANG_NEUTRAL = &H0


Public Enum NeoSpeechVoiceTextAudioFormat

    VT_FILE_API_FMT_S16PCM = 0
    VT_FILE_API_FMT_ALAW = 1
    VT_FILE_API_FMT_MULAW = 2
    VT_FILE_API_FMT_DADPCM = 3
    VT_FILE_API_FMT_S16PCM_WAVE = 4
    VT_FILE_API_FMT_U08PCM_WAVE = 5
    VT_FILE_API_FMT_IMA_WAVE = 6
    VT_FILE_API_FMT_ALAW_WAVE = 7
    VT_FILE_API_FMT_MULAW_WAVE = 8
    VT_FILE_API_FMT_MULAW_AU = 9
    
End Enum

'Export formats for Cepstral voices

    'You need to set the following instead:

    'szAudioEncoding [possible values: _
        * "riff": Microsoft RIFF (WAV) file _
        * "pcm16", "pcm8" PCM 16 bit/8 bit WAV _
        * "ulaw" - -Law (8-bit by definition), "alaw" - A-Law (8-bit by definition) _
        * "snd": Sun/NeXT .au (SND) format. _
        * "raw": unheadered audio data, native byte order _
        * "le": unheadered audio data, little-endian (LSB first) _
        * "be": unheadered audio data, big-endian (MSB first) _
        * NOTE: that not all encoding types may be supported by all formats. For instance, SND doesn't support A-Law. ], _
 _
    iAudioSamplingRate [possible values: 8000 (8 KHz), 16000 (16 KHz), 11025 (11.025 kHz), etc ], _
 _
    iAudioChannels [possible values: 1 (mono), 2 (stereo)]
    
'Export formats for AT&T NV (INTERNAL USE ONLY) _
Currently only PCM WAV supported  (all audio format arguments will be ignored)




Public Enum NeoSpeechVoiceID

     NEOSPEECH_KATE_ENG = 0

     NEOSPEECH_PAUL_ENG = 1


     NEOSPEECH_MIYU_JPN = 0

     NEOSPEECH_SHOW_JPN = 1

     NEOSPEECH_MISAKI_JPN = 2


     NEOSPEECH_LILY_CHI = 0

     NEOSPEECH_WANG_CHI = 1


     NEOSPEECH_JUNWOO_KOR = 3

     NEOSPEECH_SUJIN_KOR = 8

     NEOSPEECH_YUMI_KOR = 10

     NEOSPEECH_GYURI_KOR = 11

     NEOSPEECH_DAYOUNG_KOR = 12
    
End Enum



Public Const NEOSPEECH_KATE_ENG_NAMESTR As String = "Kate"

Public Const NEOSPEECH_PAUL_ENG_NAMESTR As String = "Paul"


Public Const NEOSPEECH_MIYU_JPN_NAMESTR As String = "Miyu"

Public Const NEOSPEECH_SHOW_JPN_NAMESTR As String = "Show"

Public Const NEOSPEECH_MISAKI_JPN_NAMESTR As String = "Misaki"


Public Const NEOSPEECH_LILY_CHI_NAMESTR As String = "Lily"

Public Const NEOSPEECH_WANG_CHI_NAMESTR As String = "Wang"


Public Const NEOSPEECH_JUNWOO_KOR_NAMESTR As String = "Junwoo"

Public Const NEOSPEECH_SUJIN_KOR_NAMESTR As String = "Sujin"

Public Const NEOSPEECH_YUMI_KOR_NAMESTR As String = "Yumi"

Public Const NEOSPEECH_GYURI_KOR_NAMESTR As String = "Gyuri"

Public Const NEOSPEECH_DAYOUNG_KOR_NAMESTR As String = "Dayoung"

Public Const sFileName As String = "test.wav"




